package jsadppac.ascfmt;

import java.io.File;

public class SaraAscFileSimulatorSample {

	public static void main(String[] args) throws Exception{
		// Input file is specified.
		String input="/Users/futaana/SARA/sample/compression2_sci.dat";
		File inputFile=new File(input);
		
		// Output file can be specified.
		File outputFile=new File("./outputSim.dat");
		
		// Instance the simulator.  The files are opened.
		SaraAscFileSimulator sim=new SaraAscFileSimulator(inputFile, outputFile);

		// If output file is not specified, the stdout will be the output.
//		SaraAscFileSimulator sim=new SaraAscFileSimulator(inputFile);

		// If you want to control the delay between packet,
//		sim.setWaitPacket(1000);
		
		// If you want to use a delay between lines (for simulating slow transfer).
//		sim.setWaitLine(5);   // Every 5 msec
		
		// Start the simulator.  Reading from input file, and
		// write to output file with 250msec interval.
		sim.start();
		
		// This is just for testing purpose, so just wait 30 sec.
		try {
			Thread.sleep(30*1000);  // Wait 30 sec
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		// To stop the simulator, you call stop() method.
		sim.stop();
		
		// Close the files to release the file.
		sim.close();
		
	}
	
}
