package jsadppac.sarapac;

import sadppac.SaraAscFile;

public class JSaraDemultiplexorSample {

	static{
		System.loadLibrary("sadppacjava");
	}
	
	public JSaraDemultiplexorSample(String filename) {
		
		SaraAscFile file=new SaraAscFile(filename);
		
		JSaraDemultiplexor demul=new JSaraDemultiplexor();
		demul.addCenaPacketListener(new CenaPacketArrivalListener(){
			public void cenaPacketArrived(CenaPacketArrivalEvent cenaEvent) {
				System.out.println("CENA packet arrived: "+cenaEvent.getPacket().get4sCycleCntr());
			}});
		demul.addSwimPacketListener(new SwimPacketArrivalListener(){
			public void swimPacketArrived(SwimPacketArrivalEvent swimEvent) {
				System.out.println("SWIM packet arrived: "+swimEvent.getPacket().get8sCycleCntr());
			}});
		
		demul.startDemultiplex(file, 0);
		
	}
	
	
	public static void main(String[] args) {
		if(args.length < 1){
			System.err.println("USAGE:   java   JSaraDemultiplexorSample    filename");
			System.exit(-1);
		}
		new JSaraDemultiplexorSample(args[0]);
	}
}
