package sadppactest;

import sadppac.*;

public class DemulTest {

    static{
	System.loadLibrary("sadppacjava");
    }

    public DemulTest(String filename){
	System.out.println(filename);

	// Instance the SaraAscFile
	SaraAscFile asc = new SaraAscFile(filename);

	if(!asc.openStream()){
	    throw new RuntimeException("Failed to open file "+filename+".");
	}

	// Instance the demultiplexor
	SaraBufferedDemultiplexor demul=new SaraBufferedDemultiplexor();
	

	System.out.println("STOP COUNTER: "+CenaAccumSclMatx.STOP_COUNTER);

	int iSara=0;
	while( ! asc.eof() ){
	    System.out.println(iSara);
	    SaraPacket saraPac = asc.getSaraPacket();

	    if(saraPac != null){

		demul.appendSaraPacket(saraPac);

		//		System.out.println("- CENA Buffer "+demul.getNrCena());
		//		System.out.println("- SWIM Buffer "+demul.getNrSwim());

		CenaPacket cPac = demul.getCena();
		if(cPac != null){
		    cPac.dumpAll();
		    System.out.println("Accum[0][0][0]: "+cPac.getAccumSclMatx().getRaw(0,0,0));
		}

		SwimPacket sPac = demul.getSwim();
		if(sPac != null){
		    sPac.dumpAll();
		}

	    }


	    iSara++;
	}


    }

    public static void main(String[] argv){
	String filename="/Users/futaana/Documents/XCode/libsadppac/sample/compression2_sci.dat";

	if(argv.length > 0){
	    filename = argv[0];
	}

	new DemulTest(filename);
    }



}

