import Sadppac
import sys
from Sadppac import *

def pyDemultiplex(filename, verbose=False):

	if verbose:
		print >> sys.stderr, "Demultiplex", filename

	asc=SaraAscFile(filename)

	if not asc.openStream():
		print "Failed to open file "+filename
		return None,None

	demul = SaraBufferedDemultiplexor()

	iSara=0

	cenaPacketArray=[]
	swimPacketArray=[]

	while not asc.eof():
		if verbose:
			print >> sys.stderr, "SaraPacket: ", iSara
		saraPac = asc.getSaraPacket()
		iSara=iSara+1;
		
		if saraPac != None:
			demul.appendSaraPacket(saraPac);
			sPac = demul.getSwim();
			if sPac != None:
				if verbose:
					print >> sys.stderr, "SWIM",
					print >> sys.stderr, sPac.getUniversalTimeInMsec();
				swimPacketArray.append(sPac)
			cPac = demul.getCena();
			if cPac != None:
				if verbose:
					print >> sys.stderr, "CENA",
					print >> sys.stderr, cPac.getUniversalTimeInMsec();
				cenaPacketArray.append(cPac)

	return cenaPacketArray,swimPacketArray

if __name__ == "__main__":
	if len(sys.argv) > 1:
		filename=sys.argv[1];
		cena, swim=pyDemultiplex(filename, verbose=True)
		print "Nr. of CENA packets = ", len(cena)
		print "Nr. of SWIM packets = ", len(swim)
	else:
		print >> sys.stderr, "USAGE:   python   ", sys.argv[0], "   data_sci.dat" 



