"""
This is a sample file to plot energy-mass matrix during the SWIM commissioning.
"""
import sys
import time
import calendar

from pylab import *
import matplotlib.pyplot as plt

import Sadppac
import pyDemultiplex

filename="../../../data_p/SRA01D18CH100735003709008163859809_sci.dat"
epoch = calendar.timegm( (2008,12,23,23,57,3) )

def ene32():
	ene=[10**(2+(log10(3000)-log10(100))/32.*i)     for i in range(33)]
	return ene


def mplSwimEM(swim=[]):
	if len(swim) ==0 :
		cena,swim=pyDemultiplex.pyDemultiplex(filename)

	id0=1290
	id1=1327

	t0=time.gmtime(swim[id0].getUniversalTimeInMsec()/1000.+epoch)
	t1=time.gmtime(swim[id1].getUniversalTimeInMsec()/1000.+epoch)

	print t0, t1

	#### Energy-Mass matrix: D should be collpased.
	ne=swim[id0].getEnergyBins()
	nd=swim[id0].getDeflectionBins()
	nm=swim[id0].getMassBins()
	print "Ne, Nm=", ne, nm

	#### Matrix initialized
	emmat = zeros((ne+1, nm+1))

	for id in range(id0,id1+1):
		sw=swim[id].decompress();
		s=sw.getSwimSciAcc()  # Science accumulation matrix
		for ie in range(ne):
			for id in range(nd):
				for im in range(nm):
					emmat[ie,im] += s.get(ie,id,im)
	emmat = emmat / (id1-id0+1)

	x=arange(33)   # Mass channel
	y=ene32()     # Energy

	X,Y=meshgrid(x,y)

	fig=figure()
	ax=fig.add_subplot(111)

	pc=ax.pcolor(X, Y, emmat)

#	im=ax.imshow(emmat, interpolation='nearest', origin='lower')

	ax.set_xlabel('Mass channel')
	ax.set_ylabel('Energy [eV] (non-cal)')

	ax.set_yscale('log')
	ax.set_xlim(-0.5,32.5)
	ax.set_ylim(95,3200)

	ax.set_title("Energy mass matrix ("+time.strftime("%H:%M:%S", t0)+" til "+time.strftime("%H:%M:%S", t1)+")")

	fig.colorbar(pc)

	fig.show()
	fig.canvas.draw()


	return swim

	
if __name__ == "__main__":
	mplSwimEM();


