import os,sys,logging
import time
from Sadppac import *
import timeit
from pylab import *
import random

def anal_by_iteration(cenaArray):
  '''
  This method uses get method.
  '''
  t0=time.time()
  size=cenaArray.size()           # The total number of the CenaPacket in CenaArray.
  r=int(random.random()*size)     # The index of the packet to be analyzed.
  packet=cenaArray.getPacket(r)   # Get the CenaPacket here.
  packet=packet.decompress()      # Decompression.
  matrix=packet.getCenaSciMassAcc()   # Get the CenaScience matrix of Mass mode.

  ne=matrix.getNrEne()
  np=matrix.getNrPhase()
  nc=matrix.getNrCh()
  nm=matrix.getNrMass()

  tot=0

  for ie in range(ne):
    for ip in range(np):
      for ic in range(nc):
        for im in range(nm):
          tot = tot + matrix.get(ie, ip, ic, im)

  print r, tot, time.time()-t0

def anal_by_array(cenaArray):
  '''
  This method uses asArray method.
  '''
  t0=time.time()
  size=cenaArray.size()           # The total number of the CenaPacket in CenaArray.
  r=int(random.random()*size)     # The index of the packet to be analyzed.
  packet=cenaArray.getPacket(r)   # Get the CenaPacket here.
  packet=packet.decompress()      # Decompression.
  matrix=packet.getCenaSciMassAcc()   # Get the CenaScience matrix of Mass mode.

  ne=matrix.getNrEne()
  np=matrix.getNrPhase()
  nc=matrix.getNrCh()
  nci=matrix.getNrChIntr()
  nm=matrix.getNrMass()

  mat=array(matrix.getCountAsArray())
  mat.shape=[ne,np,nci,nm]
  mat=mat[:,:,0:nc-1,:]
  tot=mat.sum()

  print r, tot, time.time()-t0


if __name__ == '__main__':

  if len(sys.argv) !=3:
    print 'USAGE:   %s   -a|-i   bmu.cena'
    sys.exit(1)
  logging.basicConfig(level=logging.DEBUG)
  c=CenaBmuReader()
  c.readFile(sys.argv[2])
  arr=c.getArray()

  t0=time.time()
  for i in range(1000):
     if sys.argv[1]=='-i':
       anal_by_iteration(arr)
     elif sys.argv[1]=='-a':
       anal_by_array(arr)
     else:
       print 'USAGE:   %s   -a|-i   bmu.cena'
       sys.exit(-1)
  print time.time()-t0
