/*
 *  ByteSpectrum.h
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/10/05.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __IRFPAC_BYTESPECTRUM
#define __IRFPAC_BYTESPECTRUM

#include<iostream>
#include <inttypes.h>

/**	@file ByteSpectrum.h
	@brief Utitilty to check the spectrum of byte stream.
*/

namespace IrfPac{

/** @brief Returns the spectrum of the byte array.

	Returns pointer to 256-elements array.  Each array corresponds to the
	number how often the index appeared in the stream.
	
	The returned pointer should be deleted.
	
	For example, the byte array 0x00010002 returns the 256-elements array
	which constitute of {2,1,1,0,0,0,.....}.
	This function is intended to use the shape of the bytestream is
	similar or not.  It is also useful for feeling the compression is
	effective or not.  Normally if the compression is effective, the
	spectrum approaches flat.
*/

uint16_t* byteSpectrum(uint8_t *stream, size_t number_of_stream);



}

#endif
