/**
 *  @file AscFmtReader_sample.cpp
 *
 *  A sample of SaraAscFile usage.
 *  %  AscFmtReader_sample  filename
 *
 *
 *  Created by Futaana Yoshifumi on 07/07/19.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include <iostream>
#include <cstdlib>
#include "AscFmtReader_sample.h"

using namespace std;
using namespace IrfPac::SaraPac;
using namespace IrfPac::SaraPac::AscFmt;

int main(int argc, char** argv){

	cout << "AscFmtReader_sample" << endl;

	if(argc == 1){
		cerr << "USAGE:    " << argv[0] << "   filename" << endl;
		exit(-1);
	}

#if 0
       	FILE* fp=fopen(argv[1], "r");

	char buff[2048];
	while(feof(fp) == 0 ){
		fgets(buff, 2047, fp);
		cout << buff << endl;
	}
#endif


	/*
	  Declare the SARA data file in ASCII format.
	 */
	SaraAscFile* asc=new SaraAscFile(argv[1]);
	int i=0;
	int iNull=0;

	if(asc->openStream()){
		while(! asc->eof() ){ 
			SaraPacket* saraPac = asc->getSaraPacket();
			if(saraPac != NULL){
				cout << "SARA PAC ARRIVED: " << i << endl;
				
				saraPac->dumpHexStream(stdout);
				
				delete saraPac;
				i++;
			}
			else{
				cout << "SARA PAC NULL: " << iNull << endl;
				iNull++;
			}
		}
	}
	else{
		cerr << "Failed to open " << argv[1] << endl;
		exit(-2);
	}

	asc->closeStream();


	return 0;
}

