/*
 *  CenaPacketDump_sample.cpp
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/09/12.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

/** @file CenaPacketDump_sample.cpp
	@brief A sample code (and hacking tool) for CENA demultiplex from DPU output ASCII format.
	
*/

#include<iostream>
#include <cstdlib>
using namespace std;

#include<IrfPac/irfpac.h>
#include<IrfPac/SaraPac/sarapac.h>
#include<IrfPac/SaraPac/AscFmt/ascfmt.h>
using namespace IrfPac;
using namespace IrfPac::SaraPac;
using namespace IrfPac::SaraPac::AscFmt;

int main(int argc, char** argv){

	if(argc==1){
		cerr << "USAGE:	" << argv[0] << "	filename" << endl;
		exit(-1);
	}
	
	SaraAscFile* asc=new SaraAscFile(argv[1]);  // Input file

	SaraDemultiplexor* demul=new SaraDemultiplexor();
	CenaPacket* cenaPac=NULL;

	if(asc->openStream()){
		while(! asc->eof() ){
			SaraPacket* saraPac = asc->getSaraPacket();

			if(saraPac!=NULL){
				
				if(!demul->sequenceCheck(saraPac)){
					cerr << "*** SEQUENCIAL CHECK NG:  FLUSH BUFFER ***" << endl;
					demul->flushAll();
				}
				
				cenaPac = demul->appendCena(saraPac);
				
				if(cenaPac != NULL){
					cenaPac->dumpHexStream(stdout);
					cout << endl;
				}
				
				delete cenaPac;
			}
			delete saraPac;

		}
		asc->closeStream();
	}

}
