#include<iostream>
#include<cstdlib>
#include<cmath>

#include<IrfPac/irfpac.h>
#include<IrfPac/SaraPac/sarapac.h>
#include<IrfPac/SaraPac/AscFmt/ascfmt.h>

using namespace std;
using namespace IrfPac;
using namespace IrfPac::SaraPac;
using namespace IrfPac::SaraPac::AscFmt;


int main(int argc, char** argv){

	if(argc<2){
		fprintf(stdout, "USAGE:  %s   SRA_xxxxx_xxxx_xxxx.cena\n", argv[0]);
		exit(-10);
	}

	CenaBmuReader sr;
	sr.readFile(argv[1]);

	CenaPacketArray* cpac=sr.getArray();

	fprintf(stdout, "Index Counter        Marker@OBT       Marker@DPU         Data@DPU         Data@OBT         Data@UTC                  Data@UTC  Flg\n");

	for(size_t i=0; i<cpac->size(); i++){
		CenaPacket* cp = cpac->getPacket(i);
		fprintf(stdout, "%5d   ", (int)i);  // Index
		fprintf(stdout, "%5x   ", cp->get4sCycleCntr());  // Counter
		fprintf(stdout, "%15.3f  ", cp->getMarkerObt());
		fprintf(stdout, "%15.3f  ", cp->getMarkerDpu());
		fprintf(stdout, "%15.3f  ", cp->getObsTimeDpu());
		fprintf(stdout, "%15.3f  ", cp->getObsTimeObt());
//		fprintf(stdout, "%15.3f  ", cp->getUniversalTime(NULL)*1000);
		fprintf(stdout, "%15.3f  ", cp->getUtc());
		fprintf(stdout, "%s ", epoch2str(cp->getUtc()).c_str());
		fprintf(stdout, "%2d ", cp->getQualityFlag());

		fprintf(stdout, "\n");
	}



}

