/*
 *  SaraAscFile.cpp
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/07/19.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */
#include "IrfPac/SaraPac/AscFmt/SaraAscFile.h"

#include<sys/types.h>
#include<sys/stat.h>
#include<sys/time.h>
#include<fcntl.h>
#include<unistd.h>


namespace IrfPac{
namespace SaraPac{
namespace AscFmt{

	bool SaraAscFile::openStream(){
			_fd=open(_filename, O_RDONLY);

//			_fp=fopen(_filename, "r");
			if(_fd==-1) return false;
			return true;
		}
		
	bool SaraAscFile::closeStream(){
//			if(_fp!=NULL) fclose(_fp);

			if(_fd!=-1) close(_fd);
			_fd=-1;
			return true;
	}

	SaraPacket* SaraAscFile::getSaraPacket(){
	
//		fprintf(stderr, "Get SARA Packet started\n");
		if(_fd==-1){
			fprintf(stderr, "File stream not opened.\n");
			return NULL;
		}
		
		
		int len;
		while(absense <= max_absense){
			fd_set rfds;
			
			FD_ZERO(&rfds);
			FD_SET(_fd, &rfds);
			
			struct timeval tv;  // 3second  .. I dont know why but time out does not work.
			tv.tv_sec=3;
			tv.tv_usec=0*1000;
			
//			int n=select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
			select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
			
//			printf("select=%d\n", n);
			
			if(FD_ISSET(_fd, &rfds)){
				len=read(_fd, &buffer[current_buffer], remain_buffer);
#ifdef DEBUG
				printf("len=%d\n", len);
#endif
				if(len>0){
					absense=0;
				
					total += len;
					current_buffer += len;
					remain_buffer -= len;					
					
					// For debugging...
#ifdef DEBUG
					printf("Read finished.\n");
					showBuffer();
					for(int i=pointer_buffer; i<current_buffer; i++){
						printf("%c", buffer[i]);
					}
					printf("\n---\n");
#endif
					
					// Read line
					char buf[BUFFER_SIZE+1];
					
					int nbuf=readLine(buf);					
#ifdef DEBUG
					printf("Read line.  %d chars.\n", nbuf);
					printf("<LINE size=%d>\n%s\n</LINE>\n", (int)strlen(buf), buf);
#endif					
					while(nbuf>=0){   // If the line is existing...
						
						// Processing
						
						if(cur_pos==-1){    // Resync to start
							if(strncmp(buf, "********", 8)==0){   // Next line is the start
								cur_pos=0;
#ifdef DEBUG
								printf("### START OF DATA\n");
#endif
							}
							else{
#ifdef DEBUG
								printf("### SKIPPING (CURPOS=-1 but NOT START PACKET)\t%s\n", buf);
#endif
							}
						}
						else{              // Data is coming
							if(strlen(buf)==0){  // No data included
#ifdef DEBUG
								printf("### SKIPPING (CURPOS!=-1 but NO DATA INCLUDED)\t%s\n", buf);
#endif
							}
							else if(strncmp(buf, "********", 8)==0){  // In case of header
#ifdef DEBUG
								printf("### SKIPPING (CURPOS!=-1 and HEADER FOUND)\t%s\n", buf);
#endif
								cur_pos=0;
							}
							else {
#ifdef DEBUG
								printf("### CONTINUEING DATA\t%s\n", buf);
#endif
			
							
								int a[16];
								int i;
								sscanf(buf, "%04x %04x %04x %04x %04x %04x %04x %04x %04x %04x %04x %04x %04x %04x %04x %04x",
								   	a, a+1, a+2, a+3, a+4, a+5, a+6, a+7, 
								   	a+8, a+9, a+10, a+11, a+12, a+13, a+14, a+15);
							
#ifdef DEBUG
								for(i=0; i<16; i++){
									printf("%04x ", a[i]);
								}
								printf("\n");
#endif
							
								for(i=0; i<16; i++){
									packet[cur_pos]=(a[i] & 0xff00)>>8;
									packet[cur_pos+1]=(a[i] & 0x00ff);
									cur_pos+=2;
								}
							
								if(cur_pos==896){
									cur_pos=-1;
#ifdef DEBUG
									printf("SARAPAC:CREATION\n");
#endif
									SaraPacket* sPac=new SaraPacket(packet);
	//								sPac->dumpAll();
									return sPac;
								}
							}
							
							
						}
						nbuf=readLine(buf);
#ifdef DEBUG
						printf("Read line.  %d chars.\n", nbuf);
						printf("<LINE size=%d>\n%s\n</LINE>\n", (int)strlen(buf), buf);
						showBuffer();
#endif

					}
				}
				else{   // data length == 0.  Wait for another data.
					usleep(100*1000);
					absense++;

#ifdef DEBUG
					printf("zzz (%d)\n", absense);
#endif
				}
				
			}
			
//			usleep(100*1000);   // This is a weight between segmentation.  Normally it is not used.
//			printf("z\n");
			
		}
		
		fprintf(stderr, "End of file\n");
		return NULL;
	}
	
	
}}}// Namespace

