/*
 *  SaraBufferedDemultiplexor.cpp
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/10/23.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include<iostream>
#include <cstdlib>
#include<IrfPac/irfpac.h>
#include<IrfPac/SaraPac/sarapac.h>
#include<IrfPac/SaraPac/AscFmt/ascfmt.h>

#include<time.h>

using namespace std;
using namespace IrfPac;
using namespace IrfPac::SaraPac;
using namespace IrfPac::SaraPac::AscFmt;

int main(int argc, char** argv){

	cout << "This is a sample file of using SaraBufferedDemultiplexor class" << endl;
	
	if(argc==1){
		cerr << "USAGE:  " << argv[0] << "  filename" << endl;
		exit(-1);
	}

	SaraAscFile *asc = new SaraAscFile(argv[1]);  // Specify a new input file.
	
	SaraBufferedDemultiplexor* demul=new SaraBufferedDemultiplexor();
	
//	int i=0, iCena=0, iSwim=0;
	int i=0;
	
	if(asc->openStream()){  // Open the input file
		while(! asc->eof() ){  // When the input file is not end of file.
			SaraPacket* saraPac = asc->getSaraPacket();  // Obtain SaraPacket from the input file
			
			if(saraPac != NULL){  // Do the followings the obtained packet is not NULL
				cout << "---" << endl;
				fprintf(stdout, "SARA PAC ARRIVED: %d : %04x : %d\n", i, saraPac->getPacketId(), saraPac->getCounter());
			
				demul->appendSaraPacket(saraPac);

				fprintf(stdout, " - CENA Buffered Packet = %d\n", demul->getNrCena());
				fprintf(stdout, " - SWIM Buffered Packet = %d\n", demul->getNrSwim());

				time_t t=time(NULL);
				
				if(demul->getNrCena() > 3 && demul->getNrCena() > t%15 ){ // If some conditions are satisfied, show the latest one.
					cout << "Checkout only the latest CenaPacket" << endl;
					CenaPacket* cena=demul->getLatestCena();
					cout << "CENA ?" << cena->getHeadMagicNumber() << endl;
					/////////////////////////////////////////////
					//  HERE YOU CAN PUT CENA PACKET PROCESSING.
					/////////////////////////////////////////////
					cout << "CENA PACKET ARRIVED:" << cena->get4sCycleCntr() << endl;
					delete cena;
				}
				else{
					cout << "Just keep the CENApacket in buffer" << endl;
				}
				
				if(demul->getNrSwim() > 10 && demul->getNrSwim() > t%30){
					SwimPacket* swim=demul->getLatestSwim();				
					/////////////////////////////////////////////
					//  HERE YOU CAN PUT SWIM PACKET PROCESSING.
					/////////////////////////////////////////////			
			
					cout << "SWIM PACKET ARRIVED " << swim->get8sCycleCntr()  << endl;
					delete swim;
				}
				else{
					cout << "Just keep the SWIMpacket in buffer" << endl;
				}

				fprintf(stdout, " - CENA Buffered Packet = %d\n", demul->getNrCena());
				fprintf(stdout, " - SWIM Buffered Packet = %d\n", demul->getNrSwim());



			}
			
			delete saraPac;
			
			cout << "Press ENTER to proceed to the next SaraPacket" << endl;
	//		getchar();
//			usleep(100000);
		}	
	}
	else{  // Opening the input file failed.
		cerr << "Failed to open " << argv[1] << endl;
		exit(-2);
	}

	delete asc;
	delete demul;

	return 0;
}
