/*
 *  SaraSpacePac2Bmu.cpp
 *  libsadppac
 *
 *  Created by futaana on 08/03/28.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include<iostream>
#include<ctime>
#include "IrfPac/SaraPac/AscFmt/SaraSpacePac2Bmu.h"
#include <inttypes.h>
#include <stdio.h>

using namespace std;

namespace IrfPac {
namespace SaraPac {
namespace AscFmt {

std::string SaraSpacePac2Bmu::spacepac2bmu(uint8_t* spacepac){

	uint16_t packetid = spacepac[0];
	packetid <<= 8;
	packetid |= spacepac[1];

	uint16_t verNr = (packetid >> 13)&0x7;
	uint16_t type = (packetid >> 12)&0x1;
	uint16_t secHdr = (packetid >> 11)&0x1;
	uint16_t apid = (packetid)&0x07ff;

	uint16_t packetSeq = spacepac[2];
	packetSeq <<= 8;
	packetSeq |= spacepac[3];
	uint16_t segFlag = (packetSeq >> 14)&0x3;
	uint16_t seqCont = (packetSeq) & 0x3fff;

	uint16_t packetLen = spacepac[4];
	packetLen <<= 8;
	packetLen |= spacepac[5];


#ifdef DEBUG
	fprintf(stderr, "space0,1: %02x %02x %04x\n", spacepac[0], spacepac[1], packetid);
	fprintf(stderr, "\tVerNo:Type:SeqHdr:APID:  %04x %04x %04x %04x\n", verNr, type, secHdr, apid);
	fprintf(stderr, "space2,3: %02x %02x %04x\n", spacepac[2], spacepac[3], packetSeq);
	fprintf(stderr, "\tsegFlag:seqCont: %04x %04x\n", segFlag, seqCont);
	fprintf(stderr, "space4,5: %02x %02x %04x\n", spacepac[4], spacepac[5], packetLen);
#endif

	if(detailedCheck){

		if(verNr!=0){
			fprintf(stderr, "Illegal version number 0x%x (should be 0).  Exception thrown.\n", verNr);
			throw verNr;
		}
		
		if(type !=0){
			fprintf(stderr, "Illegal Type 0x%x (should be 0).  Exception thrown.\n", type);
			throw type;
		}

		if(secHdr !=0){
			fprintf(stderr, "Illegal SecHdr 0x%x (should be 0).  Exception thrown.\n", secHdr);
			throw secHdr;
		}

		if(apid != 0x25){
			fprintf(stderr, "Illegal apid 0x%x (should be 0x25).  Exception thrown.\n", apid);
			throw apid;
		}

		if(segFlag != 0x3){
			fprintf(stderr, "Illegal Seg Flag 0x%x (should be 0x3).  Exception thrown.\n", segFlag);
			throw apid;
		}

		/* Because I'm confusing the packet size, this test is commented out.  2008/07/17 */
#if 0
		if(packetLen != 0x037f){   // Sorry for using magic number...
			fprintf(stderr, "Packet length violation 0x%x (should be 0x037f).  Exception thrown.\n", packetLen);
			throw 0x037f;
		}
#endif	
	
		if(!isFirstPacket){
			uint16_t newCntr=counter+1;
			if(newCntr == 0x4000)newCntr=0;   // Cyclic.
			
//			cout << counter << " -> " << newCntr << endl;
			
			if(newCntr != seqCont){
				fprintf(stderr, "Counter violation 0x%x (should be %x).  Exception thrown.\n", seqCont, newCntr);
				resetCounter();
				throw seqCont;
			}
			counter=newCntr;
		}
		else{
			isFirstPacket=false;
			counter=seqCont;
		}
	}

	time_t nowt=time(NULL);
	struct tm *gm=gmtime(&nowt);
	char* asc=asctime(gm);

	std::string s="********SCI-DATA at Time ";
	s=s.append(asc);
	for(int i=SPACE_PAC_HEADER_SIZE; i<SPACE_PAC_SIZE; i++){
		char buf[3];
		sprintf(buf, "%02x", spacepac[i]);
		s=s.append(buf);
		if(i%2==1)s=s.append(" ");
		if((i-SPACE_PAC_HEADER_SIZE)%32==31)s=s.append("\n");
	}

#ifdef DEBUG
//	cout << s << endl;
#endif
	
	return s;
}


}}}
