
/*
 *  SaraSpacePac2BmuApp.h
 *  libsadppac
 *
 *  Created by futaana on 08/03/28.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

/**
	Read from stdin (Space pac) out to stdout (bmu format).
	Using high-level io library.  Probably, in future, one need to modify the program using low-level library like SaraAscFile.
*/

#include<stdio.h>
#include<string>
#include"IrfPac/SaraPac/AscFmt/ascfmt.h"
#include"IrfPac/SaraPac/AscFmt/SaraSpacePac2Bmu.h"

using namespace IrfPac::SaraPac::AscFmt;

int main(void){
	// Read from stdin
	
	FILE* fp = stdin;

	uint8_t buf[1000];
	
	SaraSpacePac2Bmu bmu;

	int pacsize_pre = SaraSpacePac2Bmu::SPACE_PAC_HEADER_SKIP_BYTE;
	int pacsize = SaraSpacePac2Bmu::SPACE_PAC_SIZE;
	int pacsize_post = SaraSpacePac2Bmu::SPACE_PAC_TRAIL_SKIP_BYTE;
	
	while( !feof(fp) ){
		size_t n_read = fread(buf, 1, pacsize+pacsize_pre+pacsize_post, fp);

		if( ((signed long)n_read) < pacsize+pacsize_pre+pacsize_post){
			break;
		}
		
		try{
			std::string s=bmu.spacepac2bmu(buf+pacsize_pre);
			std::cout << s << std::endl;
		}
		catch ( uint16_t err ){
			std::cerr << "Exception caught." << std::endl;
			bmu.resetCounter();
		}
	}
	


	return 0;
}
