/*
 *  SaraSpacePac2Bmu_test.cpp
 *  libsadppac
 *
 *  Created by futaana on 08/03/28.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include<iostream>
#include<cppunit/extensions/HelperMacros.h>

#include"IrfPac/irfpac.h"
#include"IrfPac/SaraPac/sarapac.h"
#include"IrfPac/SaraPac/AscFmt/ascfmt.h"

using namespace std;
using namespace IrfPac;
using namespace IrfPac::SaraPac;
using namespace IrfPac::SaraPac::AscFmt;

class SaraSpacePac2Bmu_test : public CPPUNIT_NS::TestFixture {

public:
	CPPUNIT_TEST_SUITE(SaraSpacePac2Bmu_test);
	CPPUNIT_TEST (test1);
	CPPUNIT_TEST (testcounter);
	CPPUNIT_TEST_SUITE_END();
	
	void test1();
	void testcounter();

};

void SaraSpacePac2Bmu_test::test1(){

	SaraSpacePac2Bmu bmu;
	
	uint8_t str[902];
	
	str[0] = 0x00;
	str[1] = 0x25;
	str[2] = 0xc0;
	str[3] = 0x4c;  // sequence counter 
	str[4] = 0x03;
	str[5] = 0x85;
	
	for(int i=6; i<902; i++)str[i] = (uint8_t)(i%256);

	string s=bmu.spacepac2bmu(str);
	
	std::cout << s << endl;

}

void SaraSpacePac2Bmu_test::testcounter(){

	SaraSpacePac2Bmu bmu;

	bmu.setDetailedCheckEnabled(true);

	// first packet is not a matter
	
	uint8_t str[SaraSpacePac2Bmu::SPACE_PAC_SIZE];
	
	str[0] = 0x00;
	str[1] = 0x25;
	str[2] = 0xc0;
	str[3] = 0x4c;  // sequence counter 
	str[4] = 0x03;
	str[5] = 0x85;
	
	for(int i=6; i<SaraSpacePac2Bmu::SPACE_PAC_SIZE; i++)str[i] = (uint8_t)(i%256);

	string s=bmu.spacepac2bmu(str);
		
//	std::cout << s << endl;

	// second packet should follow the sequence.
	
	str[3] = 0x4d;
	
	s=bmu.spacepac2bmu(str);
	
//	std::cout << s << endl;

	// third packet follows
	
	str[3] = 0x4e;
	
	s=bmu.spacepac2bmu(str);


	// fourth packet violates.
	
	str[3] = 0x11;
	try{
		s=bmu.spacepac2bmu(str);
		CPPUNIT_ASSERT_ASSERTION_FAIL();
	}
	catch(uint16_t e){
		cout << "Caught exception correctlly" << endl;
		bmu.resetCounter();
	}
	
	
	// fifth packet is arbitrary.
	str[2] = 0xff;
	str[3] = 0xff;
	s=bmu.spacepac2bmu(str);
	
	// sixth packet for cyclic test
	str[2] = 0xc0;
	str[3] = 0x00;
	s=bmu.spacepac2bmu(str);
	
	CPPUNIT_ASSERT_EQUAL(1,1);
}

CPPUNIT_TEST_SUITE_REGISTRATION(SaraSpacePac2Bmu_test);
