#include<iostream>
#include<cstdlib>
#include<cmath>
#include<map>

#include<IrfPac/irfpac.h>
#include<IrfPac/SaraPac/sarapac.h>
#include<IrfPac/SaraPac/AscFmt/ascfmt.h>

using namespace std;
using namespace IrfPac;
using namespace IrfPac::SaraPac;
using namespace IrfPac::SaraPac::AscFmt;

int main(int argc, char** argv){

	bool all=false;

	if(argc==1){
		fprintf(stderr, "USAGE:   %s   -a  filename.time\n", argv[0]);
		exit(-5);
	}

	if(strcmp(argv[1], "-a")==0){
		all=true;
	}

	char* fname=argv[argc-1];
	FILE* fp=fopen(fname, "rb");
	if(fp==NULL){
		fprintf(stderr, "FATAL:fine not found   %s\n", fname);
		exit(-10);
	}

	TimeFile tf;

	tf.readFile(fp);

	map<double,double>* list=tf.getObt2Utc();
	int n=list->size();

	fprintf(stdout, "LIST: n=%d (expected filesize=%d)\n", n, n*53);

	if(all)tf.showContents(stdout);
	tf.showSummary(stdout);

	return 0;
}




