/*
 *  CenaAccumSclMatx.cpp
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/06/26.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "IrfPac/SaraPac/CenaAccumSclMatx.h"
#include "linlog++.h"

namespace IrfPac{
namespace SaraPac{

/*
	Index [E,P,C] -> E*Np*Nc + P*Nc + C
*/
uint8_t CenaAccumSclMatx::getRaw(int i_energy, int i_phase, int i_counter){
	if(!hasData()){
                fprintf(stderr, "No accumulation scaling matrix is found.\nProbably CENA mode is different.\n");
                return 0;
	}
	if(i_energy<0 || i_energy >= _ne){
		throw "Illegal argument for i_energy"+i_energy;
	}
	if(i_phase<0 || i_phase >= _np){
		throw "Illegal argument for i_phase"+i_phase;
	}
	if(i_counter<0 || i_counter >= 3){
		throw "Illegal argument for i_counter"+i_counter;
	}
	size_t index=i_energy * _np * 4 + i_phase * 4 + i_counter;
	return getValue(index);
}


uint32_t CenaAccumSclMatx::get(int i_energy, int i_phase, int i_counter){
	int value=getRaw(i_energy, i_phase, i_counter);
	return log8tolinear32(value);
}




// End of namespace
}
}

