/*
 *  CenaSciCntrAcc.cpp
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/06/26.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "IrfPac/SaraPac/CenaSciCntrAcc.h"
#include <linlog++.h>

namespace IrfPac{
namespace SaraPac{

CenaSciCntrAcc::CenaSciCntrAcc(uint8_t *pac, int nEnergy, int nPhase, int nC)
: CenaScienceDataPacket(pac, nEnergy*nPhase*nC){
	_ne=nEnergy;
	_np=nPhase;
	_nc=nC;
}


uint8_t CenaSciCntrAcc::getRaw(int iE, int iP, int iC){
	int index = iE*_np*_nc + iP*_nc + iC;
	return getValue(index);
}

uint16_t CenaSciCntrAcc::get(int iE, int iP, int iC){
	uint8_t raw=getRaw(iE, iP, iC);
	return log8tolinear16(raw);
}


void CenaSciCntrAcc::dumpAll(FILE* fp) {
	fprintf(fp, "=== CenaSciCntrAcc packet ===\n");
	fprintf(fp, "Nene = %d\n", _ne);
	fprintf(fp, "Nph = %d\n", _np);
	fprintf(fp, "Nc   = %d... should be 55, right?\n", _nc);

	for(int ie=0; ie<_ne; ie++){
		for(int ip=0; ip<_np; ip++){
			fprintf(fp, "E=%2d P=%2d |", ie, ip);
			for(int ic=0; ic<_nc; ic++){
				fprintf(fp, " %02x", getRaw(ie,ip,ic));
			}
			fprintf(fp, "\n");
		}
	}

}

// End of namespaces
}}

