/*
 *  CenaSciTofAcc.h
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/06/26.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _IRFPAC_SARAPAC_CENASCITofAcc
#define _IRFPAC_SARAPAC_CENASCITofAcc

#include "IrfPac/SaraPac/CenaScienceDataPacket.h"

namespace IrfPac{
namespace SaraPac{

/**	@brief CENA science packet (non-rice-compressed) of TOF accumulation mode.
*/
class CenaSciTofAcc : public CenaScienceDataPacket {

public:
	CenaSciTofAcc(uint8_t *pac, int nEnergy, int nTof);
	~CenaSciTofAcc(){};

	uint8_t getRaw(int iE, int iTof);
	uint16_t get(int iE, int iTof);

	int getNrEne(){return _ne;};
	int getNrTof(){return _ntof;};

private:
	int _ne, _ntof;

};

//end of namespace
}
}



#endif

