#ifndef _IRFPAC_SARAPAC_CENASCIENCEDATA
#define _IRFPAC_SARAPAC_CENASCIENCEDATA
/*
 *  CenaScienceData.h
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/06/26.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include<IrfPac/irfpac.h>

namespace IrfPac{
namespace SaraPac{

/** @brief Packet for CENA science data.

	The class is a base class for CENA science data classes.
	Normally one do not instance this class.
	Concrete classes is CenaSciMassAcc, CenaSciTofAcc, CenaSciCntrAcc, and CenaSciNonProcess.
*/
class CenaScienceDataPacket : public PacketU8Arr {

public:
	CenaScienceDataPacket(uint8_t *stream, size_t size):PacketU8Arr(stream, size){};
	virtual ~CenaScienceDataPacket(){};

protected:
	int sensor_mode;
	int telem_mode;

};


// End of namespaces
}
}

#endif

