#ifndef __IRAPAC_SARAPAC_CENASCIENCEPACKAGE_H
#define __IRAPAC_SARAPAC_CENASCIENCEPACKAGE_H

#include<sys/stat.h>
#include"IrfPac/SaraPac/CenaPacket.h"


namespace IrfPac{
namespace SaraPac{


class CenaSciencePackageMassDump{
private:
	FILE *fp1, *fp2, *fp3, *fp4, *fp5, *fp6, *fp7, *fp8;
	CenaSciMassAccFormatter *f2, *f3, *f4, *f5, *f6, *f7;

public:
	CenaSciencePackageMassDump(char* dirname){
		char name[256];
		sprintf(name, "%s/01hk", dirname); fp1=fopen(name, "w");
		sprintf(name, "%s/02et", dirname); fp2=fopen(name, "w");
		f2=new CenaSciMassAccFormatterEspec();
		sprintf(name, "%s/03mt", dirname); fp3=fopen(name, "w");
		f3=new CenaSciMassAccFormatterMspec();
		sprintf(name, "%s/04ct", dirname); fp4=fopen(name, "w");
		f4=new CenaSciMassAccFormatterCspec();
		sprintf(name, "%s/05met", dirname); fp5=fopen(name, "w");
		f5=new CenaSciMassAccFormatterMspecEne();
		sprintf(name, "%s/06lcet", dirname); fp6=fopen(name, "w");
		f6=new CenaSciMassAccFormatterLightEspecC();
		sprintf(name, "%s/07hcet", dirname); fp7=fopen(name, "w");
		f7=new CenaSciMassAccFormatterHeavyEspecC();
		sprintf(name, "%s/08reserved", dirname); fp8=fopen(name, "w");
	}
	~CenaSciencePackageMassDump(){
		delete f2;
		delete f3;
		delete f4;
		delete f5;
		delete f6;
		delete f7;
	}
	void flush(){fflush(fp1); fflush(fp2); fflush(fp3); fflush(fp4); fflush(fp5); fflush(fp6); fflush(fp7); fflush(fp8);}
	void close(){fclose(fp1); fclose(fp2); fclose(fp3); fclose(fp4); fclose(fp5); fclose(fp6); fclose(fp7); fclose(fp8);}
	void add(CenaPacket* cena, TimeConversion* tconv){
		if(!cena->isValid()){
			return;
		}
		// Cena decompression check.  If it fails, nothing to do.
		CenaPacket* ucena = cena->decompress();
		if(ucena==NULL) return;

		// 01hk HK table is the same as cenahk.
		cena->printParamsTbl2(fp1, tconv);
		// 02 to 04 is science data, only when counter mode is active.



		CenaSciMassAcc* pac=ucena->getCenaSciMassAcc();
		if(pac != NULL){
    			fprintf(fp2, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f2->dump(fp2, pac);
			fprintf(fp2, "\n");

    			fprintf(fp3, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f3->dump(fp3, pac);
			fprintf(fp3, "\n");

    			fprintf(fp4, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f4->dump(fp4, pac);
			fprintf(fp4, "\n");

    			fprintf(fp5, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f5->dump(fp5, pac);
			fprintf(fp5, "\n");

    			fprintf(fp6, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f6->dump(fp6, pac);
			fprintf(fp6, "\n");

    			fprintf(fp7, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f7->dump(fp7, pac);
			fprintf(fp7, "\n");

			delete pac;
		}
		delete ucena;
	}



};

class CenaSciencePackageCntrDump{
private:
	FILE *fp1, *fp2, *fp3, *fp4, *fp5, *fp6, *fp7, *fp8;
	CenaSciCntrAccFormatter *f2, *f3, *f4, *f5;
public:
	CenaSciencePackageCntrDump(char* dirname){
		char name[256];
		sprintf(name, "%s/01hk", dirname); fp1=fopen(name, "w");
		sprintf(name, "%s/02startnc", dirname); fp2=fopen(name, "w");
		f2=new CenaSciCntrAccFormatterStartNC();
		sprintf(name, "%s/03startcoin", dirname); fp3=fopen(name, "w");
		f3=new CenaSciCntrAccFormatterCoin();
		sprintf(name, "%s/04stop", dirname); fp4=fopen(name, "w");
		f4=new CenaSciCntrAccFormatterStopPlate();
		sprintf(name, "%s/05mesh", dirname); fp5=fopen(name, "w");
		f5=new CenaSciCntrAccFormatterStopMesh();
		sprintf(name, "%s/06reserved", dirname); fp6=fopen(name, "w");
		sprintf(name, "%s/07reserved", dirname); fp7=fopen(name, "w");
		sprintf(name, "%s/08reserved", dirname); fp8=fopen(name, "w");
	}
	~CenaSciencePackageCntrDump(){
		delete f2;
		delete f3;
		delete f4;
		delete f5;
	}
	void flush(){fflush(fp1); fflush(fp2); fflush(fp3); fflush(fp4); fflush(fp5); fflush(fp6); fflush(fp7); fflush(fp8);}
	void close(){fclose(fp1); fclose(fp2); fclose(fp3); fclose(fp4); fclose(fp5); fclose(fp6); fclose(fp7); fclose(fp8);}
	void add(CenaPacket* cena, TimeConversion *tconv){
		if(!cena->isValid()){
			return;
		}
		CenaPacket* ucena = cena->decompress();
		if(ucena==NULL){
			return;
		}

		// 01hk HK table is the same as cenahk.
		cena->printParamsTbl2(fp1, tconv);
		// 02 to 05 is science data, only when counter mode is active.
		CenaSciCntrAcc* pac=ucena->getCenaSciCntrAcc();
		if(pac != NULL){
    			fprintf(fp2, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f2->dump(fp2, pac);
			fprintf(fp2, "\n");

    			fprintf(fp3, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f3->dump(fp3, pac);
			fprintf(fp3, "\n");

    			fprintf(fp4, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f4->dump(fp4, pac);
			fprintf(fp4, "\n");

    			fprintf(fp5, "0x%04x %14.2f ", cena->get4sCycleCntr(), cena->getUniversalTime(tconv)*1000);
			f5->dump(fp5, pac);
			fprintf(fp5, "\n");


			delete pac;
		}
		delete ucena;
	}


};


/**@brief A class for dumping CENA science package.

   Series of CenaPacket is converted to so-called science package format which is to be used idlscilib and other programs.
   The package is generated also by SaraDemultiplex program.
   The package is a folder structure such as:
   <pre>
   package_name.pkg -+- cena
                     +- cenahk
                     +- cenatoff
                     +- cenacntr -+- 01hk
		     |            +- 02startnc
		     |            +- 03startcoin
		     |            +- ....
		     |
		     +- cenamass -+- 01hk
		                  +- 02et
				  +- 03mt
				  +- ...
   </pre>
   Reading routine is NOT implemented in libsadppac,
   however, you can use CenaBmuReader for the file package_name.pkg/cena in order to reconstruct CenaPacketArray.

   @section TimeConversion Time Conversion
   Time conversion is represented by an extended class of TimeConversion.
   You can set TimeConversion class by setTimeConversion(TimeConversion) method.

   If TimeConversion is set, the program uses the specified time conversion.
   If it is not set (default), the dump() method try to call getUtc() method.
   In case getUtc() is not defined (this happens if you read the data from SARA BMU format), no conversion is made (i.e. time should be very small value close to 1970's).

   However, each dump (01hk, 02et ...) yet has a problem of the time conversion since these formatter uses getUniversalTime(NULL).
   In version 2, the difference of the time, i.e. convertedUtc-getUniversalTime(NULL), where convertedUtc is usually taken from getUtc() method, is written in the cenatoff file.
 */
class CenaSciencePackage{
private:
	CenaPacketArray *pacArr;
	TimeConversion *tconv;
public:
	static int getVersion(){
		return 2;
	}
	CenaSciencePackage(){
		pacArr=new CenaPacketArray();
		tconv=NULL;
	}
	~CenaSciencePackage(){
		delete pacArr;
	}
	/**@brief Set time conversion method.

           Specify the method of time conversion.  Look at "Time conversion' section in the class description.

           This method just copy the pointer of tConv.  No new/delete is done.
           So be careful that tConv should not be deleted.
	*/
	void setTimeConversion(TimeConversion *tConv){
		tconv=tConv;
	}

	void appendCenaPacketArray(CenaPacketArray* arr){
		for(unsigned int i=0; i<arr->size(); i++){
			CenaPacket *cpac=arr->getPacket(i);
			pacArr->append(cpac);
			delete cpac;
		}
	}

	void appendCenaPacket(CenaPacket* cpac){
		pacArr->append(cpac);
	}
	void dump(char* pkgname){
#ifdef DEBUG
		fprintf(stderr, "Version=%d\n", getVersion());
		fprintf(stderr, "Number of data=%d\n", (int)pacArr->size());

		// Make a root folder of the package
		fprintf(stderr, "making package at %s\n", pkgname);
#endif
		mode_t dmode=0000755;
		mkdir(pkgname, dmode);

              char cenaverfn[1024];
              sprintf(cenaverfn, "%s/cenaversion", pkgname);
              FILE* cenaver=fopen(cenaverfn, "w");
              fprintf(cenaver, "%d", getVersion());
              fclose(cenaver);

		// Offset between time conversion
		double toff=0;


		// CENA bmu format
		PacketBmuFormatter bmuformatter;
		char cenabmufn[1024];
		sprintf(cenabmufn, "%s/cena", pkgname);
		FILE* cenabmu=fopen(cenabmufn, "w");

		// CENA HK
		char cenahkfn[1024];
		sprintf(cenahkfn, "%s/cenahk", pkgname);
		FILE* cenahk=fopen(cenahkfn, "w");
		CenaPacket::printParamsTblHeader(cenahk);

		// CENA SCIENCE
		char cenacntrout[256];
		sprintf(cenacntrout, "%s/cenacntr", pkgname);
#ifdef DEBUG
		fprintf(stderr, "OUTPUT(CENA-cntr): %s\n", cenacntrout);
#endif
		mkdir(cenacntrout, dmode);
		CenaSciencePackageCntrDump ccd(cenacntrout);
		
		char cenamassout[256];
		sprintf(cenamassout, "%s/cenamass", pkgname);
#ifdef DEBUG
		fprintf(stderr, "OUTPUT(CENA-mass): %s\n", cenamassout);
#endif
		mkdir(cenamassout, dmode);

		CenaSciencePackageMassDump cmd(cenamassout);

		for(unsigned int i=0; i<pacArr->size(); i++){
			CenaPacket *cena=pacArr->getPacket(i);

			// Dump to cenabmu
			double utc=0;
			if(tconv!=NULL){utc=cena->getUniversalTime(tconv);}
			else{
				try{utc=cena->getUtc();}
				catch(const std::runtime_error &exc){utc=cena->getUniversalTime(NULL);}
			}
			if(i==0)toff=utc-cena->getUniversalTime(NULL);
			int qf=cena->getQualityFlag();
			time_t utc_i=(time_t)utc;
			struct tm* tm=gmtime(&utc_i);
			
			fprintf(cenabmu, "******** CENA-DATA at Time  %04d-%02d-%02dT%02d:%02d:%02dZ %15.3f %d %d\n", tm->tm_year+1900, tm->tm_mon+1, tm->tm_mday, tm->tm_hour, tm->tm_min, tm->tm_sec,  utc, (int) cena->getSize(), (int) qf);
                        bmuformatter.format(cenabmu, cena);

			// Dump to cenahk
			cena->printParamsTbl2(cenahk, tconv);

			// Dump to science
			cmd.add(cena, tconv);
			ccd.add(cena, tconv);

			delete cena;
		}

                char cenatconvfn[1024];
                sprintf(cenatconvfn, "%s/cenatconv", pkgname);
                FILE* cenatconv=fopen(cenatconvfn, "w");
                fprintf(cenatconv, "%f", toff);
                fclose(cenatconv);

		
		fclose(cenabmu);
		fclose(cenahk);
		cmd.close();
		ccd.close();

	}

};
}}

#endif
