#include<iostream>
#include "IrfPac/SaraPac/CenaSubcHkPac.h"

namespace IrfPac {

namespace SaraPac {

CenaSubcHkPacket::CenaSubcHkPacket(uint8_t* stream, size_t size)
 : PacketU8Arr(stream, size)
{
#ifdef DEBUG
	std::cout << "CenaSubcPacket Generating" << std::endl;
#endif
}

CenaSubcHkPacket::CenaSubcHkPacket(uint8_t* stream)
 : PacketU8Arr(stream, 119)
{
#ifdef DEBUG
	std::cout << "CenaSubcPacket Generating" << std::endl;
#endif
}

CenaSubcHkPacket::~CenaSubcHkPacket()
{
}

void CenaSubcHkPacket::dumpAll(FILE* fp){

	fprintf(fp, "FLAGS:     %02x\n", IrfPac::SaraPac::getByteAt(*this, 0));
	fprintf(fp, "HVmain(P)  %1d\n", getFlagHvMain());
	fprintf(fp, "HVmain(S)  %1d\n", getFlagHvSafety());
	fprintf(fp, "HVmain(PE) %1d\n", getFlagHvOnEna());
	fprintf(fp, "HVmain(SE) %1d\n", getFlagHvLvlEna());
	fprintf(fp, "HVmain(ER) %1d\n", getFlagError());

	fprintf(fp, "HV main:1-2:%02x %02x: %04x\n", getByteAt(*this, 1), getByteAt(*this, 2), getHvMain());
	fprintf(fp, "HV startMCP:3-4:%02x %02x: %04x\n", getByteAt(*this, 3), getByteAt(*this, 4), getHvStartMcp());
	fprintf(fp, "HV stopMCP:5-6:%02x %02x: %04x\n", getByteAt(*this, 5), getByteAt(*this, 6), getHvStopMcp());
	fprintf(fp, "HV tof:7-8:%02x %02x: %04x\n", getByteAt(*this, 7), getByteAt(*this, 8), getHvTof());
	fprintf(fp, "HV def:9-10:%02x %02x: %04x\n", getByteAt(*this, 9), getByteAt(*this, 10), getHvDef());
	fprintf(fp, "TEMP IFE:11-12:%02x %02x: %04x\n", getByteAt(*this, 11), getByteAt(*this, 12), getTempIFE());
	fprintf(fp, "TEMP HVPS:13-14:%02x %02x: %04x\n", getByteAt(*this, 13), getByteAt(*this, 14), getTempHVPS());
	fprintf(fp, "PsyncCntr:33-34:%02x %02x: %04x\n", getByteAt(*this, 33), getByteAt(*this, 34), getPsyncCntr());
	fprintf(fp, "BaseCntr:35-36:%02x %02x: %04x\n", getByteAt(*this, 35), getByteAt(*this, 36), getBaseCntr());


	fprintf(fp, "..... HEX DUMP\n");
	dumpHexStream(fp);
}

uint16_t CenaSubcHkPacket::getHvMain(){return get12bitValue(1,2);};
uint16_t CenaSubcHkPacket::getHvStartMcp(){return get12bitValue(3,4);};
uint16_t CenaSubcHkPacket::getHvStopMcp(){return get12bitValue(5,6);};
uint16_t CenaSubcHkPacket::getHvTof(){return get12bitValue(7,8);};    
uint16_t CenaSubcHkPacket::getHvDef(){return get12bitValue(9,10);};   
uint16_t CenaSubcHkPacket::getTempIFE(){return get12bitValue(11,12);};
uint16_t CenaSubcHkPacket::getTempHVPS(){return get12bitValue(13,14);};
uint16_t CenaSubcHkPacket::getPsyncCntr(){return get16bitValue(33,34);};
uint16_t CenaSubcHkPacket::getBaseCntr(){return get16bitValue(35,36);};





}

}
