#include"IrfPac/SaraPac/SaraHkConversionGrndCal.h"

using namespace IrfPac;
using namespace IrfPac::SaraPac;

double SaraHkConversionGrndCal::swimHV(uint32_t monitor){
  return polynoms(0, 1.3567, -6.4155, monitor);
}

double SaraHkConversionGrndCal::swimVCeem(uint32_t monitor){
  return polynoms(2e-5, 1.2784, 0, monitor);
}

double SaraHkConversionGrndCal::swimVUpDef(uint32_t monitor){
  return polynoms(0, 1.2053, -4.0, monitor);
}

double SaraHkConversionGrndCal::swimVLoDef(uint32_t monitor){
  return polynoms(0, 1.2085, -4.0, monitor);
}

double SaraHkConversionGrndCal::swimVAnaCel(uint32_t monitor){
  return polynoms(0, 1.1979, -3.2, monitor);
}

double SaraHkConversionGrndCal::swimVTofCel(uint32_t monitor){
  return polynoms(7e-5, 1.1484, 8.9559, monitor);
}

double SaraHkConversionGrndCal::swimTempTofBrd(uint32_t monitor){
  return polynoms(0, 0.101725, -244.08, monitor);
}

double SaraHkConversionGrndCal::cenaHvMain(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaHvStartMcp(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaHvStopMcp(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaHvDef(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaHvTof(uint32_t monitor){
  return polynoms(0, 1.0, 0, monitor);
}

double SaraHkConversionGrndCal::cenaSvWave1(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaSvWave2a(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaSvWave2b(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaSvLens(uint32_t monitor){
  return polynoms(0, 5000./4096., 0, monitor);
}

double SaraHkConversionGrndCal::cenaTempHVPS(uint32_t monitor){
  return polynoms(0, 5000./(4096.*6.2), -273.16, monitor);
}

double SaraHkConversionGrndCal::cenaTempIFE(uint32_t monitor){
  return polynoms(0, 5000./(4096.*6.2), -273.16, monitor);
}


/** @brief a function that returns polynoms: a*x^2 + b*x + c [= c + x * (b + x*a) ]
*/
double SaraHkConversionGrndCal::polynoms(double a, double b, double c, double val){
  return c + val * ( b + val * a );
}
