#include<iostream>
using namespace std;

#include<cppunit/extensions/HelperMacros.h>

#include"IrfPac/irfpac.h"
#include"IrfPac/SaraPac/sarapac.h"

using namespace IrfPac;
using namespace IrfPac::SaraPac;

class SaraHkConversionGrndCal_test : public CPPUNIT_NS::TestFixture {

  public:

  CPPUNIT_TEST_SUITE(SaraHkConversionGrndCal_test);
  CPPUNIT_TEST(testValue);
  CPPUNIT_TEST_SUITE_END();

  void testValue(){

    SaraHkConversionGrndCal* cal = (SaraHkConversionGrndCal*) SaraHkConversion::getConversionFunctions(1);
    // First test is to obtain swin_hk_ref.  Formulation is 1.3567 x - 6.4155
    CPPUNIT_ASSERT_DOUBLES_EQUAL(-6.4155, cal->swimHV(0), 1e-6);
    CPPUNIT_ASSERT_DOUBLES_EQUAL(1356.7-6.4155, cal->swimHV(1000), 1e-6);

    // Next test is for CELL, formulation is 7e-5 x^2 + 1.1484 x + 8.9559
    CPPUNIT_ASSERT_DOUBLES_EQUAL(8.9559, cal->swimVTofCel(0), 1e-6);
    CPPUNIT_ASSERT_DOUBLES_EQUAL(0.7 + 114.84 + 8.9559, cal->swimVTofCel(100), 1e-6);
    CPPUNIT_ASSERT_DOUBLES_EQUAL(70+1148.4+8.9559, cal->swimVTofCel(1000), 1e-6);

  }


};

CPPUNIT_TEST_SUITE_REGISTRATION(SaraHkConversionGrndCal_test);
