#include<iostream>
using namespace std;

#include<cppunit/extensions/HelperMacros.h>

#include"IrfPac/irfpac.h"
#include"IrfPac/SaraPac/sarapac.h"

using namespace IrfPac;
using namespace IrfPac::SaraPac;

class SaraPacket_test : public CPPUNIT_NS::TestFixture {

    public:

    	CPPUNIT_TEST_SUITE(SaraPacket_test);
	CPPUNIT_TEST(testPerformance);
	CPPUNIT_TEST(testObt);
	CPPUNIT_TEST_SUITE_END();

	 void testPerformance(){
		 int SIZE=500;
		 
		 uint8_t* bigPacket=new uint8_t[SIZE];
		 int x=0;
		
		 for(int i=0; i<SIZE; i++) bigPacket[i]=(uint8_t)(i%256);
		
		 PacketU8Arr *arr=new PacketU8Arr(bigPacket, SIZE);
		// to be changed.
		 printf("--- IrfPac::SaraPac::getByteAt\n");
		 system("date +%s");
		 for(unsigned int i=0; i<arr->getSize(); i++){
			 x+=IrfPac::SaraPac::getByteAt(*arr, i);
		 }
		 std::cout << x << std::endl;
		 system("date +%s");
		
		 x=0;
		 PacketU8Arr *arr2=new PacketU8Arr(bigPacket, SIZE);
		 printf("--- getStream() + pointer\n");
		 system("date +%s");
		 for(unsigned int i=0; i<arr2->getSize(); i++){
			 uint8_t* valArr=arr2->getStream();
			 x+=getByteAt(*arr2, i);
			 delete valArr;
		 }
		 std::cout << x << std::endl;
		 system("date +%s");
		
		 x=0;
		 PacketU8Arr *arr3=new PacketU8Arr(bigPacket, SIZE);
		 printf("--- PacketU8Arr.getValue()\n");
		 system("date +%s");
		 system("date +%s");
		 for(unsigned int i=0; i<arr3->getSize(); i++){
			 x+=arr3->getValue(i);
		 }
		 std::cout << x << std::endl;		
		 system("date +%s");
		
		 delete arr;
		 delete arr2;
		 delete arr3;

		 delete[] bigPacket;
	 }

  void testObt(){
    fprintf(stdout, "\n---Test of OBT time to FLOTA type\n");

    uint64_t obt[] = { 0x693d60160000LL, 0x6b1260160000LL, 0x6ce760160000LL,
     0x6ebc60160000LL, 0x709160160000LL, 0x726660160000LL, 0x743b60160000LL, 0x761060160000LL,
     0x77e560160000LL, 0x79ba60160000LL, 0x7b8f60160000LL, 0x7d6460160000LL, 0x7f3960160000LL,
     0x408730170000LL, 0x4171b0170000LL, 0x425c30170000LL,};

     double ans[] = {3.448496e+06, 3.508528e+06, 3.568560e+06,
     3.628592e+06, 3.688624e+06, 3.748656e+06, 3.808688e+06, 3.868720e+06,
     3.928752e+06, 3.988784e+06, 4.048816e+06, 4.108848e+06, 4.168880e+06,
     4.228912e+06, 4.288944e+06, 4.348976e+06,};


    for(int i=0; i<16; i++){
      fprintf(stdout, "%e\n", obt2msec(obt[i]));
      CPPUNIT_ASSERT_DOUBLES_EQUAL(ans[i], obt2msec(obt[i]), 1);
    }


    
  }




};

CPPUNIT_TEST_SUITE_REGISTRATION(SaraPacket_test);
