#include<iostream>
using namespace std;

#include<cppunit/extensions/HelperMacros.h>

#include"IrfPac/irfpac.h"
#include"IrfPac/SaraPac/sarapac.h"

using namespace IrfPac;
using namespace IrfPac::SaraPac;

class SwimAccumTotMatx_test : public CPPUNIT_NS::TestFixture {
    public:
    	CPPUNIT_TEST_SUITE(SwimAccumTotMatx_test);
	CPPUNIT_TEST(testDump);
	CPPUNIT_TEST(testDump2);
	CPPUNIT_TEST(testReform);
	CPPUNIT_TEST_SUITE_END();

	void testDump(){
	  uint8_t con[32*32*5];
	  for(int i=0; i<32*32*5; i++){
	    con[i] = (uint8_t) (i%256);
	  }
	  SwimAccumTotMatx* matx=new SwimAccumTotMatx(con, 32, 32);

	  SwimAccumTotMatxHexDump dump;
	  dump.dump(stdout, matx);

	}

	void testDump2(){
	  uint8_t con[32*32*5];
	  for(int i=0; i<32*32*5; i++){
	    con[i] = (uint8_t) (i%256);
	  }
	  SwimAccumTotMatx* matx=new SwimAccumTotMatx(con, 32, 32);
	  matx->dumpAll(stdout);
	}

	void testReform(){
		uint8_t con[32*8*5];
		for(int i=0; i<32*8*5; i++){
			con[i] = (uint8_t) ((i%180) + 30);
		}

		SwimAccumTotMatx* matx = new SwimAccumTotMatx(con, 32, 8);

		SwimAccumTotMatx* matx16 = matx->reform16x16();

		// iE=0, iD=0 is aE=0, aD=0
		int val = matx->get(0, 0, 0);   // Start Counter of E,D = 0,0
		int val16 = matx16->get(0, 0, 0); // Start Counter of E,D = 0,0
		
		CPPUNIT_ASSERT_EQUAL(val, val16);

		// iE=15, iD=5 is aE=7, iD=11
		val = matx->get(15,5,3);
		val16 = matx16->get(7, 11, 3);

		CPPUNIT_ASSERT_EQUAL(val, val16);




		delete matx;

		CPPUNIT_ASSERT_EQUAL(16, matx16->getEnergyBins());
		CPPUNIT_ASSERT_EQUAL(16, matx16->getDeflectionBins());


		matx16->dumpAll(stdout);

		delete matx16;
		

	}


};

CPPUNIT_TEST_SUITE_REGISTRATION(SwimAccumTotMatx_test);
