/*
 *  SwimFastHkPacket.cpp
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/10/19.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include<iostream>
#include "IrfPac/SaraPac/SwimFastHkPacket.h"

namespace IrfPac{
namespace SaraPac{

SwimFastHkPacket::SwimFastHkPacket(uint8_t* stream, size_t size) : PacketU8Arr(stream, size){
#ifdef DEBUG
	std::cout << "SwimFastHkPacket Generating with size of  " << size << std::endl;
#endif
}

SwimFastHkPacket::SwimFastHkPacket(uint8_t* stream) : PacketU8Arr(stream, 14){
#ifdef DEBUG
	std::cout << "SwimFastHkPacket Generating with default size of 14." << std::endl;
#endif
}

SwimFastHkPacket::~SwimFastHkPacket(){
}

void SwimFastHkPacket::dumpAll(FILE* fp){
	fprintf(fp, "Main HV     :1:%04x:   %04x\n", getWordAt(*this,1), getHV());
	fprintf(fp, "CEEM HV     :2:%04x:   %04x\n", getWordAt(*this,1), getVCeem());
	fprintf(fp, "Uppe Def Vol:3:%04x:   %04x\n", getWordAt(*this,1), getVUpDef());
	fprintf(fp, "Lowe Def Vol:4:%04x:   %04x\n", getWordAt(*this,1), getVLoDef());
	fprintf(fp, "Analyzer Vol:5:%04x:   %04x\n", getWordAt(*this,1), getVAnaCel());
	fprintf(fp, "TOF CELL Vol:6:%04x:   %04x\n", getWordAt(*this,1), getVTofCel());
	fprintf(fp, "TOF BRD TEMP:7:%04x:   %04x\n", getWordAt(*this,1), getTempTofBrd());
	fprintf(fp, "..... HEX DUMP\n");
	dumpHexStream(fp);
}



}}// namespace
