/*
 *  SwimMatrix.cpp
 *  libsadppac
 *
 *  Created by Futaana Yoshifumi on 07/11/21.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */
#include<cstdio>
#include<stdexcept>
#include "IrfPac/SaraPac/saradecomp.h"
#include "IrfPac/SaraPac/SwimMatrix.h"

namespace IrfPac{
namespace SaraPac{


	SwimMatrix::SwimMatrix(uint8_t* stream, int size) : PacketU8Arr(stream, size){
	}

	SwimMatrix* SwimMatrix::decompress(int verbose){	
		size_t decomp_size=0;
		char* formattedInput=preformat();
		uint8_t* decompressedContent=decomp_main(formattedInput, &decomp_size);
		if (decompressedContent==NULL) {
			if (verbose >= VERBOSE_NORMAL) {
				uint8_t* contents=getStream();
				size_t size=getSize();
				fprintf(stderr, "<c.txt>\n");
				for(size_t i=0; i<size; i++){
					fprintf(stderr, "%02x", contents[i]);
					if(i%2==1)fprintf(stderr, " ");
				}
				fprintf(stderr, "\n</c.txt>\n");
				delete contents;
			}
			return NULL;
		}
		delete[] formattedInput;
		SwimMatrix* retMatx=new SwimMatrix(decompressedContent, decomp_size);
		delete[] decompressedContent;
		return retMatx;
	}



	char* SwimMatrix::preformat(){
		// input shoudl be "xxxx xxxx xxxx ....."
		size_t size=getSize();
#ifdef DEBUG
		fprintf(stdout, "%d\n", (int)size);
#endif
		char* str=new char[5*size/2+1];

		uint8_t* bStream=getStream();
		for(size_t i=0; i<size; i+=2){   // Even index number
			sprintf(&(str[(i/2)*5]), "%02x%02x ", bStream[i], bStream[i+1]);
		}
		
#ifdef DEBUG
		fprintf(stdout, "%s\n", str);
#endif
		
		delete[] bStream;
		return str;
	}
	uint8_t* SwimMatrix::decomp_main(char* inputStream, size_t* decompressedSize){
		Decompression* decomp=new Decompression();
		try{
			uint8_t* decompPac=decomp->decompressionAll(inputStream, 5*getSize()/2+1, decompressedSize);  
			delete decomp;
			return decompPac;
		} catch(const std::runtime_error &exc){
			fprintf(stderr, "Failed to decompress:  %s\n", exc.what());
			return NULL;
		}
	}




}}

