#include<iostream>
using namespace std;

#include<cppunit/extensions/HelperMacros.h>

#include"IrfPac/irfpac.h"
#include"IrfPac/SaraPac/sarapac.h"

using namespace IrfPac;
using namespace IrfPac::SaraPac;

class SwimPacket_test : public CPPUNIT_NS::TestFixture {

    public:

            CPPUNIT_TEST_SUITE(SwimPacket_test);
            CPPUNIT_TEST(testInstance);
            CPPUNIT_TEST(testMagicNumber);
	    CPPUNIT_TEST_SUITE_END();
		
		void testInstance(){
			cout << "TEST INSTANCE" << endl;
			uint8_t *stream=(uint8_t*) malloc (800);
			for(int i=0; i<800; i++){
				stream[i]=i;
			}
			
			SwimPacket Swim=SwimPacket(stream, 800);
			
			CPPUNIT_ASSERT_EQUAL(800, (int)Swim.getSize());
			
			free(stream);
		};
		
	void testMagicNumber(){
		cout << "TEST MAGIC NUMBER" << endl;
	
		uint8_t *stream=(uint8_t*) malloc (800);
		stream[0]=stream[1]=0xdd;
		stream[2]=stream[3]=0xee;
		for(int i=4; i<800; i++){
			stream[i]=i;
		}
		
		SwimPacket Swim=SwimPacket(stream, 800);
		
		CPPUNIT_ASSERT_EQUAL(800, (int)Swim.getSize());
		CPPUNIT_ASSERT_EQUAL((long)0xDDDDEEEE, (long)Swim.getHeadMagicNumber());
 		CPPUNIT_ASSERT_EQUAL((long)SwimPacket::SWIM_SCI_ID, (long)Swim.getHeadMagicNumber());
		//
		//		free(stream);
	}
	


};

CPPUNIT_TEST_SUITE_REGISTRATION(SwimPacket_test);

