#include<iostream>
#include<cppunit/extensions/HelperMacros.h>

#include<ctime>

#include"IrfPac/irfpac.h"
#include"IrfPac/SaraPac/sarapac.h"

using namespace std;
using namespace IrfPac;
using namespace IrfPac::SaraPac;

class TimeConversion_test : public CPPUNIT_NS::TestFixture {
	
public:
	
	CPPUNIT_TEST_SUITE(TimeConversion_test);
	CPPUNIT_TEST(testConversionOffsetOrigin);
	CPPUNIT_TEST(testConversionOffsetConv);
	CPPUNIT_TEST_SUITE_END();

	void testConversionOffsetOrigin(){
		TimeConversionOffset tc(TimeConversionOffset::OFFSET(2));   // Assuming the 2-nd iteration: i.e. start time of 2008-12-02 23:57:03
		double time_origin = tc.obt2utc(0);
		time_t ttime_origin = (time_t) time_origin;
		char buf[256];
		struct tm* tm_origin = gmtime(&ttime_origin);
		strftime(buf, 255, "%F %T", tm_origin);
		fprintf(stdout, buf);
		fprintf(stdout, "\n");

		CPPUNIT_ASSERT_EQUAL(std::string("2008-12-02 23:57:03"), std::string(buf));

		double time_1day = tc.obt2utc( 86400.*1000. );  // in msec
		time_t ttime_1day = (time_t) time_1day;
		struct tm* tm_1day = gmtime(&ttime_1day);
		strftime(buf, 255, "%F %T", tm_1day);
		fprintf(stdout, buf);
		fprintf(stdout, "\n");
		CPPUNIT_ASSERT_EQUAL(std::string("2008-12-03 23:57:03"), std::string(buf));
	}


	void testConversionOffsetConv(){
		TimeConversionOffset tc(TimeConversionOffset::OFFSET(4));  // As for Jan 13.
		double obt=1425856580.237156;
		double obstime=tc.obt2utc(obt);
		
		cout << obt << "->" << obstime << endl;

		time_t timet=(time_t) obstime;
		struct tm* tm=gmtime(&timet);
		char buf[256];
		strftime(buf, 255, "%F %T", tm);
		cout << buf << endl;
	}
	
};

CPPUNIT_TEST_SUITE_REGISTRATION(TimeConversion_test);
