#include<iostream>
#include<ctime>
#include"IrfPac/SaraPac/TimePacket.h"
#include <stdlib.h>

using namespace std;
using namespace IrfPac::SaraPac;

double IrfPac::SaraPac::convert_utc2epoch(int yr, int mo, int dy, int hr, int mn, int sec, int msec){

    struct tm tm;

    tm.tm_year = yr-1900;
    tm.tm_mon = mo-1;
    tm.tm_mday=dy;
    tm.tm_hour=hr;
    tm.tm_min=mn;
    tm.tm_sec=sec;
    tm.tm_isdst=-1;

    time_t gm=timegm(&tm);

    double res= msec/1000.+(double)gm;

    return res;
}

std::string IrfPac::SaraPac::epoch2str(double utctime){
	time_t ttime = (time_t)utctime;
	int msec = (utctime - ttime) * 1000;

	char buf[256];

	struct tm* stm = gmtime(&ttime);
	strftime(buf, 255, "%FT%T", stm);
	std::string retbuf(buf);
	sprintf(buf, ".%03iZ", msec);
	retbuf.append(std::string(buf));
	return retbuf;

}

std::string IrfPac::SaraPac::epoch2iso8601str(double utctime){
	time_t ttime = (time_t)utctime;
	int msec = (utctime - ttime) * 1000;

	char buf[256];

	struct tm* stm = gmtime(&ttime);
	strftime(buf, 255, "%Y-%m-%dT%H:%M:%S", stm);
	std::string retbuf(buf);
	sprintf(buf, ".%03i", msec);
	retbuf.append(std::string(buf));
	return retbuf;

}


time_t mkgmtime(register struct tm * t)
/* struct tm to seconds since Unix epoch */
/* http://gpsd.sourcearchive.com/documentation/2.95/gpsutils_8c-source.html */
{
#define MONTHSPERYEAR   12    /* months per calendar year */

    register int year;
    register time_t result;
    static const int cumdays[MONTHSPERYEAR] =
      { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };

    year = 1900 + t->tm_year + t->tm_mon / MONTHSPERYEAR;
    result = (year - 1970) * 365 + cumdays[t->tm_mon % MONTHSPERYEAR];
    result += (year - 1968) / 4;
    result -= (year - 1900) / 100;
    result += (year - 1600) / 400;
    if ((year % 4) == 0 && ((year % 100) != 0 || (year % 400) == 0) &&
      (t->tm_mon % MONTHSPERYEAR) < 2)
      result--;
    result += t->tm_mday - 1;
    result *= 24;
    result += t->tm_hour;
    result *= 60;
    result += t->tm_min;
    result *= 60;
    result += t->tm_sec;
    return (result);
}

double IrfPac::SaraPac::iso8601str2epoch(std::string isotime)
/* ISO8601 UTC to Unix UTC */
/* http://gpsd.sourcearchive.com/documentation/2.95/gpsutils_8c-source.html */

{
    char *dp = NULL;
    double usec;
    struct tm tm;

    dp = strptime(isotime.c_str(), "%Y-%m-%dT%H:%M:%S", &tm);
    
    if (dp == NULL) {
	string msg ("iso8601str2epoch: invalid iso8601 string '");
	msg += isotime;
	msg += "'.";
	throw std::runtime_error(msg);
    }
      
    if (dp != NULL && *dp == '.')
      usec = strtod(dp, NULL);
    else
      usec = 0;
    return (double)mkgmtime(&tm) + usec;
}
	




