#include<iostream>
#include<cppunit/extensions/HelperMacros.h>

#include"IrfPac/irfpac.h"
#include"IrfPac/SaraPac/sarapac.h"

using namespace std;
using namespace IrfPac;
using namespace IrfPac::SaraPac;

class TimePacket_test : public CPPUNIT_NS::TestFixture {
	
public:
	
		CPPUNIT_TEST_SUITE(TimePacket_test);
		CPPUNIT_TEST(testTest);
		CPPUNIT_TEST(testConversion);
		CPPUNIT_TEST(testString);
		CPPUNIT_TEST_SUITE_END();

	uint8_t* getSample(){
		uint8_t* data=new uint8_t[54];

		data[0]=0x00; data[1]=0x00; data[2]=0x00; data[3]=0x00; data[4]=0x18; data[5]=0xb9; data[6]=0x7d; data[7]=0xa2; data[8]=0x0f; data[9]=0x00; data[10]=0x00; data[11]=0x00; data[12]=0x18; data[13]=0xb9; data[14]=0x7d; data[15]=0xa2; data[16]=0x00; data[17]=0x80; data[18]=0x9f; data[19]=0xeb; data[20]=0xab; data[21]=0x10; data[22]=0xd1; data[23]=0x41; data[24]=0xd9; data[25]=0x07; data[26]=0x00; data[27]=0x00; data[28]=0x01; data[29]=0x00; data[30]=0x00; data[31]=0x00; data[32]=0x1b; data[33]=0x00; data[34]=0x00; data[35]=0x00; data[36]=0x06; data[37]=0x00; data[38]=0x00; data[39]=0x00; data[40]=0x04; data[41]=0x00; data[42]=0x00; data[43]=0x00; data[44]=0x05; data[45]=0x00; data[46]=0x00; data[47]=0x00; data[48]=0xa5; data[49]=0x04; data[50]=0x00; data[51]=0x00; data[52]=0x00; data[53]='\0';
		return data;
	}
	
	void testTest(){
		uint8_t* dat=getSample();
		TimePacket* tpac=new TimePacket(dat);
		double obt=tpac->getObtTimeDouble();
		printf("%f\n", obt);
		CPPUNIT_ASSERT_DOUBLES_EQUAL( 1145221038.492188, obt, 1e-5);
		time_t val=tpac->getGmt();
		printf("%f\n", (double)val);
	}

	void testConversion(){
		double t=IrfPac::SaraPac::convert_utc2epoch(2008,2,29,1,30,25,100);
		cout << t << endl;
		CPPUNIT_ASSERT_DOUBLES_EQUAL(1204248625.1, t, 1e-3);
		t=IrfPac::SaraPac::convert_utc2epoch(2008,3,0,1,30,25,100);
		CPPUNIT_ASSERT_DOUBLES_EQUAL(1204248625.1, t, 1e-3);
	}

	void testString(){
		std::string d=IrfPac::SaraPac::epoch2str(1204248625.250);
		cout << d << endl;
		CPPUNIT_ASSERT_EQUAL(std::string("2008-02-29T01:30:25.250Z"), d);
	}
	
	
};

CPPUNIT_TEST_SUITE_REGISTRATION(TimePacket_test);
