#ifndef IRFPAC__SARAPAC__SARAPAC_H
#define IRFPAC__SARAPAC__SARAPAC_H

/**
	@namespace IrfPac::SaraPac
	@brief Name space for SARA DPU packet.

	The namespace specifies the SARA DPU packet related codes.
	You may only include SaraPac/sarapac.h to use related classes.
	
	SaraPacket is the top-class packet, which consists of 448 words.
	After the demultiplex of series of SaraPacket, they are
	converted to sensor-level packets: CenaPacket and/or SwimPacket.
*/
#include<IrfPac/SaraPac/TimeConversion.h>
#include<IrfPac/SaraPac/TimePacket.h>

#include<IrfPac/SaraPac/CenaSubcHkPac.h>   // This is deprecated
#include<IrfPac/SaraPac/CenaFastHkPacket.h>

#include<IrfPac/SaraPac/CenaSciMassAcc.h>
#include<IrfPac/SaraPac/CenaSciTofAcc.h>
#include<IrfPac/SaraPac/CenaSciCntrAcc.h>
#include<IrfPac/SaraPac/CenaPacket.h>
#include<IrfPac/SaraPac/CenaSciencePackage.h>

#include<IrfPac/SaraPac/SwimSciAcc.h>
#include<IrfPac/SaraPac/SwimMatrix.h>
#include<IrfPac/SaraPac/SwimAccumTotMatx.h>
#include<IrfPac/SaraPac/SwimMatrix.h>
#include<IrfPac/SaraPac/SwimSubcHkPacket.h>  // This is deprecated.
#include<IrfPac/SaraPac/SwimFastHkPacket.h>

#include<IrfPac/SaraPac/SwimPacket.h>
#include<IrfPac/SaraPac/SwimSciencePackage.h>

#include<IrfPac/SaraPac/SaraPacket.h>

#include<IrfPac/SaraPac/SaraDemultiplexor.h>
#include<IrfPac/SaraPac/SaraBufferedDemultiplexor.h>

#include<IrfPac/SaraPac/SaraHkConversionGrndCal.h>
#include<IrfPac/SaraPac/SaraHkConversion.h>

#endif
