#include "IrfPac/packetbytearr.h"
using namespace std;

namespace IrfPac {



PacketByteArr::PacketByteArr(uint8_t* bytestream, size_t n)
{
	contents = new uint8_t[n];
	for(uint8_t i=0; i<n; i++) contents[i]=bytestream[i];
	_size=n;
}

PacketByteArr::~PacketByteArr(){
	if(contents!=NULL){
		delete[] contents;
		contents=NULL;
	}
}

uint8_t* PacketByteArr::getStream(void){
	uint8_t *_contents = new uint8_t[_size];
	for(uint8_t i=0; i<_size; i++) _contents[i]=contents[i];
	return _contents;
}

size_t PacketByteArr::dumpByteStream(FILE* fp){
	return fwrite(contents, sizeof(uint8_t), getSize(), fp);
}

size_t PacketByteArr::dumpHexStream(FILE* fp){
	for(uint32_t i=0; i<_size; i++){
		if(i%16==0) fprintf(fp, "0x%08x: ", i);
		fprintf(fp, "%02x", contents[i]);
		if(i%2==1)fprintf(fp, " ");
		if(i%16==15)fprintf(fp, "\n");
	}
	fprintf(fp, "\n");
	return _size;
}

size_t PacketByteArr::getSize(){
	return _size;
}


}
