#ifndef IRFPACPACKETBYTEARR_H
#define IRFPACPACKETBYTEARR_H

#include "IrfPac/irfpac.h"
// #include "generalpacket.h"

namespace IrfPac {

	/**	@brief Packet implementation: intialization by byte array.
	  	@deprecated Use PacketU8Arr

		Packet consists of byte array.
		@author FUTAANA
	*/
	class PacketByteArr : public GeneralPacket
	{
		public:
//  	 	  PacketByteArr(){contents=NULL;};

   		  PacketByteArr(uint8_t* bytestream, size_t size);

  		  virtual ~PacketByteArr();

			/**	@brief Return (the pointer to) the byte stream.

				Return the byte stream.  The stream is newly generated, so that
				it is independent from the contents inside this class.
				Change of the contents of returned stream will not affect
				the original contents.
				You have to use delete[] to release the obtained stream explicitly
				otherwise it causes memory leak.
			*/
   		  virtual   uint8_t* getStream(void);
			/**
				Dump the byte stream into the specified file.
				Returned value is the size of the dumped stream in bytes, which is
				normally the size of the packet.
			*/
    		   virtual    size_t dumpByteStream( FILE* fp);
			/**
				Dump the ascii-hex expression of the stream into the specified file.
				Returned value is the size of the dumped stream in bytes, which is
				normally the size of the packet.
			*/
		virtual   	size_t dumpHexStream( FILE* fp);
			/**
				Returns the size of the packet 
			*/
		virtual   	size_t getSize();


		private:
			uint8_t* contents;
			size_t _size;
	};

}

#endif
