/*
Rice decompression software 
Reads the 16-bit word from the file c.txt.
Featches for the header AA55AA55 till the end of the file and decompresses the data.
Each rice packet with the header AA55AA55 contains the compressed data for the 512 samples
Once the header is found, starts decompressing the data for 512 samples.
In case of sync lost, that is if a header is found before decompressing the 512 samples,
decompression starts for the new packet. Old packet which is incomplete,filled with FFFF for 
the remaining samples.Rice decompressed output is 8 bits only. If anywhere in the output file
the 16 bit data FFFF is found, it means that the particular packet has some errors.
The output file is D.txt
*/

#include<stdio.h>
#include<math.h>
int ref_block;
unsigned long lut1[18]={0x0,0x1,0x7,0xe,0x1c,0x38,
                        0x70,0xE0,0x1C0,0x380,0x700,
			0xE00,0x1C00,0x3800,0x7000,
			0xE000,0x1C000,0x38000};

unsigned long lut2[16]={0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80,
                        0x100,0x200,0x400,0x800,0x1000,0x2000,0x4000,0x8000};
unsigned long lut3[6]={0x0,0x1,0x3,0x7,0xF,0x1F};
unsigned long val,temp_val,val1,val2;
int temp[16];
int index,one_count,zero_count,append_count;
int pos,kID;
unsigned long append;
int one_more=1;
int sample[512];
int zero_block_flg;
int zero_count;
int y,dummy,x,p;
unsigned long q;
int flag=0;
int sync_lost=0, y_sync_lost=0;
FILE *fp1,*fp2;

void read_val(void)
{
   if(!sync_lost)
   { 
     if(flag==0)
       {
        if((fscanf(fp1,"%lx",&val))!=EOF)
         {
          //printf("%lx",val);
            // check if it is the header
             if(val==0xAA55)
               {
                // read the second word store it in val1
                 fscanf(fp1,"%lx",&val1);
                 if (val1==0xAA55 && y<512)
                   {
                   // header found 
                   sync_lost=1;
                   y_sync_lost=y;
                   val=0xFFFF;   
                   }
                 else
                  flag=1; 

              }
         }
        else // if end of file
         {

           if(y<512)
            {
            for(x=0;x<y;x++)
            fprintf(fp2,"0x%x\n",sample[x]);
            for(x=y;x<512;x++)
            fprintf(fp2,"0xFFFF\n");
            }
         fclose(fp2);
         //printf("reached End of file");
         exit(0);
         }   

     }
    else // if flag==1
     {
      val=val1;
      flag=0;
     }
  }
 else // if sync lost
  {
  val=0xFFFF;
  }



}


void find_option(void)
{
if(pos>2)
  {
   kID=((val & lut1[pos])>>(pos-2));
   pos=pos-3;
  }
else if(pos==2)
  {
   kID=((val & lut1[pos])>>(pos-2));
   read_val();
   pos=15;
  }
else
  {
  temp_val=val<<16;
  read_val(); // read the new value
  val=val | temp_val;
  pos=pos+16;
  kID=((val & lut1[pos])>>(pos-2));
  pos=pos-3;
  }
if(kID==0)
pos=pos-1;


}

void decompK(void)
{
 while(one_count<(16-ref_block))
 {
     if(pos>=0)
     {
     if((val & lut2[pos])==0)
       {
       zero_count=zero_count+1;
       pos=pos-1;
       }
     else
       {
       temp[index++]=zero_count;
       zero_count=0;
       one_count=one_count+1;
       pos=pos-1;
       }
     }

     else
     {
     pos=15;
     read_val();
     }

 }// end of while
}

void appendLSB(void)
{
 while(append_count < (16-ref_block))
  {
  if((pos+1)>=(kID-1))
   {
  // append=(val & (lut3[kID-1]<<(pos-kID+2))>>(pos-(kID-2)));
   append=lut3[kID-1]<<(pos-kID+2);
   append=append & val;
   append=(append >> (pos-(kID-2))) & lut3[kID-1];
   temp[index++]=((temp[index]<<(kID-1)) | append) & 0xFF; //???????
   append_count=append_count+1;
   pos=pos-(kID-1);
   }
  else
   {
   temp_val=val <<16;
   read_val();
   val=val | temp_val;
   pos=pos+16;
   }

  }// end of while


}

void decomp_zeroblk(void)
{
while(zero_block_flg==0)
 {
  if(pos>=0)
   {
   if((val & lut2[pos])==0)
    {
    zero_count++;
    pos=pos-1;
    }
   else
    {
    zero_block_flg=1;
    pos=pos-1;

    }

   }
  else
   {
   read_val();
   pos=15;
   }
 }


}

void decomp_nocomp(void)
{
while(one_count< (16-ref_block))
  {
  if(pos>7)
   {
   temp[index++]=((val & ((0xFF << (pos-7))))>>(pos-7)) & 0xFF;
  //printf("%x\n",((val & ((0xFF << (pos-7))))>>(pos-7)) & 0xFF);
    pos=pos-8;
   one_count++;
   }
 else if(pos==7)
   {
    temp[index++]=((val & ((0xFF << (pos-7))))>>(pos-7)) & 0xFF;
    //printf("%x\n",((val & ((0xFF << (pos-7))))>>(pos-7)) & 0xFF);
    pos=15;
    read_val();
   one_count++;

   }  
 else
   {
    temp_val=val << 16;
    read_val();
    val=val | temp_val;
    pos=pos+16;
   }

  }

}

int min(int x)
{
	if(x > (255-x))
		return(255-x);
    else
       return(x);
}

void post_process(void)
{

int k=0;
int theta,delta[48];

 if(ref_block==1)
 {

  delta[0]=temp[0];
  sample[y]=delta[0];
  y=y+1;
  for (k=1;k<=15;k++)
   {
    theta=min(sample[y-1]);
    if(temp[k] <= 2*theta)
     {
	   if(temp[k]%2==0)
		 delta[k]=temp[k]/2;
	   else
		 delta[k]=-1*(temp[k]+1)/2;
     }
   else
    {
	 if (theta==sample[y-1])
		 delta[k]=temp[k]-theta;
	 else
        delta[k]=theta-temp[k];
    }

sample[y]=sample[y-1]+delta[k];
y++;

 }

}
else if(ref_block==0)
{
  theta=min(sample[y-1]);
  if(temp[0] <= 2*theta)
     {
	   if(temp[0]%2==0)
		 delta[0]=temp[0]/2;
	   else
		 delta[0]=-1*(temp[0]+1)/2;
     }
   else
    {
	 if (theta==(sample[y-1]))
		 delta[0]=temp[0]-theta;
	 else
        delta[0]=theta-temp[0];
    }

   sample[y++]=sample[y-1]+delta[0];

  for (k=1;k<=15;k++)
   {
    theta=min(sample[y-1]);
    if(temp[k] <= 2*theta)
     {
	   if(temp[k]%2==0)
		 delta[k]=temp[k]/2;
	   else
		 delta[k]=-1*(temp[k]+1)/2;
     }
   else
    {
	 if (theta==sample[y-1])
		 delta[k]=temp[k]-theta;
	 else
        delta[k]=theta-temp[k];
    }

sample[y++]=sample[y-1]+delta[k];

 }
}
dummy=0;

}

void look_header(void)
 {

  // read the value
//read_val();
fscanf(fp1,"%lx",&val);
if(val==0xAA55)
 {
 fscanf(fp1,"%lx",&val);
  // read the second one
  if(val==0xAA55)
   {
    one_more=1;
   }
  else
   {
   one_more=0;
   }
 }
else
 {
 one_more=0;
 fscanf(fp1,"%lx",&val);
  if(val==0xAA55)
   {
    fscanf(fp1,"%lx",&val);
    // read the second one
     if(val==0xAA55)
      {
       one_more=1;
      }
     else
      {
      one_more=0;
      }
   }
 }

} 


void main()
{
one_more=0;
fp2=fopen("d.txt","w");
fp1=fopen("c.txt","r");
// firts read for the header
while((!one_more) && (!feof(fp1)))
{
fscanf(fp1,"%lx",&val);//read_val();
if(val==0xAA55)
 {
  fscanf(fp1,"%lx",&val);
  if(val==0xAA55)
  one_more=1;
  else
  one_more=0;
 }
else
 {
 one_more=0;
 }

}

if(!one_more)
{
printf(" No header Found");
exit(0);
}
while(one_more)
{

//printf("found header");
read_val();
pos=15;
ref_block=1;
while(y<512)
{

find_option();

 if(ref_block==1)
  {
  index=0;
  one_count=14;
  decomp_nocomp(); // to read the refference sample
  }
else
 {
 index=0;
 one_count=0;
 }
if(kID==0)
 {
//one_count=0; 
zero_count=0;
 zero_block_flg=0;
 decomp_zeroblk();
 zero_block_flg=0;
 if(ref_block==1)
  {
  //fill first block with refference
  for(x=1;x<=15;x++)
  temp[index++]=0;
  post_process();
  zero_count--;
  index=0;
  ref_block=0;
  for(x=zero_count;x>0;x--)
   {
    for(p=0;p<=15;p++)
    temp[index++]=0;
    post_process();
    index=0;
   }
  }
 else
  {
   for(x=zero_count;x>0;x--)
   {
    for(p=0;p<=15;p++)
    temp[index++]=0;
    post_process();
    index=0;

    }

   }
 }
else if(kID==1)
 {
 one_count=0;
 decompK();
 post_process();
 }
else if(kID==7)
 {
 one_count=0;
 decomp_nocomp();
 post_process();
 }
else
 {

 one_count=0;
 decompK();
 if(ref_block==1)
 index=1;
 else
 index=0;
 append_count=0;
 appendLSB();
 post_process();

 }
ref_block=0;
zero_count=0;
one_count=0;
index=0;


}

if(!sync_lost)
{
 for(x=0;x<512;x++)
 {
 fprintf(fp2,"0x%lx\n",sample[x]);
 }
look_header();
}

else
 {
 // already header found
 for(x=0;x<y_sync_lost;x++)
 fprintf(fp2,"0x%lx\n",sample[x]); // write the recovered values
 for(x=y_sync_lost;x<512;x++)
 fprintf(fp2,"0xFFFF\n"); // fill filler
 one_more=1;
 sync_lost=0; 
 y_sync_lost=0;
 }



ref_block=1;
y=0;
one_count=0;
zero_count=0;
index=0;
}
//printf("completed");
//getch();
};
