// YOU CAN USE ENVVIRONMENT VARIABLE TO CHANGE THE SEED.
// GSL_RNG_SEED=123 ./out



#include<iostream>
#include<cmath>
using namespace std;

#include<gsl/gsl_rng.h>
#include<gsl/gsl_randist.h>

int make_matrix(gsl_rng* r, int n, int p, int* matx){// Distribute n counts to matrix with size p
	for(int i=0; i<p; i++){ // Initialize matrix (113 bins)
		matx[i]=0;
	}

	for(int i=0; i<n; i++){ // Random value following Binomial distribution will be a pseudo count.  Stored to matrix.
		unsigned int k=gsl_ran_binomial(r, 0.5, p/2);
		matx[k]++;
	}

	for(int i=0; i<p; i++){  // Normalize.
		matx[i]=matx[i]%256;
	}


}

int main(void){
	const gsl_rng_type *T;
	gsl_rng *r;
	int n=1000;
	int p=113;  // Periodic each 113
	int matx[p];
	
	/** create a generator chosen by the environment variable GSL_RNG_TYPE **/
	gsl_rng_env_setup();
	T= gsl_rng_default;
	r=gsl_rng_alloc(T);
	uint8_t k;

	printf("aadd aadd ");

	int global=2;

	for(int ip=0; ip<80; ip++){
		make_matrix(r, n, p, matx);

		for(int i=0; i<p; i++){
			printf("%02x", matx[i]);
			if(global%2==1)printf(" ");
			if(global%32==29)printf("\n");
			global++;
		}
	}
	printf("\n");


	return 0;
}
