
// File: index.xml

// File: classIrfPac_1_1Encode_1_1BitBuffer.xml
%feature("docstring") IrfPac::Encode::BitBuffer "

Class to treat bit stream.

The bit treatment is not well supported by C++, I have made useful
buffer for treating bit stream. This BitBuffer class is the first
implementation, only for writing buffer.

The BitBuffer class has two buffers: byte buffer and bit buffer. The
byte buffer conserves a series of byte stream, and the bit buffer is
for a remaining bits. You can add bit stream by appendLBits() and
appendMBits() methods. The size of the bit buffer does not exceed 8:
if the bit buffer size exceed 8, the first 8 bits are converted to 1
byte storing to the byte buffer. You can also add padding to 8 bit by
paddingToBoundary() method. Note that the bit buffer is ignored in
most methods.

When you want the buffered byte stream for further processing, you can
use getBuffer() method. Also, write() method will dump the stream to
the specified file pointer in a binary format.

C++ includes: BitBuffer.h ";

%feature("docstring")  IrfPac::Encode::BitBuffer::BitBuffer "IrfPac::Encode::BitBuffer::BitBuffer() ";

%feature("docstring")  IrfPac::Encode::BitBuffer::~BitBuffer "IrfPac::Encode::BitBuffer::~BitBuffer() ";

%feature("docstring")  IrfPac::Encode::BitBuffer::BitBuffer "IrfPac::Encode::BitBuffer::BitBuffer(const BitBuffer &buf) ";

%feature("docstring")  IrfPac::Encode::BitBuffer::getSize "size_t
IrfPac::Encode::BitBuffer::getSize()

Obtain the size of the byte buffer in byte. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::getBitSize "size_t
IrfPac::Encode::BitBuffer::getBitSize()

Obtain the total size of both the byte and bit buffers in bits. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::getBuffer "uint8_t*
IrfPac::Encode::BitBuffer::getBuffer()

Obtain the pointer to the buffer. You need to delete[] the obtained
pointer when it becomes useless.

Obtain the pointer to the buffer. The buffer is newly created,
therefore the buffer should be delete[]ed after the use.

The contents of the subbuffer is disregarded. You have to use
paddingToBoundary(uint8_t) method in order to fill-up the remaining
subbuffer. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::appendLBits "void
IrfPac::Encode::BitBuffer::appendLBits(uint8_t value, size_t bits)

Append bit stream of the specified value with specified number of bits
from LSB. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::appendMBits "void
IrfPac::Encode::BitBuffer::appendMBits(uint8_t value, size_t bits)

Append bit stream of the specified value with specified number of bits
from MSB. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::atBoundary "bool
IrfPac::Encode::BitBuffer::atBoundary()

Returns true if the bit pointer is at the 8 bit boundary. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::paddingToBoundary "void IrfPac::Encode::BitBuffer::paddingToBoundary(uint8_t zero_or_one)

Make a padding with specified value up to the 8 bit boundary.

This operation does affect the getSize() or getBitSize() operation. If
you want to know the number of bits without padding, you must call
getBitSize() method before calling paddingToBoundary(). ";

%feature("docstring")  IrfPac::Encode::BitBuffer::showAllBuffer "void
IrfPac::Encode::BitBuffer::showAllBuffer(FILE *fp)

Print contents of the byte buffer and bit buffer. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::showBuffer "void
IrfPac::Encode::BitBuffer::showBuffer(FILE *fp)

Print contents of the byte buffer. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::showSubBuffer "void
IrfPac::Encode::BitBuffer::showSubBuffer(FILE *fp)

Print contents of the bit buffer. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::print "void
IrfPac::Encode::BitBuffer::print(FILE *fp)

Print the contents of buffer.

The byte buffer is printed. Bit buffer is ignored. ";

%feature("docstring")  IrfPac::Encode::BitBuffer::write "void
IrfPac::Encode::BitBuffer::write(FILE *fp)

Write the contents of buffer.

The byte buffer is wrote in binary. Bit buffer is ignored. File
pointer fp should be opened in binary mode. ";


// File: classByteSpectrum__test.xml
%feature("docstring") ByteSpectrum_test "";

%feature("docstring")  ByteSpectrum_test::setUp "void
ByteSpectrum_test::setUp() ";

%feature("docstring")  ByteSpectrum_test::tearDown "void
ByteSpectrum_test::tearDown() ";


// File: classIrfPac_1_1SaraPac_1_1CenaAccumSclMatx.xml
%feature("docstring") IrfPac::SaraPac::CenaAccumSclMatx "

CENA accumulation scale matrix.

CENA accumulation scale matrix are counters for 3 channels
corresponding to energy and phase values. The data consists of n_e *
n_p * 4 array of uint8_t type. Each uint8_t type data (so-called raw
value) will be decompressed by liblinlog library into 32 bit (uint32_t
type).

Normally this accumulation scale matrix is not instanced directory.
The CenaPacket class will create the instance by using
CenaPacket::getAccumSclMatx() method.

See:  liblinlog libarary.

C++ includes: CenaAccumSclMatx.h ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::CenaAccumSclMatx "IrfPac::SaraPac::CenaAccumSclMatx::CenaAccumSclMatx(uint8_t *stream,
int n_e, int n_p)

Instance CENA accumulation scale matrix. ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::~CenaAccumSclMatx "IrfPac::SaraPac::CenaAccumSclMatx::~CenaAccumSclMatx() ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::getRaw "uint8_t IrfPac::SaraPac::CenaAccumSclMatx::getRaw(int i_energy, int
i_phase, int i_counter)

Returns the raw value of accumulation scaling matrix for specified
energy, phase, and counter.

The value is transfered by 8 bit (0-255), which is 32-bit log-
compressed value. This method returns raw value (0-255).

(For developer) The data stream will be re-structured to be [E, P, C],
where E is the number of energy, P is the number of phase, and C is
the number of counter (4 in the data stream while the real number is
3: the last index is just a padding). ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::hasData "bool IrfPac::SaraPac::CenaAccumSclMatx::hasData()

Returns true if the accumulation scaling matrix has data. ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::get "uint32_t IrfPac::SaraPac::CenaAccumSclMatx::get(int i_energy, int
i_phase, int i_counter)

Returns the value of accumulation scaling matrix for specified energy,
phase, and counter.

The value treansfered is log-compressed from 32 bit to 8 bit. See:
also getRawValue(i_energy, i_phase, i_counter); ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::collapseEnergyRaw "uint32_t
IrfPac::SaraPac::CenaAccumSclMatx::collapseEnergyRaw(int i_phase, int
i_counter) ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::collapsePhaseRaw "uint32_t
IrfPac::SaraPac::CenaAccumSclMatx::collapsePhaseRaw(int i_energy, int
i_counter) ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::collapseAllRaw "uint32_t
IrfPac::SaraPac::CenaAccumSclMatx::collapseAllRaw(int counter) ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::dumpAll "void IrfPac::SaraPac::CenaAccumSclMatx::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaAccumSclMatx::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::getValues "T * IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::dumpAll "virtual void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaAccumSclMatx::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classCenaAccumSclMatx__test.xml
%feature("docstring") CenaAccumSclMatx_test "";

%feature("docstring")  CenaAccumSclMatx_test::CPPUNIT_TEST_SUITE "CenaAccumSclMatx_test::CPPUNIT_TEST_SUITE(CenaAccumSclMatx_test) ";

%feature("docstring")  CenaAccumSclMatx_test::CPPUNIT_TEST "CenaAccumSclMatx_test::CPPUNIT_TEST(testDirectInstance) ";

%feature("docstring")  CenaAccumSclMatx_test::CPPUNIT_TEST "CenaAccumSclMatx_test::CPPUNIT_TEST(testInstance) ";

%feature("docstring")  CenaAccumSclMatx_test::CPPUNIT_TEST "CenaAccumSclMatx_test::CPPUNIT_TEST(testValue) ";

%feature("docstring")  CenaAccumSclMatx_test::CPPUNIT_TEST_SUITE_END "CenaAccumSclMatx_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  CenaAccumSclMatx_test::testDirectInstance "void CenaAccumSclMatx_test::testDirectInstance() ";

%feature("docstring")  CenaAccumSclMatx_test::testInstance "void
CenaAccumSclMatx_test::testInstance() ";

%feature("docstring")  CenaAccumSclMatx_test::testValue "void
CenaAccumSclMatx_test::testValue() ";


// File: classIrfPac_1_1SaraPac_1_1AscFmt_1_1CenaBmuReader.xml
%feature("docstring") IrfPac::SaraPac::AscFmt::CenaBmuReader "

BMU file reader for CENA.

BMU file is generated by SaraSimpleDemulApp. This is a start point of
high-level analysis.

The usage is simple:    CenaBmuReader* bmu = new CenaBmuReader();
bmu->readFile(\"/path/to/bmu/swim_xxx.bmu\"); CenaPacketArray *arr =
getArray();  // Here you can get the CenaPacketArray    delete bmu

I'm not sure what happens if you read multiple data, especially the
same BMU file.

C++ includes: CenaBmuReader.h ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::CenaBmuReader::~CenaBmuReader "IrfPac::SaraPac::AscFmt::CenaBmuReader::~CenaBmuReader() ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::CenaBmuReader::readFile "void
IrfPac::SaraPac::AscFmt::CenaBmuReader::readFile(char *fname) ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::CenaBmuReader::getArray "CenaPacketArray*
IrfPac::SaraPac::AscFmt::CenaBmuReader::getArray()

Returns the read CenaPacket. ";


// File: classCenaCntrDump.xml
%feature("docstring") CenaCntrDump "";

%feature("docstring")  CenaCntrDump::CenaCntrDump "CenaCntrDump::CenaCntrDump(char *dirname) ";

%feature("docstring")  CenaCntrDump::~CenaCntrDump "CenaCntrDump::~CenaCntrDump() ";

%feature("docstring")  CenaCntrDump::flush "void
CenaCntrDump::flush() ";

%feature("docstring")  CenaCntrDump::close "void
CenaCntrDump::close() ";

%feature("docstring")  CenaCntrDump::add "void
CenaCntrDump::add(CenaPacket *cena, TimeConversion *tconv) ";


// File: classIrfPac_1_1SaraPac_1_1CenaFastHkPacket.xml
%feature("docstring") IrfPac::SaraPac::CenaFastHkPacket "

Implementation of CENA HK packet in CENA science packet.

The definition of the packet contents is described in Table 19 in CHA-
SARA-DS-0006.

C++ includes: CenaFastHkPacket.h ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::CenaFastHkPacket "IrfPac::SaraPac::CenaFastHkPacket::CenaFastHkPacket(uint8_t *stream,
size_t size) ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::CenaFastHkPacket "IrfPac::SaraPac::CenaFastHkPacket::CenaFastHkPacket(uint8_t *stream)
";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::~CenaFastHkPacket "IrfPac::SaraPac::CenaFastHkPacket::~CenaFastHkPacket() ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::dumpAll "void IrfPac::SaraPac::CenaFastHkPacket::dumpAll(void)

Dump a detailed information into stdout. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::dumpAll "void IrfPac::SaraPac::CenaFastHkPacket::dumpAll(FILE *fp)

Dump a detailed information into specified file. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvMain "bool
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvMain()

return Flag P ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvSafety "bool
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvSafety()

return Flag S ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvOnEna "bool
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvOnEna()

return Flag PE ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvLvlEna "bool
IrfPac::SaraPac::CenaFastHkPacket::getFlagHvLvlEna()

return Flag SE ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getFlagError
"bool IrfPac::SaraPac::CenaFastHkPacket::getFlagError()

return Flag ER ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getHvMain "uint16_t IrfPac::SaraPac::CenaFastHkPacket::getHvMain()

DV2-3, H1Level. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getHvStartMcp "uint16_t
IrfPac::SaraPac::CenaFastHkPacket::getHvStartMcp()

DV4-5, H2Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getHvStopMcp
"uint16_t IrfPac::SaraPac::CenaFastHkPacket::getHvStopMcp()

DV6-7, H3Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getHvTof "uint16_t IrfPac::SaraPac::CenaFastHkPacket::getHvTof()

DV8-9, H4Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getHvDef "uint16_t IrfPac::SaraPac::CenaFastHkPacket::getHvDef()

DV10-11, H5Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getTempIFE "uint16_t IrfPac::SaraPac::CenaFastHkPacket::getTempIFE()

DV12-13, TempIFE. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getTempHVPS
"uint16_t IrfPac::SaraPac::CenaFastHkPacket::getTempHVPS()

DV14-15,TempHVPS. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getSv1Table
"uint8_t IrfPac::SaraPac::CenaFastHkPacket::getSv1Table()

DV16[3:0], SV1_TABLE, SV_WAVE1. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getSv2Table
"uint8_t IrfPac::SaraPac::CenaFastHkPacket::getSv2Table()

DV16[7:4], SV2_TABLE, SV_WAVE2A. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getSv3Table
"uint8_t IrfPac::SaraPac::CenaFastHkPacket::getSv3Table()

DV17[3:0], SV3_TABLE, SV_WAVE2B. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getSv4Table
"uint8_t IrfPac::SaraPac::CenaFastHkPacket::getSv4Table()

DV17[7:4], SV4_TABLE, SV_LENS. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getSvTable "uint8_t IrfPac::SaraPac::CenaFastHkPacket::getSvTable(int SvName)

An accessor of SV table of specified SV names.

Parameters:
-----------

SvName:  either SV_WAVE1, SV_WAVE2A, SV_WAVE2B, or SV_LENS.

See:   getSv1Table, getSv2Table, getSv3Table, getSv4Table ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getPsyncCntr
"uint16_t IrfPac::SaraPac::CenaFastHkPacket::getPsyncCntr()

DV34-35, Number of sync pulses received from DPU since IFE power on.
";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getBaseCntr
"uint16_t IrfPac::SaraPac::CenaFastHkPacket::getBaseCntr()

DV36-37, Number of sync pulse intervals clapsed since IFE power on. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getObsModeRaw "uint8_t
IrfPac::SaraPac::CenaFastHkPacket::getObsModeRaw()

DV18. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getObsModeSync "uint8_t
IrfPac::SaraPac::CenaFastHkPacket::getObsModeSync()

DV18, B7. 0 is synchronous mode, 1 is asynchronous mode. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getObsModeSensor "uint8_t
IrfPac::SaraPac::CenaFastHkPacket::getObsModeSensor()

DV18 B1 and B0. 00 is coincident, 01 is counter, 10 is enginerring and
11 is not defined. ////// Below (DV16-) is not yet implemented. //////
Implementation would also be needed to swig interface file. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getTotalStartCounts "uint16_t
IrfPac::SaraPac::CenaFastHkPacket::getTotalStartCounts()

DV102-103. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getTotalStopCounts "uint16_t
IrfPac::SaraPac::CenaFastHkPacket::getTotalStopCounts()

DV104-105. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::getTotalCoinCounts "uint16_t
IrfPac::SaraPac::CenaFastHkPacket::getTotalCoinCounts()

DV106-107. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getSvMonitor
"uint16_t IrfPac::SaraPac::CenaFastHkPacket::getSvMonitor(int SvName,
int level)

get SV Monitor of specified Name and level.

Parameters:
-----------

SvName:  either SV_WAVE1, SV_WAVE2A, SV_WAVE2B, or SV_LENS.

level:  [1,8] ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaFastHkPacket::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getValues "T * IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaFastHkPacket::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classCenaFastHkPacket__test.xml
%feature("docstring") CenaFastHkPacket_test "";

%feature("docstring")  CenaFastHkPacket_test::CPPUNIT_TEST_SUITE "CenaFastHkPacket_test::CPPUNIT_TEST_SUITE(CenaFastHkPacket_test) ";

%feature("docstring")  CenaFastHkPacket_test::CPPUNIT_TEST "CenaFastHkPacket_test::CPPUNIT_TEST(testGeneration) ";

%feature("docstring")  CenaFastHkPacket_test::CPPUNIT_TEST "CenaFastHkPacket_test::CPPUNIT_TEST(test12b) ";

%feature("docstring")  CenaFastHkPacket_test::CPPUNIT_TEST "CenaFastHkPacket_test::CPPUNIT_TEST(testbit) ";

%feature("docstring")  CenaFastHkPacket_test::CPPUNIT_TEST "CenaFastHkPacket_test::CPPUNIT_TEST(testSv) ";

%feature("docstring")  CenaFastHkPacket_test::CPPUNIT_TEST_SUITE_END "CenaFastHkPacket_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  CenaFastHkPacket_test::testGeneration "void
CenaFastHkPacket_test::testGeneration() ";

%feature("docstring")  CenaFastHkPacket_test::testSv "void
CenaFastHkPacket_test::testSv() ";

%feature("docstring")  CenaFastHkPacket_test::test12b "void
CenaFastHkPacket_test::test12b() ";

%feature("docstring")  CenaFastHkPacket_test::testbit "void
CenaFastHkPacket_test::testbit() ";


// File: classCenaMassDump.xml
%feature("docstring") CenaMassDump "";

%feature("docstring")  CenaMassDump::CenaMassDump "CenaMassDump::CenaMassDump(char *dirname) ";

%feature("docstring")  CenaMassDump::~CenaMassDump "CenaMassDump::~CenaMassDump() ";

%feature("docstring")  CenaMassDump::flush "void
CenaMassDump::flush() ";

%feature("docstring")  CenaMassDump::close "void
CenaMassDump::close() ";

%feature("docstring")  CenaMassDump::add "void
CenaMassDump::add(CenaPacket *cena, TimeConversion *tconv) ";


// File: classIrfPac_1_1SaraPac_1_1CenaMatrix.xml
%feature("docstring") IrfPac::SaraPac::CenaMatrix "

CENA accumulation matrix class.

This class is a part of CenaPacket, which contains the raw stream of
CENA accumulation matrix. This is either compressed or uncompressed.
If the first 4 byte start with AA55AA55, this matrix is compressed.

C++ includes: CenaMatrix.h ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::CenaMatrix "IrfPac::SaraPac::CenaMatrix::CenaMatrix(uint8_t *packet, int size) ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::~CenaMatrix "IrfPac::SaraPac::CenaMatrix::~CenaMatrix() ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::decompress "CenaMatrix * IrfPac::SaraPac::CenaMatrix::decompress()

Decompress the packet.

Decompress the packet and create new CenaMatrix instance, and return
the pointer to it.

Exceptions:
-----------

NOT_COMPRESSED:  if the packet is not compressed.

ILLEGAL_PACKET:  if the packet is illegally formatted.

DECOMPRESSION_FAILED:  if the decompression failed. ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::interpret "CenaScienceDataPacket * IrfPac::SaraPac::CenaMatrix::interpret(uint8_t
tm_mode, uint8_t nc, uint8_t ne, uint8_t np, uint8_t nm)

Interpret CenaMatrix, and convert to datatype depending on TM mode.

The method interpret CenaMatrix up to TM mode. The returned type is a
derived class of CenaScienceDataPacket, up to TM mode as well. For
example, you want to interpret the packet to be mass accumulation
mode, the syntax is like                                 CenaPacket*
cenaPacket = .... ;   // If you have already CenaPacket,
CenaMatrix* cenaMatrix = cenaPacket -> getCenaMatrix();   // Obtain
CenaMatrix,                                 CenaSciMassAcc* scidata =
cenaMatrix -> interpret ( cenaPacket->getTMmode(),
cenaPacket->getNrCh(), cenaPacket->getNrEne(),
cenaPacket->getNrPhase(), cenaPacket->getNrMass()   ); ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::interpret "CenaScienceDataPacket* IrfPac::SaraPac::CenaMatrix::interpret() ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::setParameters "void IrfPac::SaraPac::CenaMatrix::setParameters(uint8_t tm_mode,
uint8_t nc, uint8_t ne, uint8_t np, uint8_t nm) ";

%feature("docstring")
IrfPac::SaraPac::CenaMatrix::getExpectedMatrixSize "int
IrfPac::SaraPac::CenaMatrix::getExpectedMatrixSize(uint8_t tm_mode,
uint8_t nc, uint8_t ne, uint8_t np, uint8_t nm)

Returns the science matrix size in byte (the same as the size of
array).

Returns the size of the matrix in byte. The value is the same as the
size of array. The size is up to the TM mode. If unknown TM mode is
specified, -1 is returned.Todo Check non-process mode if needed. ";

%feature("docstring")
IrfPac::SaraPac::CenaMatrix::getExpectedMatrixSize "int
IrfPac::SaraPac::CenaMatrix::getExpectedMatrixSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::dumpAll "void
IrfPac::SaraPac::CenaMatrix::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::dumpByteStream "size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::dumpHexStream "size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::dumpHexStream "virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::dumpAll "virtual
void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaMatrix::equals "virtual
bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classCenaMatrix__test.xml
%feature("docstring") CenaMatrix_test "";


// File: classIrfPac_1_1SaraPac_1_1CenaPacket.xml
%feature("docstring") IrfPac::SaraPac::CenaPacket "

CENA packet.

The packet is an implementation of CENA packet. Actually because the
DPU packet is so complicated and the documentation is not so well
structured, it is difficult to understand the packet contents. CENA
packet here is a data stream constituting from stuff, HK and science
data. The CENA packet should start from 0xAAAA5555 (const static
uint32_t CENA_SCI_ID).

Stuff is various information, including time and mode. Method for
accessing for these information is currently implemented at CenaPacket
class.

HK is a health check data consistute of 119 byte subpacket. The packet
is implemented as CenaFastHkPacket class.

Science data is a matrix, whose structure depends on modes. There are
two types of matrix data. One is accumulation scaling matrix data,
which only exist coincidence mode (Details of mode are written in
CenaMode page). The implementation is in the CenaAccumSclMatx class.
The other class is accumulation matrix data. The implementation is at
the CenaMatrix class. The CenaMatrix class instances are sometimes
compressed, and they are converted to a subclass of
CenaScienceDataPacket (up to mode) to get data.

|-----
CenaPacket-------------------------------------------------------------------------------|
|--- Stuff ---|--- CenaFastHkPacket ---|--- CenaAccumSclMatx ---|---
CenaMatrix -----------------| | (convert to) |---
CenaScienceDataPacket ---|

Futaana

C++ includes: CenaPacket.h ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::CenaPacket "IrfPac::SaraPac::CenaPacket::CenaPacket(uint8_t *stream, size_t size)
";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::~CenaPacket "IrfPac::SaraPac::CenaPacket::~CenaPacket() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::dumpAll "void
IrfPac::SaraPac::CenaPacket::dumpAll(void)

Dump a detailed information into stdout. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::dumpAll "void
IrfPac::SaraPac::CenaPacket::dumpAll(FILE *fp)

Dump a detailed information into specified file. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::printParamsTbl "void IrfPac::SaraPac::CenaPacket::printParamsTbl(FILE *fp)

Deprecated Use identical method of printParamsTbl2(fp, NULL) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::printParamsTbl2 "void IrfPac::SaraPac::CenaPacket::printParamsTbl2(FILE *fp,
TimeConversion *tconv)

Same as printParamsTbl3(fp, TimeConversion, false) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::printParamsTbl3 "void IrfPac::SaraPac::CenaPacket::printParamsTbl3(FILE *fp,
TimeConversion *tconv, bool useUtc)

If useUtc == true then use interpolated time from the demultiplexed
packet header instead of directly converted time from inside the
packet. If false, the time is obtained from the OBT timestamp in the
packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getHeadMagicNumber
"uint32_t IrfPac::SaraPac::CenaPacket::getHeadMagicNumber()

Returns field of the packet for the identifier of CENA science packet.

Return the field of identifier of the CENA science packet. First and
second words in the memory map. In the DPU document, it is specified
as 0xAAAA5555. This value is defined as CENA_SCI_ID field. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getObtTime "uint64_t IrfPac::SaraPac::CenaPacket::getObtTime()

Returns 48 bit BMU OBT @ marker.

This time is the OBT time synchronized to DPU time.

The OBT is in so-called 1750 format. The function returns the OBT as
in the stream. The interpretation of the value is specified in the
project. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getObtTimeInMsec "double IrfPac::SaraPac::CenaPacket::getObtTimeInMsec()

Returns BMU OBT @ marker in Msec.

The OBT time at marker (synchronization) is converted to the unit of
msec.Deprecated Use getMarkerObt() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getMarkerObt "double IrfPac::SaraPac::CenaPacket::getMarkerObt()

Returns the marker time in OBT time format. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getMarkerDpu "double IrfPac::SaraPac::CenaPacket::getMarkerDpu()

Returns the marker time in DPU format. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getObsTimeDpu "double IrfPac::SaraPac::CenaPacket::getObsTimeDpu()

Returns the observation time in DPU format. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getObsTimeObt "double IrfPac::SaraPac::CenaPacket::getObsTimeObt()

Returns the observation time in OBT format calculated by
getMarkerObt(), getMarkerDpu(), getObsTimeDpu() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getDpuTime "uint16_t IrfPac::SaraPac::CenaPacket::getDpuTime()

Returns DPU time at marker (word=6)

DPU time at marker (when synchronized). The unit is 31.25 msec. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getTcountDpu "uint16_t IrfPac::SaraPac::CenaPacket::getTcountDpu()

Returns Tcount value from timer (DPU??).

The fraction of the DPU time at marker in 2.048 msec unit. ";

%feature("docstring")
IrfPac::SaraPac::CenaPacket::getDpuTimeMarkerInMsec "double
IrfPac::SaraPac::CenaPacket::getDpuTimeMarkerInMsec()

Returns DPU time @ Marker in msec.

Actual formulation is getDpuTime()*31.25 +
getTcountDpu()*2.048.Deprecated Use getMarkerDpu(). ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getDataAcquisTime
"uint16_t IrfPac::SaraPac::CenaPacket::getDataAcquisTime()

(OBSOLETE) Returns Data acquisition time (word-8)

Deprecated This method is renamed to getEndIntegCycleTime(). ";

%feature("docstring")
IrfPac::SaraPac::CenaPacket::getEndIntegCycleTime "uint16_t
IrfPac::SaraPac::CenaPacket::getEndIntegCycleTime()

Returns the DPU time of the end of data acquisition (word-8)

Return the DPU time when the data comes. 31.25 msec unit. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getTcountAcq "uint16_t IrfPac::SaraPac::CenaPacket::getTcountAcq()

Returns Tcount value from timer for the end of the data aquisition
time.

The fraction part of the data acuisition time. 2.048 msec unit. ";

%feature("docstring")
IrfPac::SaraPac::CenaPacket::getDataAcquisTimeInMsec "double
IrfPac::SaraPac::CenaPacket::getDataAcquisTimeInMsec()

Return the DPU time at the end of integration cycles.

Return the DPU time in msec of the end of integration cycles. The
calculation is done as follows. This may be wrong, or true.... I'm not
sure.                 int t = getEndIntegCycleTime();
int dt = getTcountAcq();                 double acTime = t*31.25 + dt
* 2.048; return acTime;

Deprecated Use getObsTimeDpu(); ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getEpochTimeInMsec
"double IrfPac::SaraPac::CenaPacket::getEpochTimeInMsec()

Return the observation time in msec with OBT time origin.

Actual formulation is getObtTimeInMsec() + ( getDataAcquisTimeInMsec()
- getDpuTimeMarkerInMsec()  )

Deprecated Use getObsTimeObt() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getUniversalTime "double IrfPac::SaraPac::CenaPacket::getUniversalTime(TimeConversion
*tconv)

Return the universal time in seconds [Origin is the UNIX epoch time as
time_t].

Return the universal time in seconds. Note that this value is
calculated from the packet contents after TimeConversion. ";

%feature("docstring")
IrfPac::SaraPac::CenaPacket::getUniversalTimeInMsec "DEPRECATED
double IrfPac::SaraPac::CenaPacket::getUniversalTimeInMsec()

Returns the Universal Time in msec. (Exactly saying, this method
returns the time after the epoch).

Actual formulation is getObtTimeInMsec() + ( getDataAcquisTimeInMsec()
- getDpuTimeMarkerInMsec()  )

Deprecated Use getUniversalTime() or getEpochInMsec(). You can replace
it getUniversalTime(NULL)*1000. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::get4sCycleCntr "uint16_t IrfPac::SaraPac::CenaPacket::get4sCycleCntr()

Returns 4S cycle counter (word-10)

Returns the cyclic counter of CenaPacket. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getPacketCounter "uint16_t IrfPac::SaraPac::CenaPacket::getPacketCounter()

An alias for get4sCycleCntr() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getBinningPrm "uint16_t IrfPac::SaraPac::CenaPacket::getBinningPrm()

Binning parameter (word_11)

Returns the binning parameters. Bit 15 is the channel, where 0 is 1 ch
and 1 is 7 chs.

Bit 14-12 is the energy, n(E)-1.

Bit 11-7 is the Phase, n(P)-1.

Bit 6-0 is the Mass, n(M)-1. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getNrCh "uint8_t
IrfPac::SaraPac::CenaPacket::getNrCh()

Number of channel (word-11/bit-15)

Number of channel (1 or 7) is returned. If 11th word 15th bit is 0, 1
is returned. If 11th word 15th bit is 1, 7 is returned. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getNrEne "uint8_t
IrfPac::SaraPac::CenaPacket::getNrEne()

Number of energy (word-11/bit-14,13,12)

Number of energy is returned. B14-B12 : n(E)-1 ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getNrPhase "uint8_t IrfPac::SaraPac::CenaPacket::getNrPhase()

Number of phase (word-11/bit-11 to 7)

Number of phase is returned. B11-B07 : n(P)-1 ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getNrMass "uint8_t IrfPac::SaraPac::CenaPacket::getNrMass()

Number of mass (word-11/bit-6 to 0)

Number of mass is returned. B6-B0 : n(M)-1 ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getNrCycles "uint16_t IrfPac::SaraPac::CenaPacket::getNrCycles()

number of cycles for integration (word-12) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getModes "uint16_t IrfPac::SaraPac::CenaPacket::getModes()

modes (word-13)

Returns the modes. Logical bit, 1 as ON, 0 as OFF. B15: SWIM ON/OFF

B14: CENA ON/OFF

B13: CENA compression

B12-B10: TM mode 010: Non Acc Mode

100: Tof Acc Mode

011: Count Acc Mode

001: Non Process Mode

B9-B8: Mode of Sensor (Not documented in the DPU doc)

While B7-B0 is considered as first byte of HK, but this values are
included in the returned value. You need to disregards low 8 bits. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::isSwimOn "bool
IrfPac::SaraPac::CenaPacket::isSwimOn() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::isCenaOn "bool
IrfPac::SaraPac::CenaPacket::isCenaOn() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::isCenaCompOn "bool IrfPac::SaraPac::CenaPacket::isCenaCompOn()

True if compression is on for the DPU side. (Independent of real
CenaMatrix is compressed or not)

When the rice-compression was enabled on the DPU side, true is
returned. Note that decompress() method will NOT change this status.
See:  isCompressed() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getTMmode "uint8_t IrfPac::SaraPac::CenaPacket::getTMmode()

Get telemetry mode.

See:   CenaMode ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getTMmodeStr "std::string IrfPac::SaraPac::CenaPacket::getTMmodeStr() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getSensorMode "uint8_t IrfPac::SaraPac::CenaPacket::getSensorMode()

Get sensor mode.

See:   CenaMode ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getSensorModeStr "std::string IrfPac::SaraPac::CenaPacket::getSensorModeStr() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getSubcomHkPac "CenaSubcHkPacket * IrfPac::SaraPac::CenaPacket::getSubcomHkPac()

Get subcommuted HK packet.

Get subcom HK packet, which constitute of 119 byte. Starting from the
last byte of the word-13, to the word-72. This is consistent with
Byte-25 to byte 143.

Please delete the obtained packet after use.Deprecated Use
getFastHkPac() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getFastHkPac "CenaFastHkPacket* IrfPac::SaraPac::CenaPacket::getFastHkPac()

Get fast HK packet for CENA.

Get fast HK packet, which constitute of 119 byte, normally every 4
sec. Starting from the last byte of the word-13, to the word-72. This
is consistent with Byte-25 to byte 143.

Please delete the obtained packet after use. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getAccumSclMatx "CenaAccumSclMatx* IrfPac::SaraPac::CenaPacket::getAccumSclMatx()

Get accumulation scale matrix.

The accumulation scale matrix is returned. The length of this packet
varies up to numbers of energy bin and phase bin. This is only for
coincidence mode. In other mode, 0-byte matrix is returned.

Please delete the obtained packet after use. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getCenaMatrix "CenaMatrix* IrfPac::SaraPac::CenaPacket::getCenaMatrix() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getCenaSciCntrAcc
"CenaSciCntrAcc * IrfPac::SaraPac::CenaPacket::getCenaSciCntrAcc()

Returns CENA science data of counter accumulate mode.

Returns the CENA science data matrix of counter accumulate mode. If
the packet is not counter accumulate mode, NULL is returned. If the
packet is compressed, \"Science Matrix is still Compressed\" exception
thrown. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getCenaSciTofAcc "CenaSciTofAcc * IrfPac::SaraPac::CenaPacket::getCenaSciTofAcc()

Returns CENA science data of TOF accumulate mode.

Returns the CENA science data matrix of TOF accumulate mode. If the
packet is not TOF accumulate mode, NULL is returned. If the packet is
compressed, \"Science Matrix is still Compressed\" exception thrown.
";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getCenaSciMassAcc
"CenaSciMassAcc * IrfPac::SaraPac::CenaPacket::getCenaSciMassAcc()

Returns CENA science data of MASS accumulate mode.

Returns the CENA science data matrix of MASS accumulate mode. If the
packet is not MASS accumulate mode, NULL is returned. If the packet is
compressed, \"Science Matrix is still Compressed\" exception thrown.
";

%feature("docstring")
IrfPac::SaraPac::CenaPacket::getCenaSciMassAccE16 "CenaSciMassAccE16
* IrfPac::SaraPac::CenaPacket::getCenaSciMassAccE16()

Returns CENA science data of MASS accumulation mode, but in a generic
energy table.

It returns the CENA mass accumulation mode data, but in a generic
energy table. The generic energy table is implemented in
CenaSciMassAccE16 class, which can be (at least aiming to be) treated
as the same as CenaSciMassAcc mode.

runtime_error is thrown if known error happens. nE!=8

SV table is not uniquely defined.

If the packet is compressed (use decompress() before).

The generic energy table is composed of 16 energies. The CENA measures
8 energies of the 16, up to the SV table. The benefit of this class is
that the data can be treated independent of SV table. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::isMatrixCompressed
"bool IrfPac::SaraPac::CenaPacket::isMatrixCompressed()

Returns true if the CenaMatrix is compressed. (independent of DPU flag
of CenaCompOn)

Check whether the CenaMatrix is compressed. If the CenaMatrix stream
is compressed, true is returned. If user explicitly decompressed by
decompress() method, the returned value is changed. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::decompress "CenaPacket * IrfPac::SaraPac::CenaPacket::decompress()

Returns newly created, rice-decompressed CenaPacket.

Returns the newly created decompressed packet. If the packet is
already decompressed, the copy of this packet is returned. If
decompression failed, NULL is returned. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::isValid "bool
IrfPac::SaraPac::CenaPacket::isValid()

Check whether the packet format is valid for CenaPacket.

Check items are: First 4 byte is 0xaaaa5555

CenaMatrix starts with 0xaa55aa55 or 0xaaddaadd

OBT time is less than 1 year! (Actually it should be less than 21
days, I guess -2009-01-24-)

Todo OBT time check is proper??? ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::hasRawModeData "bool IrfPac::SaraPac::CenaPacket::hasRawModeData()

Checks if there is RAW data available.

The implemented test is theoretically not 100% collision free: It
tests for the presence of a aa01 910x header at the location where the
scaling matrix (for mass maccumulation mode) or the rice compressed
accumulation matrix (count accumulation mode) starts. No collision in
count accumulation mode as in this mode the next data block has a
unique header, but small probability of collision in mass accumulation
mode because the scaling matrix has no header and might therefore
contain aa01910x as data values. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::setUtc "void
IrfPac::SaraPac::CenaPacket::setUtc(double utc) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getUtc "double
IrfPac::SaraPac::CenaPacket::getUtc()

Return UTC in UNIX epoch, or return 0. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getQualityFlag "int IrfPac::SaraPac::CenaPacket::getQualityFlag() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::setQualityFlag "void IrfPac::SaraPac::CenaPacket::setQualityFlag(int qflag) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::newInstance "CenaPacket* IrfPac::SaraPac::CenaPacket::newInstance() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::dumpByteStream "size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::dumpHexStream "size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::dumpHexStream "virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacket::equals "virtual
bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classCenaPacket__test.xml
%feature("docstring") CenaPacket_test "";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST_SUITE "CenaPacket_test::CPPUNIT_TEST_SUITE(CenaPacket_test) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testInstance) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testMagicNumber) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testdump) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testDecomp) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testCenaSciCntrAcc) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testCenaSciCntrAcc2) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testCenaMassAccE16) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testTimeConversion) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testCenaPacketArray) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testCenaPacketArray2) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST "CenaPacket_test::CPPUNIT_TEST(testHash) ";

%feature("docstring")  CenaPacket_test::CPPUNIT_TEST_SUITE_END "CenaPacket_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  CenaPacket_test::testInstance "void
CenaPacket_test::testInstance() ";

%feature("docstring")  CenaPacket_test::testMagicNumber "void
CenaPacket_test::testMagicNumber() ";

%feature("docstring")  CenaPacket_test::testdump "void
CenaPacket_test::testdump() ";

%feature("docstring")  CenaPacket_test::testDecomp "void
CenaPacket_test::testDecomp()

Compression on for original stream ";

%feature("docstring")  CenaPacket_test::test003 "void
CenaPacket_test::test003() ";

%feature("docstring")  CenaPacket_test::testCenaMassAccE16 "void
CenaPacket_test::testCenaMassAccE16() ";

%feature("docstring")  CenaPacket_test::testCenaSciCntrAcc "void
CenaPacket_test::testCenaSciCntrAcc() ";

%feature("docstring")  CenaPacket_test::testCenaSciCntrAcc2 "void
CenaPacket_test::testCenaSciCntrAcc2() ";

%feature("docstring")  CenaPacket_test::testTimeConversion "void
CenaPacket_test::testTimeConversion() ";

%feature("docstring")  CenaPacket_test::testCopyConstructor "void
CenaPacket_test::testCopyConstructor()

This test case is not used because the copy constructor is not
recommended, and not officially surpported. ";

%feature("docstring")  CenaPacket_test::testHash "void
CenaPacket_test::testHash() ";

%feature("docstring")  CenaPacket_test::testCenaPacketArray "void
CenaPacket_test::testCenaPacketArray() ";

%feature("docstring")  CenaPacket_test::testCenaPacketArray2 "void
CenaPacket_test::testCenaPacketArray2() ";


// File: classIrfPac_1_1SaraPac_1_1CenaPacketArray.xml
%feature("docstring") IrfPac::SaraPac::CenaPacketArray "

Array of CENA packet.

Normally you do not need to create this class. This is returned by
CenaFile::getArray().

C++ includes: CenaPacket.h ";

%feature("docstring")
IrfPac::SaraPac::CenaPacketArray::~CenaPacketArray "IrfPac::SaraPac::CenaPacketArray::~CenaPacketArray() ";

%feature("docstring")  IrfPac::SaraPac::CenaPacketArray::append "void
IrfPac::SaraPac::CenaPacketArray::append(CenaPacket *pac) ";

%feature("docstring")  IrfPac::SaraPac::CenaPacketArray::getPacket "CenaPacket* IrfPac::SaraPac::CenaPacketArray::getPacket(int i)

Get the newly generated CenaPacket* of i-th packet.

You have to delete the returned pointer explicitly. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacketArray::get "DEPRECATED CenaPacket* IrfPac::SaraPac::CenaPacketArray::get(int i)

Get the i-th packet. Use getPacket(int) instead.

Deprecated Use getPacket(int) because this method can break the
contents inside the array. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacketArray::getPacketUtc
"double IrfPac::SaraPac::CenaPacketArray::getPacketUtc(int i)

Get the UTC timestamp of the i-th packet without copying the packet.

This is useful when searching for a packet with a specific UTC without
the need to copy each packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaPacketArray::getPacketQualityFlag "int
IrfPac::SaraPac::CenaPacketArray::getPacketQualityFlag(int i)

Get the quality of the i-th packet without copying the packet.

This is useful when searching for a packet with a specific quality
without the need to copy each packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacketArray::size "size_t
IrfPac::SaraPac::CenaPacketArray::size()

Get the number of elements. ";

%feature("docstring")  IrfPac::SaraPac::CenaPacketArray::destroy "void IrfPac::SaraPac::CenaPacketArray::destroy()

Clear the array after destroy all the packet contained. You don't need
to call it directly (ie called from Destructor). ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciCntrAcc.xml
%feature("docstring") IrfPac::SaraPac::CenaSciCntrAcc "

CENA science packet (non-rice-compressed) of counter accumulation
mode.

Count accumulation mode is consititute of [E][P][55] matrix, where E
is energy, P is phase (it is just a time in CENA's case), and
counters.

Counter names are as follows. IDX0_START_RING_SECTOR [4][7]

IDX0_START_RING [4]

IDX0_START_SECTOR [7]

IDX0_STOP_PLATE [8]

IDX0_STOP_MESH [1]

IDX0_COIN_SECTOR [7]  Note that libsadppac index is usually counted
from 0 (zero), even though some document starts from 1 (one). This is
a historical reason, but since many IRF people likes to start from
zero, the index name IDX0_ is recommended.

However, for convention and compatibility, counter names with index
start one areprepared as follows. This is not recommended to be used.
START_RING_SECTOR [4][7]

START_RING [4]

START_SECTOR [7]

STOP_PLATE [8]

STOP_MESH [1]

COIN_SECTOR [7]

See:  Section 10.9 on CHA-SARA-DS-0006

C++ includes: CenaSciCntrAcc.h ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::CenaSciCntrAcc
"IrfPac::SaraPac::CenaSciCntrAcc::CenaSciCntrAcc(uint8_t *pac, int
nEnergy, int nPhase, int nC)

Constructor. Normally one do not need to call the constructor
directly.

The constructor sepcifying the number of energy, phase and counter.
Number of counter is 55. Normally no one does need to call the
constructor. CenaPacket::getCenaSciCntrAcc() will create this class.
";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAcc::~CenaSciCntrAcc "IrfPac::SaraPac::CenaSciCntrAcc::~CenaSciCntrAcc() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getRaw "uint8_t IrfPac::SaraPac::CenaSciCntrAcc::getRaw(int iE, int iP, int
iC)

get 8-bit raw value of the specified energy, phase and counter name.

Parameters:
-----------

iE:  Energy step

iP:  Phase

iC:  Counter name. Using macro IDX0_XXX is recommended. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::get "uint16_t
IrfPac::SaraPac::CenaSciCntrAcc::get(int iE, int iP, int iC)

get linlog decompressed 16-bit value of the specified energy, phase
and counter name.

Parameters:
-----------

iE:  Energy step

iP:  Phase

iC:  Counter name. Using macro IDX0_XXX is recommended. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::dumpAll "void
IrfPac::SaraPac::CenaSciCntrAcc::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::dumpAll "void
IrfPac::SaraPac::CenaSciCntrAcc::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getNrEne "int
IrfPac::SaraPac::CenaSciCntrAcc::getNrEne() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getNrPhase "int IrfPac::SaraPac::CenaSciCntrAcc::getNrPhase() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getNrCounter "int IrfPac::SaraPac::CenaSciCntrAcc::getNrCounter() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::dumpByteStream
"size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::dumpHexStream
"size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::dumpHexStream
"virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getValues "T
* IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAcc::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classCenaSciCntrAcc__test.xml
%feature("docstring") CenaSciCntrAcc_test "";

%feature("docstring")  CenaSciCntrAcc_test::CPPUNIT_TEST_SUITE "CenaSciCntrAcc_test::CPPUNIT_TEST_SUITE(CenaSciCntrAcc_test) ";

%feature("docstring")  CenaSciCntrAcc_test::CPPUNIT_TEST "CenaSciCntrAcc_test::CPPUNIT_TEST(testDirectInstance) ";

%feature("docstring")  CenaSciCntrAcc_test::CPPUNIT_TEST "CenaSciCntrAcc_test::CPPUNIT_TEST(testIndex) ";

%feature("docstring")  CenaSciCntrAcc_test::CPPUNIT_TEST "CenaSciCntrAcc_test::CPPUNIT_TEST(testZeroIndex) ";

%feature("docstring")  CenaSciCntrAcc_test::CPPUNIT_TEST_SUITE_END "CenaSciCntrAcc_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  CenaSciCntrAcc_test::testDirectInstance "void
CenaSciCntrAcc_test::testDirectInstance() ";

%feature("docstring")  CenaSciCntrAcc_test::testZeroIndex "void
CenaSciCntrAcc_test::testZeroIndex() ";

%feature("docstring")  CenaSciCntrAcc_test::testIndex "void
CenaSciCntrAcc_test::testIndex() ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciCntrAccFormatter.xml
%feature("docstring") IrfPac::SaraPac::CenaSciCntrAccFormatter "

Virtual class of CenaSciCntrAcc formatter.

C++ includes: CenaSciCntrAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatter::~CenaSciCntrAccFormatter "virtual
IrfPac::SaraPac::CenaSciCntrAccFormatter::~CenaSciCntrAccFormatter()
";

%feature("docstring")  IrfPac::SaraPac::CenaSciCntrAccFormatter::dump
"virtual void IrfPac::SaraPac::CenaSciCntrAccFormatter::dump(FILE
*fp, CenaSciCntrAcc *pac)=0 ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciCntrAccFormatterCoin.xml
%feature("docstring") IrfPac::SaraPac::CenaSciCntrAccFormatterCoin "

An implementation of CenaSciCntrAccFormatter.

One-line formatter for energy-time diagram for coincidence sectors.
\"nr_of_data nr_of_ene  ene0sect1  ene1sect1 .. eneNsect1 ene0sect2
... eneNsect7\" Maximum nr_of_data is (N=8)*7=56. If less than
maximum, -1 is filled.

C++ includes: CenaSciCntrAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterCoin::~CenaSciCntrAccFormatterCoin
"IrfPac::SaraPac::CenaSciCntrAccFormatterCoin::~CenaSciCntrAccFormatterCoin()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterCoin::dump "void
IrfPac::SaraPac::CenaSciCntrAccFormatterCoin::dump(FILE *fp,
CenaSciCntrAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciCntrAccFormatterStartNC.xml
%feature("docstring") IrfPac::SaraPac::CenaSciCntrAccFormatterStartNC
"

An implementation of CenaSciCntrAccFormatter.

One-line formatter for energy-time diagram for start sectors.
\"nr_of_data nr_of_ene  ene0sect1  ene1sect1 .. eneNsect1 ene0sect2
... eneNsect7\" Maximum nr_of_data is (N=8)*7=56. If less than
maximum, -1 is filled.

C++ includes: CenaSciCntrAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterStartNC::~CenaSciCntrAccFormatterStartNC
"IrfPac::SaraPac::CenaSciCntrAccFormatterStartNC::~CenaSciCntrAccFormatterStartNC()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterStartNC::dump "void
IrfPac::SaraPac::CenaSciCntrAccFormatterStartNC::dump(FILE *fp,
CenaSciCntrAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciCntrAccFormatterStopMesh.xml
%feature("docstring") IrfPac::SaraPac::CenaSciCntrAccFormatterStopMesh
"

An implementation of CenaSciCntrAccFormatter.

One-line formatter for energy-time diagram for stop mesh. \"nr_of_data
nr_of_ene  ene0 ene1 ... eneN\" Maximum nr_of_data is N=8. If less
than maximum, -1 is filled.

C++ includes: CenaSciCntrAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterStopMesh::~CenaSciCntrAccFormatterStopMesh
"IrfPac::SaraPac::CenaSciCntrAccFormatterStopMesh::~CenaSciCntrAccFormatterStopMesh()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterStopMesh::dump "void
IrfPac::SaraPac::CenaSciCntrAccFormatterStopMesh::dump(FILE *fp,
CenaSciCntrAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciCntrAccFormatterStopPlate.xml
%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterStopPlate "

An implementation of CenaSciCntrAccFormatter.

One-line formatter for energy-time diagram for stop plate.
\"nr_of_data nr_of_ene  ene0plate1  ene1plate1 .. eneNplate1
ene0plate2 ... eneNplate8\" Maximum nr_of_data is (N=8)*8=64. If less
than maximum, -1 is filled.

C++ includes: CenaSciCntrAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterStopPlate::~CenaSciCntrAccFormatterStopPlate
"IrfPac::SaraPac::CenaSciCntrAccFormatterStopPlate::~CenaSciCntrAccFormatterStopPlate()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciCntrAccFormatterStopPlate::dump "void
IrfPac::SaraPac::CenaSciCntrAccFormatterStopPlate::dump(FILE *fp,
CenaSciCntrAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaScienceDataPacket.xml
%feature("docstring") IrfPac::SaraPac::CenaScienceDataPacket "

Packet for CENA science data.

The class is a base class for CENA science data classes. Normally one
do not instance this class. Concrete classes is CenaSciMassAcc,
CenaSciTofAcc, CenaSciCntrAcc, and CenaSciNonProcess.

C++ includes: CenaScienceDataPacket.h ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::CenaScienceDataPacket "IrfPac::SaraPac::CenaScienceDataPacket::CenaScienceDataPacket(uint8_t
*stream, size_t size) ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::~CenaScienceDataPacket "virtual
IrfPac::SaraPac::CenaScienceDataPacket::~CenaScienceDataPacket() ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::getStream "uint8_t*
IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaScienceDataPacket::getSize
"size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::getIndexSize "size_t
IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")
IrfPac::SaraPac::CenaScienceDataPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaScienceDataPacket::dumpAll
"virtual void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::CenaScienceDataPacket::dumpAll
"virtual void IrfPac::PacketIntArr< T >::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::CenaScienceDataPacket::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaScienceDataPacket::equals
"virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciencePackage.xml
%feature("docstring") IrfPac::SaraPac::CenaSciencePackage "

A class for dumping CENA science package.

Series of CenaPacket is converted to so-called science package format
which is to be used idlscilib and other programs. The package is
generated also by SaraDemultiplex program. The package is a folder
structure such as:    package_name.pkg -+- cena
+- cenahk +- cenatoff                      +- cenacntr -+- 01hk |
+- 02startnc                      |            +- 03startcoin
|            +- .... |                      +- cenamass -+- 01hk +-
02et                                   +- 03mt +- ... Reading routine
is NOT implemented in libsadppac, however, you can use CenaBmuReader
for the file package_name.pkg/cena in order to reconstruct
CenaPacketArray. Time Conversion Time conversion is represented by an
extended class of TimeConversion. You can set TimeConversion class by
setTimeConversion(TimeConversion) method.

If TimeConversion is set, the program uses the specified time
conversion. If it is not set (default), the dump() method try to call
getUtc() method. In case getUtc() is not defined (this happens if you
read the data from SARA BMU format), no conversion is made (i.e. time
should be very small value close to 1970's).

However, each dump (01hk, 02et ...) yet has a problem of the time
conversion since these formatter uses getUniversalTime(NULL). In
version 2, the difference of the time, i.e. convertedUtc-
getUniversalTime(NULL), where convertedUtc is usually taken from
getUtc() method, is written in the cenatoff file.

C++ includes: CenaSciencePackage.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackage::CenaSciencePackage "IrfPac::SaraPac::CenaSciencePackage::CenaSciencePackage() ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackage::~CenaSciencePackage "IrfPac::SaraPac::CenaSciencePackage::~CenaSciencePackage() ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackage::setTimeConversion "void
IrfPac::SaraPac::CenaSciencePackage::setTimeConversion(TimeConversion
*tConv)

Set time conversion method.

Specify the method of time conversion. Look at \"Time conversion'
section in the class description.

This method just copy the pointer of tConv. No new/delete is done. So
be careful that tConv should not be deleted. ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackage::appendCenaPacketArray "void
IrfPac::SaraPac::CenaSciencePackage::appendCenaPacketArray(CenaPacketArray
*arr) ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackage::appendCenaPacket "void
IrfPac::SaraPac::CenaSciencePackage::appendCenaPacket(CenaPacket
*cpac) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciencePackage::dump "void IrfPac::SaraPac::CenaSciencePackage::dump(char *pkgname) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciencePackageCntrDump.xml
%feature("docstring") IrfPac::SaraPac::CenaSciencePackageCntrDump "";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageCntrDump::CenaSciencePackageCntrDump
"IrfPac::SaraPac::CenaSciencePackageCntrDump::CenaSciencePackageCntrDump(char
*dirname) ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageCntrDump::~CenaSciencePackageCntrDump
"IrfPac::SaraPac::CenaSciencePackageCntrDump::~CenaSciencePackageCntrDump()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageCntrDump::flush "void
IrfPac::SaraPac::CenaSciencePackageCntrDump::flush() ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageCntrDump::close "void
IrfPac::SaraPac::CenaSciencePackageCntrDump::close() ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageCntrDump::add "void
IrfPac::SaraPac::CenaSciencePackageCntrDump::add(CenaPacket *cena,
TimeConversion *tconv) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciencePackageMassDump.xml
%feature("docstring") IrfPac::SaraPac::CenaSciencePackageMassDump "";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageMassDump::CenaSciencePackageMassDump
"IrfPac::SaraPac::CenaSciencePackageMassDump::CenaSciencePackageMassDump(char
*dirname) ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageMassDump::~CenaSciencePackageMassDump
"IrfPac::SaraPac::CenaSciencePackageMassDump::~CenaSciencePackageMassDump()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageMassDump::flush "void
IrfPac::SaraPac::CenaSciencePackageMassDump::flush() ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageMassDump::close "void
IrfPac::SaraPac::CenaSciencePackageMassDump::close() ";

%feature("docstring")
IrfPac::SaraPac::CenaSciencePackageMassDump::add "void
IrfPac::SaraPac::CenaSciencePackageMassDump::add(CenaPacket *cena,
TimeConversion *tconv) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAcc.xml
%feature("docstring") IrfPac::SaraPac::CenaSciMassAcc "

CENA science packet (non-rice-compressed) of mass accumulation mode.

Count matrix of CENA mass mode. The coincident count is stored to the
corresponding bins for energy, phase, channel and mass. Maximum
numbers of bins are 8 for energy, 32 for phase, 7 for channel and 128
for mass. Note that when the number of channel bins are 7, a padding
is added to the internal expression. This is a DPU specification, and
the library follows to the definition. Therefore the class support two
ways of getting the number of bins: getNrCh() and getNrChIntr().

See:  CenaMode

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::CenaSciMassAcc
"IrfPac::SaraPac::CenaSciMassAcc::CenaSciMassAcc(uint8_t *pac, int
nEnergy, int nPhase, int nC, int nMass) ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAcc::~CenaSciMassAcc "IrfPac::SaraPac::CenaSciMassAcc::~CenaSciMassAcc() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getRaw "uint8_t IrfPac::SaraPac::CenaSciMassAcc::getRaw(int iE, int iP, int
iC, int iM) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::get "uint16_t
IrfPac::SaraPac::CenaSciMassAcc::get(int iE, int iP, int iC, int iM)

Get the count in the packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAcc::getCountAsArray "std::vector< double
> IrfPac::SaraPac::CenaSciMassAcc::getCountAsArray()

Get the observed coincident count as an array.

The count is decompressed. The array size constitute of
iE*iP*iCintr*iM, where iCintr is the internal expression of channel
bin numbers, i.e., (iC==7)?8:ic. The index can be obtained by
indexOf(int,int,int,int) method.

For users of python extension, the method is extremely useful, and
faster than using iteration of get() method. Work routine is
from Sadppac import *         c=CenaBmuReader()
c.readFile('SRA01D18CH101252003709051005532453.cena') arr=c.getArray()
pac=arr.getPacket(30) pac2=pac.decompress()
mass=pac2.getCenaSciMassAcc() print mass.getNrCh()         print
mass.getNrEne()         print mass.getNrMass()         print
mass.getNrPhase()         arr=mass. getCountAsArray() For users of
matplotlib, more useful way is         matx=array(arr)
matx.shape=[mass.getNrEne(), mass.getNrPhase(), mass.getNrChIntr(),
mass.getNrMass()] A pointer to the new object of valarray<double> in
which the count data is stored. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::indexOf "int
IrfPac::SaraPac::CenaSciMassAcc::indexOf(int iE, int iP, int iC, int
iM)

Return the index to the internal expression of the memory layout. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getNrEne "virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrEne() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getNrPhase "virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrPhase() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getNrCh "virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrCh()

Returns the number of channel bins. (1,2,4,7) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getNrChIntr "virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrChIntr()

Returns the number of internal expression of channel bins. (1,2,4,8)
";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getNrMass "virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrMass() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::dumpAll "virtual void IrfPac::SaraPac::CenaSciMassAcc::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::dumpAll "virtual void IrfPac::SaraPac::CenaSciMassAcc::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::dumpByteStream
"size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::dumpHexStream
"size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::dumpHexStream
"virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getValues "T
* IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAcc::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classCenaSciMassAcc__test.xml
%feature("docstring") CenaSciMassAcc_test "";

%feature("docstring")  CenaSciMassAcc_test::CPPUNIT_TEST_SUITE "CenaSciMassAcc_test::CPPUNIT_TEST_SUITE(CenaSciMassAcc_test) ";

%feature("docstring")  CenaSciMassAcc_test::CPPUNIT_TEST "CenaSciMassAcc_test::CPPUNIT_TEST(testDirectInstance) ";

%feature("docstring")  CenaSciMassAcc_test::CPPUNIT_TEST "CenaSciMassAcc_test::CPPUNIT_TEST(testValarray) ";

%feature("docstring")  CenaSciMassAcc_test::CPPUNIT_TEST "CenaSciMassAcc_test::CPPUNIT_TEST(testValarrayC7) ";

%feature("docstring")  CenaSciMassAcc_test::CPPUNIT_TEST "CenaSciMassAcc_test::CPPUNIT_TEST(testValarrayE16) ";

%feature("docstring")  CenaSciMassAcc_test::CPPUNIT_TEST_SUITE_END "CenaSciMassAcc_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  CenaSciMassAcc_test::testDirectInstance "void
CenaSciMassAcc_test::testDirectInstance() ";

%feature("docstring")  CenaSciMassAcc_test::testValarray "void
CenaSciMassAcc_test::testValarray() ";

%feature("docstring")  CenaSciMassAcc_test::testValarrayC7 "void
CenaSciMassAcc_test::testValarrayC7() ";

%feature("docstring")  CenaSciMassAcc_test::testValarrayE16 "void
CenaSciMassAcc_test::testValarrayE16() ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccE16.xml
%feature("docstring") IrfPac::SaraPac::CenaSciMassAccE16 "

Another view of the science matrix for mass mode.

Number of different CENA energy setting is 16. In each SV table, 8 of
16 is selected In this view, energy step looks like 16, and 8 of 16
has meaningful data, and the other is garbage (255 for getRaw). The
benefit of using this class is that the data can be treated
independent of SV table.

The non-observed data is filled by 255 (raw) and log8linear16(255) =
63488.

This class is prepared to handle the CENA mass mode data independent
of CENA SV table setting. This class instance is generated by
CenaPacket::getCenaSciMassAccE16() method.

According to the CENA calibration table, the SV table (sv) dependence
of the E8 index (iE) and E16 index is as follows.  iE             SV=0
SV=1    SV=2            SV=3  0 n/a             8               11
15  1              n/a 7               10              14  ...  7
n/a 1               4               8

Normal data access with CenaPacket::getCenaSciMassAccE16() maps the
E16 index to E8. Where no data is present because the E16 index does
not have a corresponding E8 index, the non-observed data case is used.
The case of SV=0 is special such that independent of E16 index, the
result is the non-observed data case. This is better than to throw an
exception as it allows to use other properties of the data packet
nevertheless.

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccE16::CenaSciMassAccE16 "IrfPac::SaraPac::CenaSciMassAccE16::CenaSciMassAccE16(CenaSciMassAcc
*pac, int sv) ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccE16::~CenaSciMassAccE16 "virtual
IrfPac::SaraPac::CenaSciMassAccE16::~CenaSciMassAccE16() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getNrEne "int IrfPac::SaraPac::CenaSciMassAccE16::getNrEne() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::dumpAll "void IrfPac::SaraPac::CenaSciMassAccE16::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::dumpAll "void IrfPac::SaraPac::CenaSciMassAccE16::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getSvTable
"int IrfPac::SaraPac::CenaSciMassAccE16::getSvTable() ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccE16::getCountAsArray "std::vector<
double > IrfPac::SaraPac::CenaSciMassAccE16::getCountAsArray()

Get the observed coincident count as an array.

The count is decompressed. The array size constitute of
iE*iP*iCintr*iM, where iCintr is the internal expression of channel
bin numbers, i.e., (iC==7)?8:ic. The index can be obtained by
indexOf(int,int,int,int) method.

For users of python extension, the method is extremely useful, and
faster than using iteration of get() method. Work routine is
from Sadppac import *         c=CenaBmuReader()
c.readFile('SRA01D18CH101252003709051005532453.cena') arr=c.getArray()
pac=arr.getPacket(30) pac2=pac.decompress()
mass=pac2.getCenaSciMassAcc() print mass.getNrCh()         print
mass.getNrEne()         print mass.getNrMass()         print
mass.getNrPhase()         arr=mass. getCountAsArray() For users of
matplotlib, more useful way is         matx=array(arr)
matx.shape=[mass.getNrEne(), mass.getNrPhase(), mass.getNrChIntr(),
mass.getNrMass()] A pointer to the new object of valarray<double> in
which the count data is stored. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::indexOf "int IrfPac::SaraPac::CenaSciMassAccE16::indexOf(int iE16, int iP, int
iC, int iM)

Return the index to the internal expression of the memory layout. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getRaw "uint8_t IrfPac::SaraPac::CenaSciMassAccE16::getRaw(int iE16, int iP,
int iC, int iM) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::get "uint16_t IrfPac::SaraPac::CenaSciMassAcc::get(int iE, int iP, int iC,
int iM)

Get the count in the packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getNrPhase
"virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrPhase() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getNrCh "virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrCh()

Returns the number of channel bins. (1,2,4,7) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getNrChIntr
"virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrChIntr()

Returns the number of internal expression of channel bins. (1,2,4,8)
";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getNrMass "virtual int IrfPac::SaraPac::CenaSciMassAcc::getNrMass() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccE16::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccE16::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccE16::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccE16::getIndexSize "size_t
IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getValues "T * IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::getValue "T IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccE16::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccFormatter.xml
%feature("docstring") IrfPac::SaraPac::CenaSciMassAccFormatter "

Virtual class of CenaSciMassAcc formatter.

CenaSciMassAcc class has 4 dimensional data in one packet : iE x iP x
iC x iM .

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatter::~CenaSciMassAccFormatter "virtual
IrfPac::SaraPac::CenaSciMassAccFormatter::~CenaSciMassAccFormatter()
";

%feature("docstring")  IrfPac::SaraPac::CenaSciMassAccFormatter::dump
"virtual void IrfPac::SaraPac::CenaSciMassAccFormatter::dump(FILE
*fp, CenaSciMassAcc *pac)=0 ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccFormatterCspec.xml
%feature("docstring") IrfPac::SaraPac::CenaSciMassAccFormatterCspec "

A dump of directional spectrum.

Collapse over all enegy, phase, and mass. Maximum energy step is 7.

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterCspec::~CenaSciMassAccFormatterCspec
"IrfPac::SaraPac::CenaSciMassAccFormatterCspec::~CenaSciMassAccFormatterCspec()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterCspec::dump "void
IrfPac::SaraPac::CenaSciMassAccFormatterCspec::dump(FILE *fp,
CenaSciMassAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccFormatterEspec.xml
%feature("docstring") IrfPac::SaraPac::CenaSciMassAccFormatterEspec "

A dump of energy spectrum.

Collapse over all phase, channel, and mass. Maximum real energy step
is 8, but here filled by -1 until 32 steps. If the Matrix is
reformated to be SV independent with 16 energy steps then it wil be
printed accordingly with unpopulated energy steps = -1.

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterEspec::~CenaSciMassAccFormatterEspec
"IrfPac::SaraPac::CenaSciMassAccFormatterEspec::~CenaSciMassAccFormatterEspec()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterEspec::dump "void
IrfPac::SaraPac::CenaSciMassAccFormatterEspec::dump(FILE *fp,
CenaSciMassAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccFormatterHeavyEspecC.xml
%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterHeavyEspecC "

A dump of energy spectrum for each channel step, only mass bins
64..127 are used.

Collapse over phase, and mass 64..127. mass bins 0..63 are not used.
Each line constitute of 8 energy steps * 7 direction steps. First
energy step index cycle, then channel step: i.e., ene0chan0 ene1chan0
ene2chan0 ... ene7chan0 ene0chan1 ene1chan1 ... If no data availble
due to binning parameter, -1 is filled.

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterHeavyEspecC::~CenaSciMassAccFormatterHeavyEspecC
"IrfPac::SaraPac::CenaSciMassAccFormatterHeavyEspecC::~CenaSciMassAccFormatterHeavyEspecC()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterHeavyEspecC::dump "void
IrfPac::SaraPac::CenaSciMassAccFormatterHeavyEspecC::dump(FILE *fp,
CenaSciMassAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccFormatterLightEspecC.xml
%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterLightEspecC "

A dump of energy spectrum for each channel step, only mass bins 0..63
are used.

Collapse over phase, and mass 0..63. mass 64..128 is not used. Each
line constitute of 8 energy steps * 7 direction steps. First energy
step index cycle, then channel step: i.e., ene0chan0 ene1chan0
ene2chan0 ... ene7chan0 ene0chan1 ene1chan1 ... If no data availble
due to binning parameter, -1 is filled.

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterLightEspecC::~CenaSciMassAccFormatterLightEspecC
"IrfPac::SaraPac::CenaSciMassAccFormatterLightEspecC::~CenaSciMassAccFormatterLightEspecC()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterLightEspecC::dump "void
IrfPac::SaraPac::CenaSciMassAccFormatterLightEspecC::dump(FILE *fp,
CenaSciMassAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccFormatterMspec.xml
%feature("docstring") IrfPac::SaraPac::CenaSciMassAccFormatterMspec "

A dump of mass spectrum.

Collapse over all enegy, phase, and channel. If I remember correctly,
maximum mass step is 128, but here filled by -1 until 256 steps.

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterMspec::~CenaSciMassAccFormatterMspec
"IrfPac::SaraPac::CenaSciMassAccFormatterMspec::~CenaSciMassAccFormatterMspec()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterMspec::dump "void
IrfPac::SaraPac::CenaSciMassAccFormatterMspec::dump(FILE *fp,
CenaSciMassAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciMassAccFormatterMspecEne.xml
%feature("docstring") IrfPac::SaraPac::CenaSciMassAccFormatterMspecEne
"

A dump of mass spectrum for each energy step.

Collapse over phase, and channel. Each line constitute of 128 mass
steps * 8 energy steps. First mass step index cycle, then energy step:
i.e., mass0ene0 mass1ene0 mass2ene0 ... mass127ene0 mass0ene1
mass1ene1 ... If no data availble due to binning parameter, -1 is
filled.

C++ includes: CenaSciMassAcc.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterMspecEne::~CenaSciMassAccFormatterMspecEne
"IrfPac::SaraPac::CenaSciMassAccFormatterMspecEne::~CenaSciMassAccFormatterMspecEne()
";

%feature("docstring")
IrfPac::SaraPac::CenaSciMassAccFormatterMspecEne::dump "void
IrfPac::SaraPac::CenaSciMassAccFormatterMspecEne::dump(FILE *fp,
CenaSciMassAcc *pac) ";


// File: classIrfPac_1_1SaraPac_1_1CenaSciTofAcc.xml
%feature("docstring") IrfPac::SaraPac::CenaSciTofAcc "

CENA science packet (non-rice-compressed) of TOF accumulation mode.

C++ includes: CenaSciTofAcc.h ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::CenaSciTofAcc "IrfPac::SaraPac::CenaSciTofAcc::CenaSciTofAcc(uint8_t *pac, int
nEnergy, int nTof) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::~CenaSciTofAcc
"IrfPac::SaraPac::CenaSciTofAcc::~CenaSciTofAcc() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getRaw "uint8_t IrfPac::SaraPac::CenaSciTofAcc::getRaw(int iE, int iTof) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::get "uint16_t
IrfPac::SaraPac::CenaSciTofAcc::get(int iE, int iTof) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getNrEne "int
IrfPac::SaraPac::CenaSciTofAcc::getNrEne() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getNrTof "int
IrfPac::SaraPac::CenaSciTofAcc::getNrTof() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::dumpByteStream
"size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::dumpHexStream "size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::dumpHexStream "virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::dumpAll "virtual void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::dumpAll "virtual void IrfPac::PacketIntArr< T >::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaSciTofAcc::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classCenaSciTofAcc__test.xml
%feature("docstring") CenaSciTofAcc_test "";

%feature("docstring")  CenaSciTofAcc_test::CPPUNIT_TEST_SUITE "CenaSciTofAcc_test::CPPUNIT_TEST_SUITE(CenaSciTofAcc_test) ";

%feature("docstring")  CenaSciTofAcc_test::CPPUNIT_TEST "CenaSciTofAcc_test::CPPUNIT_TEST(testDirectInstance) ";

%feature("docstring")  CenaSciTofAcc_test::CPPUNIT_TEST_SUITE_END "CenaSciTofAcc_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  CenaSciTofAcc_test::testDirectInstance "void
CenaSciTofAcc_test::testDirectInstance() ";


// File: classCenaSubcHkPac__test.xml
%feature("docstring") CenaSubcHkPac_test "";

%feature("docstring")  CenaSubcHkPac_test::CPPUNIT_TEST_SUITE "CenaSubcHkPac_test::CPPUNIT_TEST_SUITE(CenaSubcHkPac_test) ";

%feature("docstring")  CenaSubcHkPac_test::CPPUNIT_TEST "CenaSubcHkPac_test::CPPUNIT_TEST(testGeneration) ";

%feature("docstring")  CenaSubcHkPac_test::CPPUNIT_TEST "CenaSubcHkPac_test::CPPUNIT_TEST(test12b) ";

%feature("docstring")  CenaSubcHkPac_test::CPPUNIT_TEST "CenaSubcHkPac_test::CPPUNIT_TEST(testbit) ";

%feature("docstring")  CenaSubcHkPac_test::CPPUNIT_TEST_SUITE_END "CenaSubcHkPac_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  CenaSubcHkPac_test::testGeneration "void
CenaSubcHkPac_test::testGeneration() ";

%feature("docstring")  CenaSubcHkPac_test::test12b "void
CenaSubcHkPac_test::test12b() ";

%feature("docstring")  CenaSubcHkPac_test::testbit "void
CenaSubcHkPac_test::testbit() ";


// File: classIrfPac_1_1SaraPac_1_1CenaSubcHkPacket.xml
%feature("docstring") IrfPac::SaraPac::CenaSubcHkPacket "

Implementation of CENA HK packet subcommuted in CENA science packet.

The definition of the packet contents is described in Table 19 in CHA-
SARA-DS-0006.

Deprecated  CenaSubcHkPacket class is deprecated because the name
'subc' confuses users. The new class CenaFastHkPacket can be used.

C++ includes: CenaSubcHkPac.h ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::CenaSubcHkPacket "IrfPac::SaraPac::CenaSubcHkPacket::CenaSubcHkPacket(uint8_t *stream,
size_t size) ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::CenaSubcHkPacket "IrfPac::SaraPac::CenaSubcHkPacket::CenaSubcHkPacket(uint8_t *stream)
";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::~CenaSubcHkPacket "IrfPac::SaraPac::CenaSubcHkPacket::~CenaSubcHkPacket() ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::dumpAll "DEPRECATED void IrfPac::SaraPac::CenaSubcHkPacket::dumpAll(void)

Dump a detailed information into stdout. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::dumpAll "void IrfPac::SaraPac::CenaSubcHkPacket::dumpAll(FILE *fp)

Dump a detailed information into specified file. ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvMain "DEPRECATED bool
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvMain()

return Flag P ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvSafety "DEPRECATED bool
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvSafety()

return Flag S ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvOnEna "DEPRECATED bool
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvOnEna()

return Flag PE ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvLvlEna "DEPRECATED bool
IrfPac::SaraPac::CenaSubcHkPacket::getFlagHvLvlEna()

return Flag SE ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getFlagError
"DEPRECATED bool IrfPac::SaraPac::CenaSubcHkPacket::getFlagError()

return Flag ER ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getHvMain "uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getHvMain()

DV2-3, H1Level. ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::getHvStartMcp "uint16_t
IrfPac::SaraPac::CenaSubcHkPacket::getHvStartMcp()

DV4-5, H2Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getHvStopMcp
"uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getHvStopMcp()

DV6-7, H3Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getHvTof "uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getHvTof()

DV8-9, H4Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getHvDef "uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getHvDef()

DV10-11, H5Level. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getTempIFE "uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getTempIFE()

DV12-13, TempIFE. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getTempHVPS
"uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getTempHVPS()

DV14-15,TempHVPS. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getPsyncCntr
"uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getPsyncCntr()

DV34-35, Number of sync pulses received from DPU since IFE power on.
";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getBaseCntr
"uint16_t IrfPac::SaraPac::CenaSubcHkPacket::getBaseCntr()

DV36-37, Number of sync pulse intervals clapsed since IFE power on. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::CenaSubcHkPacket::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getValues "T * IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::CenaSubcHkPacket::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1GeneralPacket.xml
%feature("docstring") IrfPac::GeneralPacket "

Pure virtual class of packets.

Base class for packets of general purpose. Futaana

C++ includes: generalpacket.h ";

%feature("docstring")  IrfPac::GeneralPacket::~GeneralPacket "virtual
IrfPac::GeneralPacket::~GeneralPacket() ";

%feature("docstring")  IrfPac::GeneralPacket::getStream "virtual
uint8_t* IrfPac::GeneralPacket::getStream(void)=0

Returns pointer to the byte stream. The byte stream should be freeed
explicitly after use. ";

%feature("docstring")  IrfPac::GeneralPacket::dumpByteStream "virtual
size_t IrfPac::GeneralPacket::dumpByteStream(FILE *fp)=0

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::GeneralPacket::dumpHexStream "virtual
size_t IrfPac::GeneralPacket::dumpHexStream(FILE *fp)=0

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::GeneralPacket::getSize "virtual size_t
IrfPac::GeneralPacket::getSize()=0

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::GeneralPacket::hash "virtual
std::string IrfPac::GeneralPacket::hash()

Returns a string expression of hash of the packet. ";

%feature("docstring")  IrfPac::GeneralPacket::equals "virtual bool
IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1PacketBmuFormatter.xml
%feature("docstring") IrfPac::PacketBmuFormatter "

One of the basic formatters: so-called BMU format.

This is a formatter for packet. Output is the so-called BMU format.
Sample code is: uint8_t array[100]; for(int i=0; i<100;
i++)array[i]=i; PacketU8Arr* packet=new PacketU8Arr(array, 100);
// Instance PacketU8Arr in some ways. PacketBmuFormatter *formatter;
// Instance formatter. formatter.format(stdout, packet); // Format
packet and print to stdout. Results looks like: 0001 0203 0405 0607
0809 0a0b 0c0d 0e0f 1011 1213 1415 1617 1819 1a1b 1c1d 1e1f 2021 2223
2425 2627 2829 2a2b 2c2d 2e2f 3031 3233 3435 3637 3839 3a3b 3c3d 3e3f
4041 4243 4445 4647 4849 4a4b 4c4d 4e4f 5051 5253 5455 5657 5859 5a5b
5c5d 5e5f 6061 6263 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000
0000 0000 0000 0000

Normally the BMU format has header starting \"*******\", however, it
is not displayed in this formatter.

Sample of header is: ********BMU-FMT at TIME XXX XXX XX XX:XX:XX XXXX

C++ includes: PacketIntArr.h ";

%feature("docstring")  IrfPac::PacketBmuFormatter::format "void
IrfPac::PacketBmuFormatter::format(FILE *fp, PacketU8Arr *packet) ";


// File: classIrfPac_1_1PacketByteArr.xml
%feature("docstring") IrfPac::PacketByteArr "

Packet implementation: intialization by byte array.

Deprecated Use PacketU8Arr

Packet consists of byte array. FUTAANA

C++ includes: packetbytearr.h ";

%feature("docstring")  IrfPac::PacketByteArr::PacketByteArr "IrfPac::PacketByteArr::PacketByteArr(uint8_t *bytestream, size_t size)
";

%feature("docstring")  IrfPac::PacketByteArr::~PacketByteArr "IrfPac::PacketByteArr::~PacketByteArr() ";

%feature("docstring")  IrfPac::PacketByteArr::getStream "uint8_t *
IrfPac::PacketByteArr::getStream(void)

Return (the pointer to) the byte stream.

Return the byte stream. The stream is newly generated, so that it is
independent from the contents inside this class. Change of the
contents of returned stream will not affect the original contents. You
have to use delete[] to release the obtained stream explicitly
otherwise it causes memory leak. ";

%feature("docstring")  IrfPac::PacketByteArr::dumpByteStream "size_t
IrfPac::PacketByteArr::dumpByteStream(FILE *fp)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::PacketByteArr::dumpHexStream "size_t
IrfPac::PacketByteArr::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::PacketByteArr::getSize "size_t
IrfPac::PacketByteArr::getSize()

Returns the size of the packet ";

%feature("docstring")  IrfPac::PacketByteArr::hash "virtual
std::string IrfPac::GeneralPacket::hash()

Returns a string expression of hash of the packet. ";

%feature("docstring")  IrfPac::PacketByteArr::equals "virtual bool
IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classPacketByteArrTest.xml
%feature("docstring") PacketByteArrTest "";


// File: classIrfPac_1_1PacketInt32Arr.xml
%feature("docstring") IrfPac::PacketInt32Arr "

Implementaion of GeneralPacket: initialization and internal structure
by uint32_t array.

Deprecated Use PacketU32Arr

FUTAANA

C++ includes: packetint32arr.h ";

%feature("docstring")  IrfPac::PacketInt32Arr::PacketInt32Arr "IrfPac::PacketInt32Arr::PacketInt32Arr(uint32_t *stream, int nIndex)
";

%feature("docstring")  IrfPac::PacketInt32Arr::~PacketInt32Arr "IrfPac::PacketInt32Arr::~PacketInt32Arr() ";

%feature("docstring")  IrfPac::PacketInt32Arr::getStream "uint8_t *
IrfPac::PacketInt32Arr::getStream(void)

Returns pointer to the byte stream. The byte stream should be freeed
explicitly after use. ";

%feature("docstring")  IrfPac::PacketInt32Arr::dumpByteStream "size_t
IrfPac::PacketInt32Arr::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::PacketInt32Arr::dumpHexStream "size_t
IrfPac::PacketInt32Arr::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::PacketInt32Arr::getSize "size_t
IrfPac::PacketInt32Arr::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::PacketInt32Arr::getIndexSize "size_t
IrfPac::PacketInt32Arr::getIndexSize() ";

%feature("docstring")  IrfPac::PacketInt32Arr::getValues "uint32_t *
IrfPac::PacketInt32Arr::getValues(void) ";

%feature("docstring")  IrfPac::PacketInt32Arr::getValue "uint32_t
IrfPac::PacketInt32Arr::getValue(size_t index) ";

%feature("docstring")  IrfPac::PacketInt32Arr::hash "virtual
std::string IrfPac::GeneralPacket::hash()

Returns a string expression of hash of the packet. ";

%feature("docstring")  IrfPac::PacketInt32Arr::equals "virtual bool
IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classPacketInt32Arr__test.xml
%feature("docstring") PacketInt32Arr_test "";


// File: classIrfPac_1_1PacketIntArr.xml
%feature("docstring") IrfPac::PacketIntArr "

Implementaion of GeneralPacket.

This class is a template class, so that it is not recommended to be
used. Use PacketU64Arr, PacketU32Arr, PacketU16Arr, and PacketU8Arr.
These classes are immutable.

FUTAANA

C++ includes: PacketIntArr.h ";

%feature("docstring")  IrfPac::PacketIntArr::PacketIntArr "IrfPac::PacketIntArr< T >::PacketIntArr(T *stream, int nIndex) ";

%feature("docstring")  IrfPac::PacketIntArr::PacketIntArr "IrfPac::PacketIntArr< T >::PacketIntArr(const PacketIntArr< T > &obj)

copy constructor ";

%feature("docstring")  IrfPac::PacketIntArr::~PacketIntArr "IrfPac::PacketIntArr< T >::~PacketIntArr() ";

%feature("docstring")  IrfPac::PacketIntArr::getStream "uint8_t *
IrfPac::PacketIntArr< T >::getStream(void)

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::PacketIntArr::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::PacketIntArr::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::PacketIntArr::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::PacketIntArr::getIndexSize "size_t
IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::PacketIntArr::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::PacketIntArr::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::PacketIntArr::dumpAll "virtual void
IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::PacketIntArr::dumpAll "virtual void
IrfPac::PacketIntArr< T >::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::PacketIntArr::dumpHexStream "virtual
size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::PacketIntArr::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::PacketIntArr::equals "virtual bool
IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classPacketIntArr__test.xml
%feature("docstring") PacketIntArr_test "";


// File: classIrfPac_1_1PacketU8Arr.xml
%feature("docstring") IrfPac::PacketU8Arr "

Implementation of packet constituted by 8bit (1byte) Array.

This class is immutable, so that only the initialization and change is
done in the constructor.

C++ includes: PacketIntArr.h ";

%feature("docstring")  IrfPac::PacketU8Arr::PacketU8Arr "IrfPac::PacketU8Arr::PacketU8Arr(uint8_t *str, size_t size) ";

%feature("docstring")  IrfPac::PacketU8Arr::~PacketU8Arr "virtual
IrfPac::PacketU8Arr::~PacketU8Arr() ";

%feature("docstring")  IrfPac::PacketU8Arr::getStream "uint8_t*
IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::PacketU8Arr::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::PacketU8Arr::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::PacketU8Arr::dumpHexStream "virtual
size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::PacketU8Arr::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::PacketU8Arr::getIndexSize "size_t
IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::PacketU8Arr::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::PacketU8Arr::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::PacketU8Arr::dumpAll "virtual void
IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::PacketU8Arr::dumpAll "virtual void
IrfPac::PacketIntArr< T >::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::PacketU8Arr::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::PacketU8Arr::equals "virtual bool
IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1PacketU8ArrFormatter.xml
%feature("docstring") IrfPac::PacketU8ArrFormatter "

Pure virtual formatter class of the PacketU8Arr.

This is a base class of many formatter classes for PacketU8Arr. Refer
to, e.g. BmuFormatter class, as a sample.

C++ includes: PacketIntArr.h ";

%feature("docstring")
IrfPac::PacketU8ArrFormatter::~PacketU8ArrFormatter "virtual
IrfPac::PacketU8ArrFormatter::~PacketU8ArrFormatter() ";

%feature("docstring")  IrfPac::PacketU8ArrFormatter::format "virtual
void IrfPac::PacketU8ArrFormatter::format(FILE *fp, PacketU8Arr
*packet)=0 ";


// File: classIrfPac_1_1SaraPac_1_1AscFmt_1_1SaraAscFile.xml
%feature("docstring") IrfPac::SaraPac::AscFmt::SaraAscFile "

The class corresponds to a dump file of SARA BMU format.

Science packet should start by an indicator of 8 continouts *
(asterisc) followed by 896 byte hex-dumped string, each line has 16
word (64 chars) The sample of using this class can be found in
AscFmtReader_sample.cpp file.

SCI-DATA at Time Mon Jul  2 17:49:20 2007         cccc 0001 aaaa 5555
0000 0000 0000 0000 0000 0183 000e 0001 0000 0001 6000 0000 ....
(continuing 27 residual lines)

C++ includes: SaraAscFile.h ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraAscFile::SaraAscFile "IrfPac::SaraPac::AscFmt::SaraAscFile::SaraAscFile(char *filename)

Instance class with specifying the dump file name.

You have to open the stream by openStream() method to use the file. ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraAscFile::~SaraAscFile "IrfPac::SaraPac::AscFmt::SaraAscFile::~SaraAscFile() ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraAscFile::openStream "bool
IrfPac::SaraPac::AscFmt::SaraAscFile::openStream()

Open the file stream. ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraAscFile::closeStream "bool
IrfPac::SaraPac::AscFmt::SaraAscFile::closeStream()

Close the file stream. ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::SaraAscFile::eof "bool IrfPac::SaraPac::AscFmt::SaraAscFile::eof()

Check the file stream is end-of-file or not. ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraAscFile::clearerror "void
IrfPac::SaraPac::AscFmt::SaraAscFile::clearerror()

Clear the flag of the file.

The method clears all the error flag (including eof flag). ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraAscFile::getSaraPacket "SaraPacket *
IrfPac::SaraPac::AscFmt::SaraAscFile::getSaraPacket()

Get next SaraPacket read from the file.

If the file is not open, or reach end, NULL is returned. The returned
packet should be deleted explicitly. ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraAscFile::setTimeout "void
IrfPac::SaraPac::AscFmt::SaraAscFile::setTimeout(int wait_msec)

Determine how long the program wait for the file stream. ";


// File: classIrfPac_1_1SaraPac_1_1SaraBufferedDemultiplexor.xml
%feature("docstring") IrfPac::SaraPac::SaraBufferedDemultiplexor "

SaraPacket demultiplexor. Usage can be found in DemultiplexorSample
page.

This class is for demultiplexing of SaraPacket to CenaPcket and
SwimPacket. A sample code is described in DemultiplexorSample

Basic ideas of this class are Input SaraPacket* instances.

Demultiplex the input SaraPacket* to CenaPacket* and SwimPacket*.

Once CenaPacket and/or SwimPacket is completed, the CenaPacket* and
SwimPacket* are buffered internally.

Access to the buffered CenaPacket* and SwimPacket* instances.

To whom being interested in the details: There are 4 bufferes
internally. Incomplete CenaPacket and SwimPacket, and Complete
CenaPacket and SwimPacket. Once SaraPacket comes, the packet is
analyzed into a part of CenaPacket and SwimPacket up to the SaraPacket
header. The analyzed CenaPacket and SwimPacket is stored to
'incomplete' CenaPacket and SwimPacket buffer respectively. Once
CenaPacket (or SwimPacket) is completed, and it is copied to the
'complete' CenaPacket (or SwimPacket) buffer. There are no public
method to manually modify the 'incomplete' CenaBuffer and SwimBuffer
(Only appending SaraPacket is possible).

C++ includes: SaraBufferedDemultiplexor.h ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::SaraBufferedDemultiplexor
"IrfPac::SaraPac::SaraBufferedDemultiplexor::SaraBufferedDemultiplexor()
";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::~SaraBufferedDemultiplexor
"IrfPac::SaraPac::SaraBufferedDemultiplexor::~SaraBufferedDemultiplexor()
";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::appendSaraPacket "void
IrfPac::SaraPac::SaraBufferedDemultiplexor::appendSaraPacket(SaraPacket
*saraPac)

Append SaraPacket instance for demultiplexor. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::getNrCena "int
IrfPac::SaraPac::SaraBufferedDemultiplexor::getNrCena()

Returns the number of buffered CenaPacket. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::getNrSwim "int
IrfPac::SaraPac::SaraBufferedDemultiplexor::getNrSwim()

Returns the number of buffered SwimPacket. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::getCena "CenaPacket *
IrfPac::SaraPac::SaraBufferedDemultiplexor::getCena()

Returns the first CenaPacket in the CENA buffer(like FIFO).

Returns the first (=oldest) CenaPacket. If CenaPacket is not in the
CENA buffer, NULL is returned. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::getSwim "SwimPacket *
IrfPac::SaraPac::SaraBufferedDemultiplexor::getSwim()

Returns the first SwimPacket in the SWIM buffer (like FIFO).

Returns the first (=oldest) SwimPacket. If SwimPacket is not in the
SWIM buffer, NULL is returned. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::getLatestCena "CenaPacket
* IrfPac::SaraPac::SaraBufferedDemultiplexor::getLatestCena()

Returns the latest CenaPacket, and flush the CenaPacket* buffer.

Returns the latest CenaPacket in the CENA buffer. All the packets in
the CENA buffer are then destroyed. If no CenaPacket instance is in
the buffer, NULL is returned. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::getLatestSwim "SwimPacket
* IrfPac::SaraPac::SaraBufferedDemultiplexor::getLatestSwim()

Returns the latest SwimPacket, and flush the SwimPacket* buffer.

Returns the latest SwimPacket in the SWIM buffer. All the packets in
the SWIM buffer are then destroyed. If no SwimPacket instance is in
the buffer, NULL is returned. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::flushCena "void
IrfPac::SaraPac::SaraBufferedDemultiplexor::flushCena()

Flush all the buffered CenaPacket. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::flushSwim "void
IrfPac::SaraPac::SaraBufferedDemultiplexor::flushSwim()

Flush all the buffered SwimPacket. ";

%feature("docstring")
IrfPac::SaraPac::SaraBufferedDemultiplexor::showBufferStatus "void
IrfPac::SaraPac::SaraBufferedDemultiplexor::showBufferStatus() ";


// File: classIrfPac_1_1SaraPac_1_1SaraDemultiplexor.xml
%feature("docstring") IrfPac::SaraPac::SaraDemultiplexor "

Factory class of SARA data stream to demultiplex to CENA/SWIM data
stream.

This class receives series of SaraPacket, which is 448-word-fixed
binary stream packet, and demultiplex the packet, and returns
CenaPacket and SwimPacket. Only when SaraPacket shows the completion
of one packet, CenaPacket and SwimPacket will be returned. Otherwise,
NULL is returned.

An sample of the execution can be found in
AscFmt/SaraDemultiplexor_sample.cpp

C++ includes: SaraDemultiplexor.h ";

%feature("docstring")
IrfPac::SaraPac::SaraDemultiplexor::SaraDemultiplexor "IrfPac::SaraPac::SaraDemultiplexor::SaraDemultiplexor() ";

%feature("docstring")
IrfPac::SaraPac::SaraDemultiplexor::~SaraDemultiplexor "IrfPac::SaraPac::SaraDemultiplexor::~SaraDemultiplexor() ";

%feature("docstring")  IrfPac::SaraPac::SaraDemultiplexor::appendCena
"CenaPacket *
IrfPac::SaraPac::SaraDemultiplexor::appendCena(SaraPacket *saraPac)

Append the SaraPacket to the CENA cache. Returns the completed packet
that has been cached.

This method controls caching and returning the completed packet. We
know the completion of packet only when the new packet arrived. No
sequencial check is done in this method. That should be done manually.
Look the sample code in SaraDemultiplexor_sample.cpp file. ";

%feature("docstring")  IrfPac::SaraPac::SaraDemultiplexor::appendSwim
"SwimPacket *
IrfPac::SaraPac::SaraDemultiplexor::appendSwim(SaraPacket *saraPac) ";

%feature("docstring")
IrfPac::SaraPac::SaraDemultiplexor::sequenceCheck "bool
IrfPac::SaraPac::SaraDemultiplexor::sequenceCheck(SaraPacket *saraPac)

Check the sequence of SaraPacket, and returns the packet is
sequencially arrived.

This sequence should not be called twice for the same SaraPacket
because this updates the internal buffer of counter number to the
current packet.

Bug Potential bug: Because I do not know the maximum number of the
packet counter, I have never checked the bug-freeness when loop
occurs. I implemented maximum counter as 1<<15, but should be checked!
";

%feature("docstring")  IrfPac::SaraPac::SaraDemultiplexor::flushAll "void IrfPac::SaraPac::SaraDemultiplexor::flushAll() ";


// File: classSaraDemultiplexor__test.xml
%feature("docstring") SaraDemultiplexor_test "";

%feature("docstring")  SaraDemultiplexor_test::CPPUNIT_TEST_SUITE "SaraDemultiplexor_test::CPPUNIT_TEST_SUITE(SaraDemultiplexor_test) ";

%feature("docstring")  SaraDemultiplexor_test::CPPUNIT_TEST "SaraDemultiplexor_test::CPPUNIT_TEST(testSasCacheAppend) ";

%feature("docstring")  SaraDemultiplexor_test::CPPUNIT_TEST_SUITE_END
"SaraDemultiplexor_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SaraDemultiplexor_test::testSasCacheAppend "void SaraDemultiplexor_test::testSasCacheAppend() ";


// File: classIrfPac_1_1SaraPac_1_1SaraHkConversion.xml
%feature("docstring") IrfPac::SaraPac::SaraHkConversion "

Conversion table for SARA HK data.

C++ includes: SaraHkConversion.h ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversion::~SaraHkConversion "virtual
IrfPac::SaraPac::SaraHkConversion::~SaraHkConversion() ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::getName "virtual std::string IrfPac::SaraPac::SaraHkConversion::getName()=0 ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::swimHV "virtual double IrfPac::SaraPac::SaraHkConversion::swimHV(uint32_t
monitor)=0

SWIM Main in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::swimVCeem "virtual double IrfPac::SaraPac::SaraHkConversion::swimVCeem(uint32_t
monitor)=0

SWIM CEM in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::swimVUpDef "virtual double IrfPac::SaraPac::SaraHkConversion::swimVUpDef(uint32_t
monitor)=0

SWIM Defl. upper in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::swimVLoDef "virtual double IrfPac::SaraPac::SaraHkConversion::swimVLoDef(uint32_t
monitor)=0

SWIM Defl. lower in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::swimVAnaCel
"virtual double
IrfPac::SaraPac::SaraHkConversion::swimVAnaCel(uint32_t monitor)=0

SWIM Anyz in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::swimVTofCel
"virtual double
IrfPac::SaraPac::SaraHkConversion::swimVTofCel(uint32_t monitor)=0

SWIM Cell in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversion::swimTempTofBrd "virtual double
IrfPac::SaraPac::SaraHkConversion::swimTempTofBrd(uint32_t monitor)=0

SWIM Temp in degC. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaHvMain "virtual double IrfPac::SaraPac::SaraHkConversion::cenaHvMain(uint32_t
monitor)=0

CENA HV_Ref in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversion::cenaHvStartMcp "virtual double
IrfPac::SaraPac::SaraHkConversion::cenaHvStartMcp(uint32_t monitor)=0

CENA HV_StartMCP in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversion::cenaHvStopMcp "virtual double
IrfPac::SaraPac::SaraHkConversion::cenaHvStopMcp(uint32_t monitor)=0

CENA HV_StopMCP in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaHvDef "virtual double IrfPac::SaraPac::SaraHkConversion::cenaHvDef(uint32_t
monitor)=0

CENA HV_Def in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaHvTof "virtual double IrfPac::SaraPac::SaraHkConversion::cenaHvTof(uint32_t
monitor)=0

CENA HV_Tef in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaSvWave1
"virtual double
IrfPac::SaraPac::SaraHkConversion::cenaSvWave1(uint32_t monitor)=0

CENA SV_WAVE1 in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaSvWave2a
"virtual double
IrfPac::SaraPac::SaraHkConversion::cenaSvWave2a(uint32_t monitor)=0

CENA SV_WAVE2A in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaSvWave2b
"virtual double
IrfPac::SaraPac::SaraHkConversion::cenaSvWave2b(uint32_t monitor)=0

CENA SV_WAVE2B in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaSvLens "virtual double IrfPac::SaraPac::SaraHkConversion::cenaSvLens(uint32_t
monitor)=0

CENA HV_LENS in Volts. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaTempHVPS
"virtual double
IrfPac::SaraPac::SaraHkConversion::cenaTempHVPS(uint32_t monitor)=0

CENA Temp_HVPS in degC. ";

%feature("docstring")  IrfPac::SaraPac::SaraHkConversion::cenaTempIFE
"virtual double
IrfPac::SaraPac::SaraHkConversion::cenaTempIFE(uint32_t monitor)=0

CENA Temp_IFE in degC. ";


// File: classSaraHkConversion__test.xml
%feature("docstring") SaraHkConversion_test "";

%feature("docstring")  SaraHkConversion_test::CPPUNIT_TEST_SUITE "SaraHkConversion_test::CPPUNIT_TEST_SUITE(SaraHkConversion_test) ";

%feature("docstring")  SaraHkConversion_test::CPPUNIT_TEST "SaraHkConversion_test::CPPUNIT_TEST(testInstance) ";

%feature("docstring")  SaraHkConversion_test::CPPUNIT_TEST_SUITE_END "SaraHkConversion_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SaraHkConversion_test::testInstance "void
SaraHkConversion_test::testInstance() ";


// File: classIrfPac_1_1SaraPac_1_1SaraHkConversionGrndCal.xml
%feature("docstring") IrfPac::SaraPac::SaraHkConversionGrndCal "

An implementation of the SaraHkConversion.

The conversion function is defined by CHA-SARA-CR-0002-I1R2 (SAS
Housekeeping Calibration Functions). You can instance it
bySaraHkConversion.getConversionFunctions(SaraHkConversion::TABLE_GROUND_CALIBRATION);

C++ includes: SaraHkConversionGrndCal.h ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::SaraHkConversionGrndCal "IrfPac::SaraPac::SaraHkConversionGrndCal::SaraHkConversionGrndCal() ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::getName "virtual
std::string IrfPac::SaraPac::SaraHkConversionGrndCal::getName() ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::swimHV "double
SaraHkConversionGrndCal::swimHV(uint32_t monitor)

SWIM Main in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::swimVCeem "double
SaraHkConversionGrndCal::swimVCeem(uint32_t monitor)

SWIM CEM in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::swimVUpDef "double
SaraHkConversionGrndCal::swimVUpDef(uint32_t monitor)

SWIM Defl. upper in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::swimVLoDef "double
SaraHkConversionGrndCal::swimVLoDef(uint32_t monitor)

SWIM Defl. lower in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::swimVAnaCel "double
SaraHkConversionGrndCal::swimVAnaCel(uint32_t monitor)

SWIM Anyz in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::swimVTofCel "double
SaraHkConversionGrndCal::swimVTofCel(uint32_t monitor)

SWIM Cell in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::swimTempTofBrd "double
SaraHkConversionGrndCal::swimTempTofBrd(uint32_t monitor)

SWIM Temp in degC. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaHvMain "double
SaraHkConversionGrndCal::cenaHvMain(uint32_t monitor)

CENA HV_Ref in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaHvStartMcp "double
SaraHkConversionGrndCal::cenaHvStartMcp(uint32_t monitor)

CENA HV_StartMCP in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaHvStopMcp "double
SaraHkConversionGrndCal::cenaHvStopMcp(uint32_t monitor)

CENA HV_StopMCP in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaHvDef "double
SaraHkConversionGrndCal::cenaHvDef(uint32_t monitor)

CENA HV_Def in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaHvTof "double
SaraHkConversionGrndCal::cenaHvTof(uint32_t monitor)

CENA HV_Tef in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaSvWave1 "double
SaraHkConversionGrndCal::cenaSvWave1(uint32_t monitor)

CENA SV_WAVE1 in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaSvWave2a "double
SaraHkConversionGrndCal::cenaSvWave2a(uint32_t monitor)

CENA SV_WAVE2A in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaSvWave2b "double
SaraHkConversionGrndCal::cenaSvWave2b(uint32_t monitor)

CENA SV_WAVE2B in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaSvLens "double
SaraHkConversionGrndCal::cenaSvLens(uint32_t monitor)

CENA HV_LENS in Volts. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaTempHVPS "double
SaraHkConversionGrndCal::cenaTempHVPS(uint32_t monitor)

CENA Temp_HVPS in degC. ";

%feature("docstring")
IrfPac::SaraPac::SaraHkConversionGrndCal::cenaTempIFE "double
SaraHkConversionGrndCal::cenaTempIFE(uint32_t monitor)

CENA Temp_IFE in degC. ";


// File: classSaraHkConversionGrndCal__test.xml
%feature("docstring") SaraHkConversionGrndCal_test "";

%feature("docstring")
SaraHkConversionGrndCal_test::CPPUNIT_TEST_SUITE "SaraHkConversionGrndCal_test::CPPUNIT_TEST_SUITE(SaraHkConversionGrndCal_test)
";

%feature("docstring")  SaraHkConversionGrndCal_test::CPPUNIT_TEST "SaraHkConversionGrndCal_test::CPPUNIT_TEST(testValue) ";

%feature("docstring")
SaraHkConversionGrndCal_test::CPPUNIT_TEST_SUITE_END "SaraHkConversionGrndCal_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SaraHkConversionGrndCal_test::testValue "void
SaraHkConversionGrndCal_test::testValue() ";


// File: classIrfPac_1_1SaraPac_1_1SaraPacket.xml
%feature("docstring") IrfPac::SaraPac::SaraPacket "

SARA packet. See TMTC doc.

The SARA packet is very complicated packet. Each packet consists of
448 word (896 byte). Combination of packets will re-create CenaPacket
and SaraPacket. This process is called `demultiplex'.

The SARA packet can be categolized into several types depending on the
header value (first one-word). 0xCECE is a packet contains both CENA
and SWIM

0xCCCC is a packet contains only CENA

0xEEEE is a packet contains only SWIM

C++ includes: SaraPacket.h ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::SaraPacket "IrfPac::SaraPac::SaraPacket::SaraPacket(uint8_t *stream) ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::~SaraPacket "IrfPac::SaraPac::SaraPacket::~SaraPacket() ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getPacketId "uint16_t IrfPac::SaraPac::SaraPacket::getPacketId()

Returns the packet ID, packetIdCenaOnly (0xCCCC), packetIdCenaSwim
(0xCECE), or packetIdSwimOnly (0xEEEE).

In case the packet ID was not those of them, packetIdUnknown (0xFFFF)
is returned. ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getCounter "uint16_t IrfPac::SaraPac::SaraPacket::getCounter()

Returns the counter of packet.

The counter is located at WORD-2.

Bug Note that I DO NOT KNOW THE MAXIMUM NUMBER YET! HOW LOOP LOOKS
LIKE. IT IS SIGNED? or UNSIGNED? ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getCenaByteStream
"uint8_t * IrfPac::SaraPac::SaraPacket::getCenaByteStream()

Returns a copy of byte stream of CENA part.

The CENA memory area is returned. The area is up to the packet ID. If
the packet ID is Cena only, it returns 446 words (WORD 3 to 448/Byte 4
to 895). If the packet ID is Cens-Swim, it returns 318 words (WORD 3
to 320/Byte 4 to 639). Otherwise, NULL is returned. ";

%feature("docstring")
IrfPac::SaraPac::SaraPacket::getCenaByteStreamSize "size_t
IrfPac::SaraPac::SaraPacket::getCenaByteStreamSize()

Returns the size in byte of the area that CENA data occupies. Values
are up to the packet ID.

This must be the same as the size of the array of getCenaByteStream().
CENA_ONLY is 892, CENA_SWIM is 636, otherwize 0. ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getSwimByteStream
"uint8_t * IrfPac::SaraPac::SaraPacket::getSwimByteStream() ";

%feature("docstring")
IrfPac::SaraPac::SaraPacket::getSwimByteStreamSize "size_t
IrfPac::SaraPac::SaraPacket::getSwimByteStreamSize() ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::dumpByteStream "size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::dumpHexStream "size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::dumpHexStream "virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::dumpAll "virtual
void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::dumpAll "virtual
void IrfPac::PacketIntArr< T >::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SaraPacket::equals "virtual
bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classSaraPacket__test.xml
%feature("docstring") SaraPacket_test "";

%feature("docstring")  SaraPacket_test::CPPUNIT_TEST_SUITE "SaraPacket_test::CPPUNIT_TEST_SUITE(SaraPacket_test) ";

%feature("docstring")  SaraPacket_test::CPPUNIT_TEST "SaraPacket_test::CPPUNIT_TEST(testPerformance) ";

%feature("docstring")  SaraPacket_test::CPPUNIT_TEST "SaraPacket_test::CPPUNIT_TEST(testObt) ";

%feature("docstring")  SaraPacket_test::CPPUNIT_TEST_SUITE_END "SaraPacket_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SaraPacket_test::testPerformance "void
SaraPacket_test::testPerformance() ";

%feature("docstring")  SaraPacket_test::testObt "void
SaraPacket_test::testObt() ";


// File: classIrfPac_1_1SaraPac_1_1AscFmt_1_1SaraSpacePac2Bmu.xml
%feature("docstring") IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu "

Implementation of the converter class of 'SpacePacket' to BMU format.

The space packet is the packet that the project team is treating.
Because the definition is not clear, the implementation is done by
'hacking' way of the sample source.

Current definition (2008-10-23) is here.         Pre-header 33 byte +
header 12 byte + contents 896 byte + trail 6 byte This definition is
derived from the 'hacking' way.

See SaraSpacePac2BmuApp.cpp for the usage of this class.

(Below is obsolete, but it is left intentionally as a reminder.)
During the AIT of delivery (2008-04), the definition is as follows.
Header 12 byte + Contents 896 byte The header will be reduced to be 6
byte for the nominal mission.

C++ includes: SaraSpacePac2Bmu.h ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::SaraSpacePac2Bmu "IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::SaraSpacePac2Bmu() ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::spacepac2bmu "std::string
IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::spacepac2bmu(uint8_t
*spacepac)

Convert space packet to BMU format.

Convert space packet (byte array) to BMU format. The spacepac size
should be 902. Otherwise fatal error may occur. No boundary check is
conducted in this method. BE CAREFUL OF THE BUFFER OVERFLOW!! ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::setDetailedCheckEnabled "void
IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::setDetailedCheckEnabled(bool
b) ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::resetCounter "void
IrfPac::SaraPac::AscFmt::SaraSpacePac2Bmu::resetCounter() ";


// File: classSaraSpacePac2Bmu__test.xml
%feature("docstring") SaraSpacePac2Bmu_test "";

%feature("docstring")  SaraSpacePac2Bmu_test::CPPUNIT_TEST_SUITE "SaraSpacePac2Bmu_test::CPPUNIT_TEST_SUITE(SaraSpacePac2Bmu_test) ";

%feature("docstring")  SaraSpacePac2Bmu_test::CPPUNIT_TEST "SaraSpacePac2Bmu_test::CPPUNIT_TEST(test1) ";

%feature("docstring")  SaraSpacePac2Bmu_test::CPPUNIT_TEST "SaraSpacePac2Bmu_test::CPPUNIT_TEST(testcounter) ";

%feature("docstring")  SaraSpacePac2Bmu_test::CPPUNIT_TEST_SUITE_END "SaraSpacePac2Bmu_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SaraSpacePac2Bmu_test::test1 "void
SaraSpacePac2Bmu_test::test1() ";

%feature("docstring")  SaraSpacePac2Bmu_test::testcounter "void
SaraSpacePac2Bmu_test::testcounter() ";


// File: classIrfPac_1_1SaraPac_1_1SasCache.xml
%feature("docstring") IrfPac::SaraPac::SasCache "

Cache of byte stream.

Actually, I believe that this class should be refactored as it extends
GeneralPacket.

C++ includes: SaraDemultiplexor.h ";

%feature("docstring")  IrfPac::SaraPac::SasCache::SasCache "IrfPac::SaraPac::SasCache::SasCache() ";

%feature("docstring")  IrfPac::SaraPac::SasCache::~SasCache "IrfPac::SaraPac::SasCache::~SasCache() ";

%feature("docstring")  IrfPac::SaraPac::SasCache::isEmpty "bool
IrfPac::SaraPac::SasCache::isEmpty() ";

%feature("docstring")  IrfPac::SaraPac::SasCache::getPacket "uint8_t
* IrfPac::SaraPac::SasCache::getPacket()

Returns a copy of the contents of packet. ";

%feature("docstring")  IrfPac::SaraPac::SasCache::flush "uint8_t *
IrfPac::SaraPac::SasCache::flush()

Returns a copy of the contents of packet, and flush the cache. ";

%feature("docstring")  IrfPac::SaraPac::SasCache::append "size_t
IrfPac::SaraPac::SasCache::append(GeneralPacket *saraPac)

Append the GeneralPacket to the cache. ";

%feature("docstring")  IrfPac::SaraPac::SasCache::append "size_t
IrfPac::SaraPac::SasCache::append(uint8_t *byteToAdd, size_t
sizeToAdd)

Append the byte stream to the cache. ";

%feature("docstring")  IrfPac::SaraPac::SasCache::getSize "size_t
IrfPac::SaraPac::SasCache::getSize() ";

%feature("docstring")  IrfPac::SaraPac::SasCache::getCacheSize "size_t IrfPac::SaraPac::SasCache::getCacheSize() ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatx.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatx "

Accumulation matrix data of total count values.

The size is described as [ExDx5] bytes.

C++ includes: SwimAccumTotMatx.h ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::SwimAccumTotMatx "IrfPac::SaraPac::SwimAccumTotMatx::SwimAccumTotMatx(uint8_t *stream,
int n_e, int n_d)

A constructor of SWIM accumulation matrix.

Todo Unknown size of the buffer....They say n_e * n_d * 5,
but.....(Padding??) ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::~SwimAccumTotMatx "IrfPac::SaraPac::SwimAccumTotMatx::~SwimAccumTotMatx() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::reform16x16
"SwimAccumTotMatx * IrfPac::SaraPac::SwimAccumTotMatx::reform16x16()

Create a 16x16 reformed total matrix for SWIM.

New packet that has E=16 D=16 matrix. The returned object is in fact
an instance of SwimAccumTotMatx16x16, but you can use it tranparently
as SwimAccumTotMatx.

Exceptions:
-----------

std::runtime_error:  when the method is applied to the packet which
has not E=32 and D=8.

See:   SwimAccumTotMatx16x16 ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::dumpAll "void IrfPac::SaraPac::SwimAccumTotMatx::dumpAll(FILE *fp)

Dump the contents using default formatter ( SwimAccumTotMatxAllDump).
";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::dump "void
IrfPac::SaraPac::SwimAccumTotMatx::dump(FILE *fp, SwimAccumTotMatxDump
*dump) ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::getRaw "virtual uint8_t IrfPac::SaraPac::SwimAccumTotMatx::getRaw(int i_e, int
i_d, int counter)

Returns the raw value (8bit) corresponding to the specified energy and
deflection_bin. ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::get "virtual uint32_t IrfPac::SaraPac::SwimAccumTotMatx::get(int i_e, int
i_d, int counter)

Returns the value (32 bit) corresponding to the specified energy and
deflection bin.

The value is lin-log compressed (32bit->8bit). This function returnes
the 32 bit decoded values. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::collapseEnergyRaw "virtual
uint32_t IrfPac::SaraPac::SwimAccumTotMatx::collapseEnergyRaw(int i_d,
int counter)

Returns the sum of raw counts over energy for specified deflection bin
and counter.

Note that this is a sum of the raw values (without lin-log
decompression). No physical meaning. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::collapseEnergy "virtual double
IrfPac::SaraPac::SwimAccumTotMatx::collapseEnergy(int i_d, int
counter)

Returns the sum of decompressed counts over energy for specified
deflection bin and counter. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::collapseDeflbinRaw "virtual
uint32_t IrfPac::SaraPac::SwimAccumTotMatx::collapseDeflbinRaw(int
i_e, int counter)

Returns the sum of raw counts over deflection bins for specified
energy bin and counter.

Note that this is a sum of the raw values (without lin-log
decompression). No physical meaning. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::collapseDeflbin "virtual double
IrfPac::SaraPac::SwimAccumTotMatx::collapseDeflbin(int i_e, int
counter)

Returns the sum of decompressed counts over deflection bins for
specified energy bin and counter. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::collapseAllRaw "virtual uint32_t
IrfPac::SaraPac::SwimAccumTotMatx::collapseAllRaw(int counter)

Returns the sum of raw counts over deflection bins and energy for
specified counter.

Note that this is a sum of the raw values (without lin-log
decompression). No physical meaning. ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::collapseAll
"virtual double IrfPac::SaraPac::SwimAccumTotMatx::collapseAll(int
counter)

Returns the sum of lin-log decompressed counts over deflection bins
and energy bins for specified counter. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::getEnergyBins "virtual int
IrfPac::SaraPac::SwimAccumTotMatx::getEnergyBins() ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::getDeflectionBins "virtual int
IrfPac::SaraPac::SwimAccumTotMatx::getDeflectionBins() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::getValues "T * IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::dumpAll "virtual void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatx16x16.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatx16x16 "

An implementation of 16x16-reformed SWIM total matrix.

See:   SwimSciAcc16x16 for details of 16x16 reform.

C++ includes: SwimAccumTotMatx.h ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::SwimAccumTotMatx16x16 "IrfPac::SaraPac::SwimAccumTotMatx16x16::SwimAccumTotMatx16x16(uint8_t
*pac) ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::~SwimAccumTotMatx16x16 "IrfPac::SaraPac::SwimAccumTotMatx16x16::~SwimAccumTotMatx16x16() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::getRaw
"uint8_t IrfPac::SaraPac::SwimAccumTotMatx16x16::getRaw(int aE, int
aD, int iC)

Get raw counts.

See:   get(int,int,int)  Accessor to the raw count. aE and aD should
be 0 to 15. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::reform16x16 "SwimAccumTotMatx
* IrfPac::SaraPac::SwimAccumTotMatx::reform16x16()

Create a 16x16 reformed total matrix for SWIM.

New packet that has E=16 D=16 matrix. The returned object is in fact
an instance of SwimAccumTotMatx16x16, but you can use it tranparently
as SwimAccumTotMatx.

Exceptions:
-----------

std::runtime_error:  when the method is applied to the packet which
has not E=32 and D=8.

See:   SwimAccumTotMatx16x16 ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::dumpAll
"void IrfPac::SaraPac::SwimAccumTotMatx::dumpAll(FILE *fp)

Dump the contents using default formatter ( SwimAccumTotMatxAllDump).
";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::dumpAll
"virtual void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::dump "void IrfPac::SaraPac::SwimAccumTotMatx::dump(FILE *fp,
SwimAccumTotMatxDump *dump) ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::get "virtual uint32_t IrfPac::SaraPac::SwimAccumTotMatx::get(int i_e, int
i_d, int counter)

Returns the value (32 bit) corresponding to the specified energy and
deflection bin.

The value is lin-log compressed (32bit->8bit). This function returnes
the 32 bit decoded values. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::collapseEnergyRaw "virtual
uint32_t IrfPac::SaraPac::SwimAccumTotMatx::collapseEnergyRaw(int i_d,
int counter)

Returns the sum of raw counts over energy for specified deflection bin
and counter.

Note that this is a sum of the raw values (without lin-log
decompression). No physical meaning. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::collapseEnergy "virtual
double IrfPac::SaraPac::SwimAccumTotMatx::collapseEnergy(int i_d, int
counter)

Returns the sum of decompressed counts over energy for specified
deflection bin and counter. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::collapseDeflbinRaw "virtual
uint32_t IrfPac::SaraPac::SwimAccumTotMatx::collapseDeflbinRaw(int
i_e, int counter)

Returns the sum of raw counts over deflection bins for specified
energy bin and counter.

Note that this is a sum of the raw values (without lin-log
decompression). No physical meaning. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::collapseDeflbin "virtual
double IrfPac::SaraPac::SwimAccumTotMatx::collapseDeflbin(int i_e, int
counter)

Returns the sum of decompressed counts over deflection bins for
specified energy bin and counter. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::collapseAllRaw "virtual
uint32_t IrfPac::SaraPac::SwimAccumTotMatx::collapseAllRaw(int
counter)

Returns the sum of raw counts over deflection bins and energy for
specified counter.

Note that this is a sum of the raw values (without lin-log
decompression). No physical meaning. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::collapseAll "virtual double
IrfPac::SaraPac::SwimAccumTotMatx::collapseAll(int counter)

Returns the sum of lin-log decompressed counts over deflection bins
and energy bins for specified counter. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::getEnergyBins "virtual int
IrfPac::SaraPac::SwimAccumTotMatx::getEnergyBins() ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::getDeflectionBins "virtual
int IrfPac::SaraPac::SwimAccumTotMatx::getDeflectionBins() ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::getStream "uint8_t*
IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::getSize
"size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::getIndexSize "size_t
IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatx16x16::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatx16x16::equals
"virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classSwimAccumTotMatx__test.xml
%feature("docstring") SwimAccumTotMatx_test "";

%feature("docstring")  SwimAccumTotMatx_test::CPPUNIT_TEST_SUITE "SwimAccumTotMatx_test::CPPUNIT_TEST_SUITE(SwimAccumTotMatx_test) ";

%feature("docstring")  SwimAccumTotMatx_test::CPPUNIT_TEST "SwimAccumTotMatx_test::CPPUNIT_TEST(testDump) ";

%feature("docstring")  SwimAccumTotMatx_test::CPPUNIT_TEST "SwimAccumTotMatx_test::CPPUNIT_TEST(testDump2) ";

%feature("docstring")  SwimAccumTotMatx_test::CPPUNIT_TEST "SwimAccumTotMatx_test::CPPUNIT_TEST(testReform) ";

%feature("docstring")  SwimAccumTotMatx_test::CPPUNIT_TEST_SUITE_END "SwimAccumTotMatx_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SwimAccumTotMatx_test::testDump "void
SwimAccumTotMatx_test::testDump() ";

%feature("docstring")  SwimAccumTotMatx_test::testDump2 "void
SwimAccumTotMatx_test::testDump2() ";

%feature("docstring")  SwimAccumTotMatx_test::testReform "void
SwimAccumTotMatx_test::testReform() ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatxAllDump.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatxAllDump "

Implementation of All Dump.

C++ includes: SwimAccumTotMatx.h ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatxAllDump::dump
"void IrfPac::SaraPac::SwimAccumTotMatxAllDump::dump(FILE *fp,
SwimAccumTotMatx *matx) ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatxDeflDump.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatxDeflDump "";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatxDeflDump::SwimAccumTotMatxDeflDump "IrfPac::SaraPac::SwimAccumTotMatxDeflDump::SwimAccumTotMatxDeflDump(int
counter_id) ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatxDeflDump::dump
"void IrfPac::SaraPac::SwimAccumTotMatxDeflDump::dump(FILE *fp2,
SwimAccumTotMatx *tot) ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatxDump.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatxDump "

Pure virtual class for formatting the contents of the
SwimAccumTotMatx.

Dumping the contents is always the issue for this kind of library. As
an trial implementation, I made a pure virtual class of
SwimAccumTotMatxDump. This class is intened to be extended to a
concrete class. The instance of one concrete class will be added to
SwimAccumTotMatx class, and the SwimAccumTotMatx::dumpAll(FILE*)
method will dump the contents.

C++ includes: SwimAccumTotMatx.h ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatxDump::~SwimAccumTotMatxDump "virtual
IrfPac::SaraPac::SwimAccumTotMatxDump::~SwimAccumTotMatxDump() ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatxDump::dump "virtual void IrfPac::SaraPac::SwimAccumTotMatxDump::dump(FILE *fp,
SwimAccumTotMatx *matx)=0 ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatxEspecDump.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatxEspecDump "

Implementation of energy spectrum dump for start counter.

C++ includes: SwimAccumTotMatx.h ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatxEspecDump::SwimAccumTotMatxEspecDump
"IrfPac::SaraPac::SwimAccumTotMatxEspecDump::SwimAccumTotMatxEspecDump(int
counter_id) ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatxEspecDump::dump "void
IrfPac::SaraPac::SwimAccumTotMatxEspecDump::dump(FILE *fp2,
SwimAccumTotMatx *tot) ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatxEspecDump8Dir.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatxEspecDump8Dir "

Formatter of SWIM accumulation total matrix to make E-t diagram in
each directions.

The output is 2+8*32=256 list. The order is    nd  ne  count_d=0_e=0
count_d=0_e=1  count_d=0_e=2  ... count_d=0_e=31  count_d=1_e=0 ...
count_d=1_e=31 ... count_d=7_e=0 ... count_d=7_e=31 If no values are
avaiable, -1 is written.

C++ includes: SwimAccumTotMatx.h ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatxEspecDump8Dir::SwimAccumTotMatxEspecDump8Dir
"IrfPac::SaraPac::SwimAccumTotMatxEspecDump8Dir::SwimAccumTotMatxEspecDump8Dir(int
counter_id) ";

%feature("docstring")
IrfPac::SaraPac::SwimAccumTotMatxEspecDump8Dir::dump "void
IrfPac::SaraPac::SwimAccumTotMatxEspecDump8Dir::dump(FILE *fp,
SwimAccumTotMatx *matx) ";


// File: classIrfPac_1_1SaraPac_1_1SwimAccumTotMatxHexDump.xml
%feature("docstring") IrfPac::SaraPac::SwimAccumTotMatxHexDump "

Implementation of HEX dumping class.

C++ includes: SwimAccumTotMatx.h ";

%feature("docstring")  IrfPac::SaraPac::SwimAccumTotMatxHexDump::dump
"void IrfPac::SaraPac::SwimAccumTotMatxHexDump::dump(FILE *fp,
SwimAccumTotMatx *matx) ";


// File: classIrfPac_1_1SaraPac_1_1AscFmt_1_1SwimBmuReader.xml
%feature("docstring") IrfPac::SaraPac::AscFmt::SwimBmuReader "

BMU file reader for SWIM.

BMU file is generated by SaraSimpleDemulApp. This is a start point of
high-level analysis.

The usage is simple:    SwimBmuReader* bmu = new SwimBmuReader();
bmu->readFile(\"/path/to/bmu/swim_xxx.bmu\"); SwimPacketArray *arr =
getArray();  // Here you can get the SwimPacketArray    delete bmu

I'm not sure what happens if you read multiple data, especially the
same BMU file.

C++ includes: SwimBmuReader.h ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SwimBmuReader::~SwimBmuReader "IrfPac::SaraPac::AscFmt::SwimBmuReader::~SwimBmuReader() ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SwimBmuReader::readFile "void
IrfPac::SaraPac::AscFmt::SwimBmuReader::readFile(char *fname) ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::SwimBmuReader::getArray "SwimPacketArray*
IrfPac::SaraPac::AscFmt::SwimBmuReader::getArray()

Returns the read SwimPacket. ";


// File: classIrfPac_1_1SaraPac_1_1SwimFastHkPacket.xml
%feature("docstring") IrfPac::SaraPac::SwimFastHkPacket "

HK field of the science stream of SWIM.

Documentation is in Table 18 of DS0005.

C++ includes: SwimFastHkPacket.h ";

%feature("docstring")
IrfPac::SaraPac::SwimFastHkPacket::SwimFastHkPacket "IrfPac::SaraPac::SwimFastHkPacket::SwimFastHkPacket(uint8_t *stream,
size_t size) ";

%feature("docstring")
IrfPac::SaraPac::SwimFastHkPacket::SwimFastHkPacket "IrfPac::SaraPac::SwimFastHkPacket::SwimFastHkPacket(uint8_t *stream)
";

%feature("docstring")
IrfPac::SaraPac::SwimFastHkPacket::~SwimFastHkPacket "IrfPac::SaraPac::SwimFastHkPacket::~SwimFastHkPacket() ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::dumpAll "void IrfPac::SaraPac::SwimFastHkPacket::dumpAll(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::dumpAll "void IrfPac::SaraPac::SwimFastHkPacket::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getHV "uint16_t IrfPac::SaraPac::SwimFastHkPacket::getHV()

Main HV voltage, HK0. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getVCeem "uint16_t IrfPac::SaraPac::SwimFastHkPacket::getVCeem()

CCEM voltage, HK1. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getVUpDef "uint16_t IrfPac::SaraPac::SwimFastHkPacket::getVUpDef()

Upper deflector voltage, HK2. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getVLoDef "uint16_t IrfPac::SaraPac::SwimFastHkPacket::getVLoDef()

Lower deflector voltage, HK3. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getVAnaCel "uint16_t IrfPac::SaraPac::SwimFastHkPacket::getVAnaCel()

Analyzer voltage, HK4. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getVTofCel "uint16_t IrfPac::SaraPac::SwimFastHkPacket::getVTofCel()

Tof cell voltage, HK5. ";

%feature("docstring")
IrfPac::SaraPac::SwimFastHkPacket::getTempTofBrd "uint16_t
IrfPac::SaraPac::SwimFastHkPacket::getTempTofBrd()

Tof board temperature, HK6. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::SwimFastHkPacket::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimFastHkPacket::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimFastHkPacket::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getValues "T * IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimFastHkPacket::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1SwimMatrix.xml
%feature("docstring") IrfPac::SaraPac::SwimMatrix "

Matrix part of SWIM packet.

See:   SwimPacket

C++ includes: SwimMatrix.h ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::SwimMatrix "IrfPac::SaraPac::SwimMatrix::SwimMatrix(uint8_t *packet, int size) ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::~SwimMatrix "IrfPac::SaraPac::SwimMatrix::~SwimMatrix() ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::dumpAll "void
IrfPac::SaraPac::SwimMatrix::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::decompress "SwimMatrix * IrfPac::SaraPac::SwimMatrix::decompress()

Decompress the packet. Decompress the packet and create new SwimMatrix
instance. After that, the pointer to the instance is returned.

Exceptions:
-----------

NOT_COMPRESSED:  if the packet is not compressed.

ILLEGAL_PACKET:  if the packet is illegally formatted.

DECOMPRESSION_FAILED:  if the decompression failed. ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::interpret "SwimScienceDataPacket* IrfPac::SaraPac::SwimMatrix::interpret(uint8_t
ne, uint8_t nd, uint8_t nm)

Interpret the contents of matrix, and returns the science data packet.

The returned type is SwimScienceDataPacket*, but, this is a base class
for mode dependent (see CENA case). Fortunately, SWIM is only one
mode, only available packet is SwimSciAcc class.

See:   SwimScienceDataPacket

SwimSciAcc ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::dumpByteStream "size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::dumpHexStream "size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::dumpHexStream "virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::dumpAll "virtual
void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimMatrix::equals "virtual
bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1SwimPacket.xml
%feature("docstring") IrfPac::SaraPac::SwimPacket "

SWIM packet.

This is the implementation of SWIM packet. SWIM packet is a data
stream consisting of stuff, HK and science data.

Stuff part contains various information, including time and mode.
Methods to access these fields are implemented in this SwimPacket
class.

HK is a house keeping packet which constitute of 14 byte subpacket.
The packet is implemented in SwimFastHkPacket class.

Science part is not yet implemented.

The data structure is:         0             28
42 variable         |-----
SwimPacket----------------------------------------------------------------------------|
|--- Stuff ---|--- SwimFastHkPacket ---|--- SwimAccumTotMatx ---|---
SwimMatrix --------------| | (convert to) |--- SwimScienceDataPacket
---|

(alternative)  |--- SwimRawData --------| Work routine  SwimPacket
analysis routine is as follows. SwimPacket
*swim=demul->appendSwim(saraPac);   // demul is SaraDemultiplexor
instance.  saraPac is SaraPacket instance.         if(swim!=NULL){  //
swim packet is arrived double univTime=swim->
getUniversalTimeInMsec();  // Obtain universal time of observations.
SwimFastHkPacket* fastHk = swim->getFastHkPac();  // Obtain embedded
house keeping.                 SwimAccumTotMatx* totalMatx = swim->
getAccumTotMatx();  // Obtain the total matrix.
SwimSciAcc* sciMatx;

SwimPacket *swim_decmp = swim-> decompress();  // Decompress packet.
(For non-compressed packet, a copy is returned)
sciMatx=swim_decmp->getSwimSciAcc();  // You can now get the science
matrix.

////                 Here you can use whatever you want. ////

delete swim_decmp;                 delete sciMatx; delete fastHk;
delete swim;         } Reforming matrix of nE=32 and nD=8 Special
treatment should be taken when the binning parameters of SWIM are
E=32, D=8. Because of last minute sensor configuration change, the
binning parameter of (E,D)=(32,8) should be considered as
(E,D)=(16,16).

The SwimSciAcc class and SwimAccumTotMatx class will be affected. To
conduct science analysis, users should know the fact. Because the
policy of the libsadppac is simple and flexible, the conversion is not
done automatically.

Take an example of SwimAccumTotMatx. The instance can be obtained by
SwimAccumTotMatx* totalMatx = swim-> getAccumTotMatx();  // Obtain the
total matrix. as in the previous example. If the binning parameter of
the packet is (E,D)=(32,8),         cout << totalMatx->getEnergyBins()
<< endl;         cout << totalMatx->getDeflectionBins() << endl; will
display 32 and 8. Therefore the matrix cannot be used for science
analysis.

So one should reform the matrix to (E,D)=(16,16). libsadppac prepares
the functionality: SwimAccumTotMatx::reform16x16().
SwimAccumTotMatx* refMatx = totalMatx->reform16x16(); The returned
instance, refMatx, is the reformed matrix to (16,16). Therefore,
cout << refMatx->getEnergyBins() << endl;         cout <<
refMatx->getDeflectionBins() << endl; will return 16 and 16. Technical
details The refMatx in the sample code is in fact the instance of
SwimAccumTotMatx16x16. SwimAccumTotMatx16x16 is a derived class of
SwimAccumTotMatx. Therefore one can use it transparently indentical to
SwimAccumTotMatx.

Conversion from E,D=32,8 to E,D=16,16 is as follows. Assuming that iE
and iD is the index for the original matrix (0<=iE<32; 0<=iD<8) and aE
and aD is the index of the reformed matrix (0<=aE,aD<16).
Original (iE, iD)  ->  Reform (aE, aD) The relationship is         aE
= (int)(iE/2) = (iE >> 1)         aD = (iD*2 + iE mod 2) = (iD << 1) |
(iE & 1) and         iD = aD >> 1         iE = (aE << 1) | (aD & 1)

C++ includes: SwimPacket.h ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::SwimPacket "IrfPac::SaraPac::SwimPacket::SwimPacket(uint8_t *stream, size_t size)
";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::~SwimPacket "IrfPac::SaraPac::SwimPacket::~SwimPacket() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::dumpAll "void
IrfPac::SaraPac::SwimPacket::dumpAll(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::dumpAll "void
IrfPac::SaraPac::SwimPacket::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::printParamsTbl "void IrfPac::SaraPac::SwimPacket::printParamsTbl(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::printParamsTbl2 "void IrfPac::SaraPac::SwimPacket::printParamsTbl2(FILE *fp,
TimeConversion *tconv) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::printParamsTbl3 "void IrfPac::SaraPac::SwimPacket::printParamsTbl3(FILE *fp,
TimeConversion *tconv, bool useUtc) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getHeadMagicNumber
"uint32_t IrfPac::SaraPac::SwimPacket::getHeadMagicNumber()

Returns field of the packet for the identifier of SWIM science packet.

Return the field of identifier of the SWIM science packet. First and
second words in the memory map. In the DPU document, it is specified
as 0xDDDDEEEE. This value is defined as SWIM_SCI_ID field. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getObtTime "uint64_t IrfPac::SaraPac::SwimPacket::getObtTime()

Returns 48 bit BMU OBT @ marker. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getObtTimeInMsec "DEPRECATED double IrfPac::SaraPac::SwimPacket::getObtTimeInMsec()

Get the OBT time at marker in msec.

Deprecated Use getMarkerObt() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getMarkerObt "double IrfPac::SaraPac::SwimPacket::getMarkerObt()

Get marker time in OBT format. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getDpuTime "uint16_t IrfPac::SaraPac::SwimPacket::getDpuTime()

Returns DPU time at marker (word=6) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getTcountDpu "uint16_t IrfPac::SaraPac::SwimPacket::getTcountDpu()

Returns Tcount value from timer (DPU??).

Actullay I do not understand what it means. This method will be
changed in future. ";

%feature("docstring")
IrfPac::SaraPac::SwimPacket::getDpuTimeMarkerInMsec "DEPRECATED
double IrfPac::SaraPac::SwimPacket::getDpuTimeMarkerInMsec()

Deprecated Use getMarkerDpu() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getMarkerDpu "double IrfPac::SaraPac::SwimPacket::getMarkerDpu()

Returns the marker time in DPU format. ";

%feature("docstring")
IrfPac::SaraPac::SwimPacket::getEndIntegCycleTime "uint16_t
IrfPac::SaraPac::SwimPacket::getEndIntegCycleTime() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getTcountAcq "uint16_t IrfPac::SaraPac::SwimPacket::getTcountAcq()

Returns Tcount value from timer (DPU??).

Actullay I do not understand what it means. This method will be
changed in future. ";

%feature("docstring")
IrfPac::SaraPac::SwimPacket::getDataAcquisTimeInMsec "DEPRECATED
double IrfPac::SaraPac::SwimPacket::getDataAcquisTimeInMsec()

Return the DPU time at the end of integration cycles.

Return the DPU time in msec of the end of integration cycles. The
calculation is done as follows. This may be wrong, or true.... I'm not
sure.                         int t = getEndIntegCycleTime(); int dt =
getTcountAcq();                         double acTime = t*31.25 + dt *
2.048; return acTime;Deprecated Use getObsTimeDpu() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getObsTimeDpu "double IrfPac::SaraPac::SwimPacket::getObsTimeDpu()

Return the DPU time at the end of integration cycles.

Return the DPU time in msec of the end of integration cycles. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getEpochTimeInMsec
"DEPRECATED double IrfPac::SaraPac::SwimPacket::getEpochTimeInMsec()

Returns the Universal Time in msec.

Actual formulation is getObtTimeInMsec() + ( getDataAcquisTimeInMsec()
- getDpuTimeMarkerInMsec()  )

You can also find the time related issue in UniversalTimeSample
.Deprecated Use getObsTimeObt(); ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getObsTimeObt "double IrfPac::SaraPac::SwimPacket::getObsTimeObt()

Returns the observation time in OBT. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getUniversalTime "double IrfPac::SaraPac::SwimPacket::getUniversalTime(TimeConversion
*tconv)

Return the universal time in seconds [Origin is the UNIX epoch time as
time_t].

You can also find the time related issue in UniversalTimeSample . ";

%feature("docstring")
IrfPac::SaraPac::SwimPacket::getUniversalTimeInMsec "DEPRECATED
double IrfPac::SaraPac::SwimPacket::getUniversalTimeInMsec()

Returns the Universal Time in msec.

Actual formulation is getObtTimeInMsec() + ( getDataAcquisTimeInMsec()
- getDpuTimeMarkerI nMsec()  )Deprecated Use getEpochTimeInMsec() or
getUniversalTime() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::get8sCycleCntr "uint16_t IrfPac::SaraPac::SwimPacket::get8sCycleCntr()

Returns 8S cycle counter (word-10) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getPacketCounter "uint16_t IrfPac::SaraPac::SwimPacket::getPacketCounter()

An alias for get8sCycleCntr. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getBinningPrm1 "uint16_t IrfPac::SaraPac::SwimPacket::getBinningPrm1()

Binning parameter (word_11)

Returns the binning parameters. Bit 15-8 Post Acc Index

Bit 7-0 Mass bins ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getPostAccIdx "uint8_t IrfPac::SaraPac::SwimPacket::getPostAccIdx() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getMassBins "uint8_t IrfPac::SaraPac::SwimPacket::getMassBins() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getBinningPrm2 "uint16_t IrfPac::SaraPac::SwimPacket::getBinningPrm2()

Binning parameter (word_12)

Returns the binning parameters. Bit 15-8 Deflection bins

Bit 7-0 Energy bins ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getDeflectionBins
"uint8_t IrfPac::SaraPac::SwimPacket::getDeflectionBins() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getEnergyBins "uint8_t IrfPac::SaraPac::SwimPacket::getEnergyBins() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getNrCycles "uint16_t IrfPac::SaraPac::SwimPacket::getNrCycles()

number of cycles for integration (word-13) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getModes "uint16_t IrfPac::SaraPac::SwimPacket::getModes()

modes (word-14) MSB is Swim status byte. (See 9.3.1 on DS-0005 (SWIM
SICD)).

B15-8: Swim status byte                          8: not used
9: mode: 0=idle, 1=sampling 10: selected memory bank
11: HVPS oscillator status: 0=disabled, 1=enabled
12: TDC latch up status: 0=TDC working, 1=TDC shut down (latch up
protection enabled) 13: TDC latch up protection setting: 0=disabled,
1=enabled 14: TDC power status: 0=off, 1=on
15: not used Returns the modes. Logical bit, 1 as ON, 0 as OFF.
B7 SWIM on/off                 B6 CENA on/off B5 Compression EN/DS
B0 Health check event indication ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isTdcPowerOn "bool IrfPac::SaraPac::SwimPacket::isTdcPowerOn() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isLatchUpProtectOn
"bool IrfPac::SaraPac::SwimPacket::isLatchUpProtectOn() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isLatchUp "bool
IrfPac::SaraPac::SwimPacket::isLatchUp() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isHvpsOscOn "bool
IrfPac::SaraPac::SwimPacket::isHvpsOscOn() ";

%feature("docstring")
IrfPac::SaraPac::SwimPacket::isSelectedMemoryBank "bool
IrfPac::SaraPac::SwimPacket::isSelectedMemoryBank() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isModeSampling "bool IrfPac::SaraPac::SwimPacket::isModeSampling() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isSwimOn "bool
IrfPac::SaraPac::SwimPacket::isSwimOn() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isCenaOn "bool
IrfPac::SaraPac::SwimPacket::isCenaOn() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isSwimCompOn "bool IrfPac::SaraPac::SwimPacket::isSwimCompOn() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isHealthCheckEvent
"bool IrfPac::SaraPac::SwimPacket::isHealthCheckEvent() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getSubcomHkPac "SwimSubcHkPacket * IrfPac::SaraPac::SwimPacket::getSubcomHkPac() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getFastHkPac "SwimFastHkPacket* IrfPac::SaraPac::SwimPacket::getFastHkPac() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::hasRawModeData "bool IrfPac::SaraPac::SwimPacket::hasRawModeData()

Checks if there is RAW data available.

The implemented test is theoretically not 100% collision free: It
tests for the presence of a bbbb 3333 header at the location where the
accumulation total matrix starts. As these values are valid for
counter values a small probability of collision exists. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getRawModeData "SwimRawModeData* IrfPac::SaraPac::SwimPacket::getRawModeData()

Returns the pointer to the Swim RAW data array containing 8 sec worth
of raw data.

Calls hasRawModeData() internally to ensure RAW data is present in the
packet. If no RAW data is present then NULL is returned. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getAccumTotMatx "SwimAccumTotMatx* IrfPac::SaraPac::SwimPacket::getAccumTotMatx()

Returns the pointer to the Swim accumulation matrix of total count.

Todo Confirm the boundary. Due to inconsistency between document and
test vector, I do not yet confirm that the SwimAccumTotMatx is
correct. Currently, this problem is avoided by added 2byte for the
calculation of offset to the science matrix. This should be replaced
by more sophisticated way.[2007-11-21]

Prior calling this function the presence of RAW data must be excluded.
RAW data presence can be checked with hasRawModeData(). ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getSwimMatrix "SwimMatrix* IrfPac::SaraPac::SwimPacket::getSwimMatrix() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getSwimSciAcc "SwimSciAcc* IrfPac::SaraPac::SwimPacket::getSwimSciAcc() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isMatrixCompressed
"bool IrfPac::SaraPac::SwimPacket::isMatrixCompressed()

Returns true if the SwimMatrix is compressed. (independent of DPU flag
of SwimCompOn)

Check whether the SwimMatrix is compressed. If the SwimMatrix stream
is compressed, true is returned. If user explicitly decompressed by
decompress() method, the returned value is changed. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::isValid "bool
IrfPac::SaraPac::SwimPacket::isValid()

Check whether the packet format is valid for SwimPacket.

Check items are: First 4 byte is 0xddddeeee

SwimMatrix starts with 0xaa55aa55 or 0xaaddaadd

OBT time is less than 1 year! (Actually it should be less than 21
days, I guess -2009-01-24-)

Todo OBT time check is proper??? ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::decompress "SwimPacket * IrfPac::SaraPac::SwimPacket::decompress()

Returns newly created, rice-decompressed SwimPacket.

Returns the decompressed packet which is newly created. The HK flag
isSwimCompOn() of newly generated packet is not changed. If
decompression is already done, the copy of the packet is returned. If
decompression failed, NULL is returned. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::setUtc "void
IrfPac::SaraPac::SwimPacket::setUtc(double utc) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getUtc "double
IrfPac::SaraPac::SwimPacket::getUtc() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getQualityFlag "int IrfPac::SaraPac::SwimPacket::getQualityFlag() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::setQualityFlag "void IrfPac::SaraPac::SwimPacket::setQualityFlag(int qflag) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::newInstance "SwimPacket* IrfPac::SaraPac::SwimPacket::newInstance() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::dumpByteStream "size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::dumpHexStream "size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::dumpHexStream "virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacket::equals "virtual
bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classSwimPacket__test.xml
%feature("docstring") SwimPacket_test "";

%feature("docstring")  SwimPacket_test::CPPUNIT_TEST_SUITE "SwimPacket_test::CPPUNIT_TEST_SUITE(SwimPacket_test) ";

%feature("docstring")  SwimPacket_test::CPPUNIT_TEST "SwimPacket_test::CPPUNIT_TEST(testInstance) ";

%feature("docstring")  SwimPacket_test::CPPUNIT_TEST "SwimPacket_test::CPPUNIT_TEST(testMagicNumber) ";

%feature("docstring")  SwimPacket_test::CPPUNIT_TEST_SUITE_END "SwimPacket_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SwimPacket_test::testInstance "void
SwimPacket_test::testInstance() ";

%feature("docstring")  SwimPacket_test::testMagicNumber "void
SwimPacket_test::testMagicNumber() ";


// File: classIrfPac_1_1SaraPac_1_1SwimPacketArray.xml
%feature("docstring") IrfPac::SaraPac::SwimPacketArray "

Array of SWIM packet.

C++ includes: SwimPacket.h ";

%feature("docstring")
IrfPac::SaraPac::SwimPacketArray::~SwimPacketArray "IrfPac::SaraPac::SwimPacketArray::~SwimPacketArray() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacketArray::append "void
IrfPac::SaraPac::SwimPacketArray::append(SwimPacket *pac) ";

%feature("docstring")  IrfPac::SaraPac::SwimPacketArray::getPacket "SwimPacket* IrfPac::SaraPac::SwimPacketArray::getPacket(int i)

Get the newly generated SwimPacket* of i-th contents.

You have to delete the returned pointer explicitly. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacketArray::get "DEPRECATED SwimPacket* IrfPac::SaraPac::SwimPacketArray::get(int i)

Get the i-th packet.

Deprecated Use getPacket(int) because this method can break the
contents inside the array. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacketArray::size "size_t
IrfPac::SaraPac::SwimPacketArray::size() ";

%feature("docstring")  IrfPac::SaraPac::SwimPacketArray::getPacketUtc
"double IrfPac::SaraPac::SwimPacketArray::getPacketUtc(int i)

Get the UTC timestamp of the i-th packet without copying the packet.

This is useful when searching for a packet with a specific UTC without
the need to copy each packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimPacketArray::getPacketQualityFlag "int
IrfPac::SaraPac::SwimPacketArray::getPacketQualityFlag(int i)

Get the quality of the i-th packet without copying the packet.

This is useful when searching for a packet with a specific quality
without the need to copy each packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimPacketArray::destroy "void IrfPac::SaraPac::SwimPacketArray::destroy()

Clear the array after destroy all the packet contained. You don't need
to call it directly (ie called from Destructor). ";


// File: classIrfPac_1_1SaraPac_1_1SwimRawModeData.xml
%feature("docstring") IrfPac::SaraPac::SwimRawModeData "

RAW mode data.

The size is described as (4+8+4080)*254 bytes.

C++ includes: SwimRawModeData.h ";

%feature("docstring")
IrfPac::SaraPac::SwimRawModeData::SwimRawModeData "IrfPac::SaraPac::SwimRawModeData::SwimRawModeData(uint8_t *stream)

Number of bytes used for a complete RAW packet.

A constructor of SWIM raw mode data array

size is (4+8+240)*254 ";

%feature("docstring")
IrfPac::SaraPac::SwimRawModeData::~SwimRawModeData "IrfPac::SaraPac::SwimRawModeData::~SwimRawModeData() ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::dumpAll "void IrfPac::SaraPac::SwimRawModeData::dumpAll(FILE *fp)

Dump the contents using default formatter ( SwimRawModeDataAllDump).
";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::dump "void
IrfPac::SaraPac::SwimRawModeData::dump(FILE *fp, SwimRawModeDataDump
*dump) ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getRawByte "virtual uint8_t IrfPac::SaraPac::SwimRawModeData::getRawByte(int slot,
int offset)

Returns the offset byte of the n'th RAW packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getSlotId "virtual uint8_t IrfPac::SaraPac::SwimRawModeData::getSlotId(int slot)

Returns the slot ID (8bit) for the n'th RAW packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimRawModeData::getMaxRawPacket "virtual int
IrfPac::SaraPac::SwimRawModeData::getMaxRawPacket()

Returns the number of RAW packets available. The highest slot id is
number of RAW packets-1.

Todo add some checks to validate the number? ";

%feature("docstring")
IrfPac::SaraPac::SwimRawModeData::getMaxTofEvents "virtual int
IrfPac::SaraPac::SwimRawModeData::getMaxTofEvents()

Returns the number of RAW packets available. The number of TOF events
in a RAW packet.

Todo add some checks to validate the number? ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getStart "virtual uint16_t IrfPac::SaraPac::SwimRawModeData::getStart(int slot)

Returns Start counter value of the slot'th RAW packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getStop "virtual uint16_t IrfPac::SaraPac::SwimRawModeData::getStop(int slot)

Returns Stop counter value of the slot'th RAW packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getOver "virtual uint16_t IrfPac::SaraPac::SwimRawModeData::getOver(int slot)

Returns Over counter value of the slot'th RAW packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getUnder "virtual uint16_t IrfPac::SaraPac::SwimRawModeData::getUnder(int slot)

Returns Under counter value of the slot'th RAW packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getTof "virtual uint8_t IrfPac::SaraPac::SwimRawModeData::getTof(int slot, int
i_tof)

Returns the i_tof'th TOF value of the slot'th RAW packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::SwimRawModeData::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::dumpHexStream
"size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::dumpHexStream
"virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getValues "T
* IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::dumpAll "virtual void IrfPac::PacketIntArr< T >::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeData::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1SwimRawModeDataAllDump.xml
%feature("docstring") IrfPac::SaraPac::SwimRawModeDataAllDump "

Implementation of All Dump.

C++ includes: SwimRawModeData.h ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeDataAllDump::dump "void IrfPac::SaraPac::SwimRawModeDataAllDump::dump(FILE *fp,
SwimRawModeData *matx) ";


// File: classIrfPac_1_1SaraPac_1_1SwimRawModeDataDump.xml
%feature("docstring") IrfPac::SaraPac::SwimRawModeDataDump "

Pure virtual class for formatting the contents of the SwimRawModeData.

Dumping the contents is always the issue for this kind of library. As
an trial implementation, I made a pure virtual class of
SwimRawModeDataDump. This class is intened to be extended to a
concrete class. The instance of one concrete class will be added to
SwimRawModeData class, and the SwimRawModeData::dumpAll(FILE*) method
will dump the contents.

C++ includes: SwimRawModeData.h ";

%feature("docstring")
IrfPac::SaraPac::SwimRawModeDataDump::~SwimRawModeDataDump "virtual
IrfPac::SaraPac::SwimRawModeDataDump::~SwimRawModeDataDump() ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeDataDump::dump "virtual void IrfPac::SaraPac::SwimRawModeDataDump::dump(FILE *fp,
SwimRawModeData *matx)=0 ";


// File: classIrfPac_1_1SaraPac_1_1SwimRawModeDataHexDump.xml
%feature("docstring") IrfPac::SaraPac::SwimRawModeDataHexDump "

Implementation of HEX dumping class.

C++ includes: SwimRawModeData.h ";

%feature("docstring")  IrfPac::SaraPac::SwimRawModeDataHexDump::dump "void IrfPac::SaraPac::SwimRawModeDataHexDump::dump(FILE *fp,
SwimRawModeData *matx) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciAcc.xml
%feature("docstring") IrfPac::SaraPac::SwimSciAcc "

Science data of SWIM.

C++ includes: SwimSciAcc.h ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::SwimSciAcc "IrfPac::SaraPac::SwimSciAcc::SwimSciAcc(uint8_t *pac, int nEnergy, int
nDefl, int nMass) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::~SwimSciAcc "virtual IrfPac::SaraPac::SwimSciAcc::~SwimSciAcc() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::reform16x16 "SwimSciAcc * IrfPac::SaraPac::SwimSciAcc::reform16x16()

Create a 16x16 reformed science matrix for SWIM.

New packet that has E=16 D=16 matrix. The returned object is a
instance of SwimSciAcc16x16.

Exceptions:
-----------

std::runtime_error:  when this method is applied non-maximum mode
(E=32,D=8) data.

See:   SwimSciAcc16x16 ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getRaw "uint8_t
IrfPac::SaraPac::SwimSciAcc::getRaw(int iE, int iD, int iM)

Returns the raw count in the specified energy, deflection and mass. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::get "uint16_t
IrfPac::SaraPac::SwimSciAcc::get(int iE, int iD, int iM)

Returns the lin-log decompressed count in the specified energy,
deflection and mass. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::collapseAll "virtual double IrfPac::SaraPac::SwimSciAcc::collapseAll()

Returns the total count rate over all the energy, deflection and mass
channel. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::collapseED "virtual double IrfPac::SaraPac::SwimSciAcc::collapseED(int im)

Returns the total count rate of specified mass bins summed over all
the energy and deflection. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::collapseDM "virtual double IrfPac::SaraPac::SwimSciAcc::collapseDM(int ie)

Returns the total count rate of specified energy bins summed over all
the deflection and mass. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::collapseEM "virtual double IrfPac::SaraPac::SwimSciAcc::collapseEM(int id)

Returns the total count rate of specified deflection bins summed over
all the energy and mass. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::dumpAll "virtual
void IrfPac::SaraPac::SwimSciAcc::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::dumpAll "void
IrfPac::SaraPac::SwimSciAcc::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getNrEne "virtual
int IrfPac::SaraPac::SwimSciAcc::getNrEne() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getNrDefl "virtual int IrfPac::SaraPac::SwimSciAcc::getNrDefl() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getNrMass "virtual int IrfPac::SaraPac::SwimSciAcc::getNrMass() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::dumpByteStream "size_t IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::dumpHexStream "size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::dumpHexStream "virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getSize "size_t
IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getIndexSize "size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::hash "std::string
IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc::equals "virtual
bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciAcc16x16.xml
%feature("docstring") IrfPac::SaraPac::SwimSciAcc16x16 "

An implementation of 16x16-reformed SWIM science matrix.

SWIM has several binning parameters. Energy and deflection bin numbers
(and mass as well) can be set by commanding. However, the case of E=32
D=8 is not straight forward. In this case, even DPU says E=32 D=8, the
actual observations is done by E=16 D=16 mode. I don't know in which
document this fact is described, but in fact this is what it is.

This libsadppac supports this functionality by using a object-oriented
advantage. SwimSciAcc instance has a method to convert the packet to
16x16-reformed packet. This method returns the pointer to SwimSciAcc,
but it is in fact an instance of SwimSciAcc16x16. However, users can
use the returned instance as it is SwimSciAcc instance, obviously,
because SwimSciAcc16x16 is an extended class of SwimSciAcc.

Anyway, you can look at the example below.

SwimPacket *spac=...;   // Assume that we have SwimPacket with
E=32,D=8. SwimSciAcc *sciMatx=spac->getSwimSciAcc();   // Obtaining
science matrix SwimSciAcc.    cout << sciMatx->getNrEne() << endl;
// Energy step is 32 cout << sciMatx->getNrDefl() << endl;   //
Deflector bins is 8

SwimSciAcc *sciMatx16x16=sciMatx-> reform16x16();   // Reform the
science matrix    cout << sciMatx16x16->getNrEne() << endl;  // Energy
step is 16    cout << sciMatx16x16->getNrDefl() << endl;   //
Deflector bins is 16

delete spac;    delete sciMatx;    delete sciMatx16x16;

Similar conversion should be done in SwimAccumTotMatx class.

C++ includes: SwimSciAcc.h ";

%feature("docstring")
IrfPac::SaraPac::SwimSciAcc16x16::SwimSciAcc16x16 "IrfPac::SaraPac::SwimSciAcc16x16::SwimSciAcc16x16(uint8_t *pac, int
nMass) ";

%feature("docstring")
IrfPac::SaraPac::SwimSciAcc16x16::~SwimSciAcc16x16 "IrfPac::SaraPac::SwimSciAcc16x16::~SwimSciAcc16x16() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getRaw "uint8_t IrfPac::SaraPac::SwimSciAcc16x16::getRaw(int aE, int aD, int
iM)

Obtain raw count for 16x16 matrix.(not yet implemented...sorry)

See:   get(int,int,int) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::reform16x16 "SwimSciAcc * IrfPac::SaraPac::SwimSciAcc::reform16x16()

Create a 16x16 reformed science matrix for SWIM.

New packet that has E=16 D=16 matrix. The returned object is a
instance of SwimSciAcc16x16.

Exceptions:
-----------

std::runtime_error:  when this method is applied non-maximum mode
(E=32,D=8) data.

See:   SwimSciAcc16x16 ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::get "uint16_t IrfPac::SaraPac::SwimSciAcc::get(int iE, int iD, int iM)

Returns the lin-log decompressed count in the specified energy,
deflection and mass. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::collapseAll "virtual double IrfPac::SaraPac::SwimSciAcc::collapseAll()

Returns the total count rate over all the energy, deflection and mass
channel. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::collapseED "virtual double IrfPac::SaraPac::SwimSciAcc::collapseED(int im)

Returns the total count rate of specified mass bins summed over all
the energy and deflection. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::collapseDM "virtual double IrfPac::SaraPac::SwimSciAcc::collapseDM(int ie)

Returns the total count rate of specified energy bins summed over all
the deflection and mass. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::collapseEM "virtual double IrfPac::SaraPac::SwimSciAcc::collapseEM(int id)

Returns the total count rate of specified deflection bins summed over
all the energy and mass. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::dumpAll "virtual void IrfPac::SaraPac::SwimSciAcc::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::dumpAll "void IrfPac::SaraPac::SwimSciAcc::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getNrEne "virtual int IrfPac::SaraPac::SwimSciAcc::getNrEne() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getNrDefl "virtual int IrfPac::SaraPac::SwimSciAcc::getNrDefl() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getNrMass "virtual int IrfPac::SaraPac::SwimSciAcc::getNrMass() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::SwimSciAcc16x16::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::dumpHexStream
"size_t IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::dumpHexStream
"virtual size_t IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getValues "T
* IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAcc16x16::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classSwimSciAcc__test.xml
%feature("docstring") SwimSciAcc_test "";

%feature("docstring")  SwimSciAcc_test::CPPUNIT_TEST_SUITE "SwimSciAcc_test::CPPUNIT_TEST_SUITE(SwimSciAcc_test) ";

%feature("docstring")  SwimSciAcc_test::CPPUNIT_TEST "SwimSciAcc_test::CPPUNIT_TEST(testTest) ";

%feature("docstring")  SwimSciAcc_test::CPPUNIT_TEST "SwimSciAcc_test::CPPUNIT_TEST(testSwimSciAcc16x16) ";

%feature("docstring")  SwimSciAcc_test::CPPUNIT_TEST "SwimSciAcc_test::CPPUNIT_TEST(testSwimSciAcc16x16exception) ";

%feature("docstring")  SwimSciAcc_test::CPPUNIT_TEST_SUITE_END "SwimSciAcc_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  SwimSciAcc_test::testTest "void
SwimSciAcc_test::testTest() ";

%feature("docstring")  SwimSciAcc_test::testSwimSciAcc16x16exception "void SwimSciAcc_test::testSwimSciAcc16x16exception() ";

%feature("docstring")  SwimSciAcc_test::testSwimSciAcc16x16 "void
SwimSciAcc_test::testSwimSciAcc16x16() ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciAccD16SpectraDump.xml
%feature("docstring") IrfPac::SaraPac::SwimSciAccD16SpectraDump "

Dump with 16 directions summed over all the energy and mass.

C++ includes: SwimSciAcc.h ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAccD16SpectraDump::dump
"void IrfPac::SaraPac::SwimSciAccD16SpectraDump::dump(FILE *fp,
SwimSciAcc *matx) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciAccDSpectraDump.xml
%feature("docstring") IrfPac::SaraPac::SwimSciAccDSpectraDump "";

%feature("docstring")  IrfPac::SaraPac::SwimSciAccDSpectraDump::dump "void IrfPac::SaraPac::SwimSciAccDSpectraDump::dump(FILE *fp,
SwimSciAcc *matx) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciAccDump.xml
%feature("docstring") IrfPac::SaraPac::SwimSciAccDump "";

%feature("docstring")
IrfPac::SaraPac::SwimSciAccDump::~SwimSciAccDump "virtual
IrfPac::SaraPac::SwimSciAccDump::~SwimSciAccDump() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciAccDump::dump "virtual
void IrfPac::SaraPac::SwimSciAccDump::dump(FILE *fp, SwimSciAcc
*matx)=0 ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciAccESpectraDump.xml
%feature("docstring") IrfPac::SaraPac::SwimSciAccESpectraDump "";

%feature("docstring")  IrfPac::SaraPac::SwimSciAccESpectraDump::dump "void IrfPac::SaraPac::SwimSciAccESpectraDump::dump(FILE *fp,
SwimSciAcc *matx) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciAccMSpectraDump.xml
%feature("docstring") IrfPac::SaraPac::SwimSciAccMSpectraDump "";

%feature("docstring")  IrfPac::SaraPac::SwimSciAccMSpectraDump::dump "void IrfPac::SaraPac::SwimSciAccMSpectraDump::dump(FILE *fp,
SwimSciAcc *matx) ";


// File: classSwimSciDump.xml
%feature("docstring") SwimSciDump "";

%feature("docstring")  SwimSciDump::SwimSciDump "SwimSciDump::SwimSciDump(char *dirname) ";

%feature("docstring")  SwimSciDump::flush "void SwimSciDump::flush()
";

%feature("docstring")  SwimSciDump::close "void SwimSciDump::close()
";

%feature("docstring")  SwimSciDump::add "void
SwimSciDump::add(SwimPacket *swim, TimeConversion *tconv) ";


// File: classIrfPac_1_1SaraPac_1_1SwimScienceDataPacket.xml
%feature("docstring") IrfPac::SaraPac::SwimScienceDataPacket "

Base class for mode-dependent SWIM science data.

C++ includes: SwimScienceDataPacket.h ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::SwimScienceDataPacket "IrfPac::SaraPac::SwimScienceDataPacket::SwimScienceDataPacket(uint8_t
*stream, size_t size) ";

%feature("docstring")  IrfPac::SaraPac::SwimScienceDataPacket::dumpAll
"virtual void IrfPac::SaraPac::SwimScienceDataPacket::dumpAll() ";

%feature("docstring")  IrfPac::SaraPac::SwimScienceDataPacket::dumpAll
"void IrfPac::SaraPac::SwimScienceDataPacket::dumpAll(FILE *fp) ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::getStream "uint8_t*
IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimScienceDataPacket::getSize
"size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::getIndexSize "size_t
IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::getValues "T *
IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")
IrfPac::SaraPac::SwimScienceDataPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimScienceDataPacket::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimScienceDataPacket::equals
"virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciencePackage.xml
%feature("docstring") IrfPac::SaraPac::SwimSciencePackage "

A class for dumping SWIM science package.

Series of SwimPacket is converted to so-called science package format
which is to be used idlscilib and other programs. The package is
generated also by SaraDemultiplex program. The package is a folder
structure such as:    package_name.pkg -+- swim
+- swimhk +- swimsci -+- 01hk                                  +-
02sclstr +- 03sclstp                                  +- .... Reading
routine is NOT implemented in libsadppac, however, you can use
SwimBmuReader for the file package_name.pkg/swim in order to
reconstruct SwimPacketArray. Time Conversion Time conversion is
represented by an extended class of TimeConversion. You can set
TimeConversion class by setTimeConversion(TimeConversion) method.

If TimeConversion is set, the program uses the specified time
conversion. If it is not set (default), the dump() method try to call
getUtc() method. In case getUtc() is not defined (this happens if you
read the data from SARA BMU format), no conversion is made (i.e. time
should be very small value close to 1970's).

C++ includes: SwimSciencePackage.h ";

%feature("docstring")
IrfPac::SaraPac::SwimSciencePackage::SwimSciencePackage "IrfPac::SaraPac::SwimSciencePackage::SwimSciencePackage() ";

%feature("docstring")
IrfPac::SaraPac::SwimSciencePackage::~SwimSciencePackage "IrfPac::SaraPac::SwimSciencePackage::~SwimSciencePackage() ";

%feature("docstring")
IrfPac::SaraPac::SwimSciencePackage::setTimeConversion "void
IrfPac::SaraPac::SwimSciencePackage::setTimeConversion(TimeConversion
*tConv)

Set time conversion method.

Specify the method of time conversion. Look at \"Time conversion'
section in the class description.

This method just copy the pointer of tConv. No new/delete is done. So
be careful that tConv should not be deleted. ";

%feature("docstring")
IrfPac::SaraPac::SwimSciencePackage::appendSwimPacketArray "void
IrfPac::SaraPac::SwimSciencePackage::appendSwimPacketArray(SwimPacketArray
*arr) ";

%feature("docstring")
IrfPac::SaraPac::SwimSciencePackage::appendSwimPacket "void
IrfPac::SaraPac::SwimSciencePackage::appendSwimPacket(SwimPacket *pac)
";

%feature("docstring")  IrfPac::SaraPac::SwimSciencePackage::dump "void IrfPac::SaraPac::SwimSciencePackage::dump(char *pkgname) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSciencePackageDump.xml
%feature("docstring") IrfPac::SaraPac::SwimSciencePackageDump "";

%feature("docstring")
IrfPac::SaraPac::SwimSciencePackageDump::SwimSciencePackageDump "IrfPac::SaraPac::SwimSciencePackageDump::SwimSciencePackageDump(char
*dirname) ";

%feature("docstring")  IrfPac::SaraPac::SwimSciencePackageDump::flush
"void IrfPac::SaraPac::SwimSciencePackageDump::flush() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciencePackageDump::close
"void IrfPac::SaraPac::SwimSciencePackageDump::close() ";

%feature("docstring")  IrfPac::SaraPac::SwimSciencePackageDump::add "void IrfPac::SaraPac::SwimSciencePackageDump::add(SwimPacket *swim,
TimeConversion *tconv) ";


// File: classIrfPac_1_1SaraPac_1_1SwimSubcHkPacket.xml
%feature("docstring") IrfPac::SaraPac::SwimSubcHkPacket "

HK field of the science stream of SWIM.

Documentation is in Table 18 of DS0005.

Deprecated  SwimSubcHkPacket class is deprecated because the 'subc'
confuses the user. Use the complementary class of SwimFastHkPacket.

C++ includes: SwimSubcHkPacket.h ";

%feature("docstring")
IrfPac::SaraPac::SwimSubcHkPacket::SwimSubcHkPacket "IrfPac::SaraPac::SwimSubcHkPacket::SwimSubcHkPacket(uint8_t *stream,
size_t size) ";

%feature("docstring")
IrfPac::SaraPac::SwimSubcHkPacket::SwimSubcHkPacket "IrfPac::SaraPac::SwimSubcHkPacket::SwimSubcHkPacket(uint8_t *stream)
";

%feature("docstring")
IrfPac::SaraPac::SwimSubcHkPacket::~SwimSubcHkPacket "IrfPac::SaraPac::SwimSubcHkPacket::~SwimSubcHkPacket() ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::dumpAll "DEPRECATED void IrfPac::SaraPac::SwimSubcHkPacket::dumpAll(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::dumpAll "void IrfPac::SaraPac::SwimSubcHkPacket::dumpAll(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getHV "DEPRECATED uint16_t IrfPac::SaraPac::SwimSubcHkPacket::getHV()

Main HV voltage, HK0. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getVCeem "DEPRECATED uint16_t IrfPac::SaraPac::SwimSubcHkPacket::getVCeem()

CCEM voltage, HK1. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getVUpDef "DEPRECATED uint16_t IrfPac::SaraPac::SwimSubcHkPacket::getVUpDef()

Upper deflector voltage, HK2. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getVLoDef "DEPRECATED uint16_t IrfPac::SaraPac::SwimSubcHkPacket::getVLoDef()

Lower deflector voltage, HK3. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getVAnaCel "DEPRECATED uint16_t IrfPac::SaraPac::SwimSubcHkPacket::getVAnaCel()

Analyzer voltage, HK4. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getVTofCel "DEPRECATED uint16_t IrfPac::SaraPac::SwimSubcHkPacket::getVTofCel()

Tof cell voltage, HK5. ";

%feature("docstring")
IrfPac::SaraPac::SwimSubcHkPacket::getTempTofBrd "DEPRECATED uint16_t
IrfPac::SaraPac::SwimSubcHkPacket::getTempTofBrd()

Tof board temperature, HK6. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getStream "uint8_t* IrfPac::PacketU8Arr::getStream()

Returns the copy of the contents of byte stream.

Since returned stream is a copy of the original, the returned stream
should be explicitly deleted by delete[] operation. ";

%feature("docstring")
IrfPac::SaraPac::SwimSubcHkPacket::dumpByteStream "size_t
IrfPac::PacketIntArr< T >::dumpByteStream(FILE *)

Dump the byte stream into the specified file. Returned value is the
size of the dumped stream in bytes, which is normally the size of the
packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimSubcHkPacket::dumpHexStream "size_t
IrfPac::PacketIntArr< T >::dumpHexStream(FILE *fp)

Dump the ascii-hex expression of the stream into the specified file.
Returned value is the size of the dumped stream in bytes, which is
normally the size of the packet. ";

%feature("docstring")
IrfPac::SaraPac::SwimSubcHkPacket::dumpHexStream "virtual size_t
IrfPac::PacketIntArr< T >::dumpHexStream() ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getSize "size_t IrfPac::PacketIntArr< T >::getSize()

Returns the size of the packet. The unit of the size is BYTEs. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getIndexSize
"size_t IrfPac::PacketIntArr< T >::getIndexSize() ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getValues "T * IrfPac::PacketIntArr< T >::getValues(void) ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::getValue "T
IrfPac::PacketIntArr< T >::getValue(size_t index) ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::hash "std::string IrfPac::PacketIntArr< T >::hash()

Returns a hash of the packet contents.

The implementation uses MD5. It needs openssl crypto packge. ";

%feature("docstring")  IrfPac::SaraPac::SwimSubcHkPacket::equals "virtual bool IrfPac::GeneralPacket::equals(GeneralPacket *pac) ";


// File: classIrfPac_1_1SaraPac_1_1TimeConversion.xml
%feature("docstring") IrfPac::SaraPac::TimeConversion "

Virtual class of time conversion between OBT and UTC.

C++ includes: TimeConversion.h ";

%feature("docstring")
IrfPac::SaraPac::TimeConversion::~TimeConversion "virtual
IrfPac::SaraPac::TimeConversion::~TimeConversion() ";

%feature("docstring")  IrfPac::SaraPac::TimeConversion::obt2utc "virtual double IrfPac::SaraPac::TimeConversion::obt2utc(double obt)=0

Convert double-precision OBT value to double-precision UTC time.

OBT time is obtained from CenaPacket or SwimPacket. The unit should be
in milisec. UTC time is the Unix epoch time (identical to time_t for
integer part) with 3-rd order after the decimal point. ";


// File: classTimeConversion__test.xml
%feature("docstring") TimeConversion_test "";

%feature("docstring")  TimeConversion_test::CPPUNIT_TEST_SUITE "TimeConversion_test::CPPUNIT_TEST_SUITE(TimeConversion_test) ";

%feature("docstring")  TimeConversion_test::CPPUNIT_TEST "TimeConversion_test::CPPUNIT_TEST(testConversionOffsetOrigin) ";

%feature("docstring")  TimeConversion_test::CPPUNIT_TEST "TimeConversion_test::CPPUNIT_TEST(testConversionOffsetConv) ";

%feature("docstring")  TimeConversion_test::CPPUNIT_TEST_SUITE_END "TimeConversion_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  TimeConversion_test::testConversionOffsetOrigin
"void TimeConversion_test::testConversionOffsetOrigin() ";

%feature("docstring")  TimeConversion_test::testConversionOffsetConv "void TimeConversion_test::testConversionOffsetConv() ";


// File: classIrfPac_1_1SaraPac_1_1TimeConversionOffset.xml
%feature("docstring") IrfPac::SaraPac::TimeConversionOffset "

An implementation of OBT-UTC conversion.

One way to calculate UTC from OBT is using offset. Because the OBT is
21-day periodic with msec unit, if you know the origin of the OBT in
UTC, you can convert OBT to UTC at any time.

The offset looks like as follows. Note that this estimation is done
very primitive way, it is not guaranteed the results. You may have to
use TimeConversionTimeFile class for precise calculation.    OFFSET(0)
2008-10-21T23:57:03    1224633423    OFFSET(1) 2008-11-11T23:57:03
1226447823    OFFSET(2)    2008-12-02T23:57:03 1228262223    OFFSET(3)
2008-12-23T23:57:03    1230076623 OFFSET(4)    2009-01-13T23:57:03
1231891023        OFFSET(5) 2009-02-03T23:57:03    1233705423
OFFSET(6)    2009-02-24T23:57:03 1235519823    ...

C++ includes: TimeConversion.h ";

%feature("docstring")
IrfPac::SaraPac::TimeConversionOffset::TimeConversionOffset "IrfPac::SaraPac::TimeConversionOffset::TimeConversionOffset(double
offset) ";

%feature("docstring")  IrfPac::SaraPac::TimeConversionOffset::obt2utc
"double IrfPac::SaraPac::TimeConversionOffset::obt2utc(double obt)

Convert double-precision OBT value to double-precision UTC time.

OBT time is obtained from CenaPacket or SwimPacket. The unit should be
in milisec. UTC time is the Unix epoch time (identical to time_t for
integer part) with 3-rd order after the decimal point. ";


// File: classIrfPac_1_1SaraPac_1_1AscFmt_1_1TimeConversionTimeFile.xml
%feature("docstring") IrfPac::SaraPac::AscFmt::TimeConversionTimeFile
"

TimeConversion implementation from TimeFile.

The 21-day roll over is now supported.

C++ includes: TimeFile.h ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::TimeConversionTimeFile
"IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::TimeConversionTimeFile(TimeFile
*tfile) ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::~TimeConversionTimeFile
"IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::~TimeConversionTimeFile()
";

%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::getStartTime "double
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::getStartTime() ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::getStopTime "double
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::getStopTime() ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::obt2utc "double
IrfPac::SaraPac::AscFmt::TimeConversionTimeFile::obt2utc(double
obt_in)

Convert double-precision OBT value to double-precision UTC time.

OBT time is obtained from CenaPacket or SwimPacket. The unit should be
in milisec. UTC time is the Unix epoch time (identical to time_t for
integer part) with 3-rd order after the decimal point. ";


// File: classIrfPac_1_1SaraPac_1_1AscFmt_1_1TimeConversionTimeFileExtpol.xml
%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFileExtpol "

TimeConversion implementation from TimeFile with extrapolation
support.

From data on time file, the conversion is apploximated by linear
function as    UTC = coeff * OBT + offset

The 21-day roll-over is supported.

C++ includes: TimeFile.h ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFileExtpol::TimeConversionTimeFileExtpol
"IrfPac::SaraPac::AscFmt::TimeConversionTimeFileExtpol::TimeConversionTimeFileExtpol(TimeFile
*tfile) ";

%feature("docstring")
IrfPac::SaraPac::AscFmt::TimeConversionTimeFileExtpol::obt2utc "double
IrfPac::SaraPac::AscFmt::TimeConversionTimeFileExtpol::obt2utc(double
obt)

Convert from OBT to UTC.

Return the corresponding UTC (epoch) from OBT. ";


// File: classIrfPac_1_1SaraPac_1_1AscFmt_1_1TimeFile.xml
%feature("docstring") IrfPac::SaraPac::AscFmt::TimeFile "

Time file reader.

This class corresponds to the time file. The time file is provided by
project. The time file describes the conversion from OBT to UTC. OBT
is in the unit of milliseconds. getObt2Utc() will return the map from
OBT to UTC.

OBT has a roll-over with 21 days (=21*86400e3). Detection of OBT roll-
over is currently done by comparing the first and last OBT values.
When roll-over is detected, the rollover flag is set, and users can
know by a method of isRollover(). In this case, the OBT value (key) of
the map returned by getObt2Utc() is incremented by 21 days from the
original contents.

Therefore, users have to check isRollover(), and if it is true, you
have to add 21 days to the input OBT after the roll-over. Well, it is
difficult to say in English, so please look at the implementaion. The
implementation of TimeConversionTimeFile class will be a good example.

C++ includes: TimeFile.h ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::TimeFile "IrfPac::SaraPac::AscFmt::TimeFile::TimeFile() ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::~TimeFile "IrfPac::SaraPac::AscFmt::TimeFile::~TimeFile() ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::readFile "void IrfPac::SaraPac::AscFmt::TimeFile::readFile(FILE *fp) ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::getFirstObt
"double IrfPac::SaraPac::AscFmt::TimeFile::getFirstObt()

Obtain the OBT of the first packet . ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::getLastObt "double IrfPac::SaraPac::AscFmt::TimeFile::getLastObt()

Obtain the OBT of the last packet . ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::isRollover "bool IrfPac::SaraPac::AscFmt::TimeFile::isRollover()

Return true if roll over is found.

Rollover is decided by getFirstObt()> getLastObt(); ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::getObt2Utc "std::map<double, double>*
IrfPac::SaraPac::AscFmt::TimeFile::getObt2Utc()

Return the conversion look up table.

You have to delete the returned pointer explicitly. ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::showSummary
"void IrfPac::SaraPac::AscFmt::TimeFile::showSummary(FILE *fp)

Show summary of the contents. ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::TimeFile::showContents
"void IrfPac::SaraPac::AscFmt::TimeFile::showContents(FILE *fp)

Show contents of the time file contents. ";


// File: classTimeFile__test.xml
%feature("docstring") TimeFile_test "";

%feature("docstring")  TimeFile_test::CPPUNIT_TEST_SUITE "TimeFile_test::CPPUNIT_TEST_SUITE(TimeFile_test) ";

%feature("docstring")  TimeFile_test::CPPUNIT_TEST "TimeFile_test::CPPUNIT_TEST(testRead) ";

%feature("docstring")  TimeFile_test::CPPUNIT_TEST "TimeFile_test::CPPUNIT_TEST(testTimeConversion) ";

%feature("docstring")  TimeFile_test::CPPUNIT_TEST "TimeFile_test::CPPUNIT_TEST(testTimeConversionRO) ";

%feature("docstring")  TimeFile_test::CPPUNIT_TEST_SUITE_END "TimeFile_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  TimeFile_test::testRead "void
TimeFile_test::testRead() ";

%feature("docstring")  TimeFile_test::testTimeConversion "void
TimeFile_test::testTimeConversion() ";

%feature("docstring")  TimeFile_test::testTimeConversionRO "void
TimeFile_test::testTimeConversionRO() ";


// File: classIrfPac_1_1SaraPac_1_1TimePacket.xml
%feature("docstring") IrfPac::SaraPac::TimePacket "

Contents of times file.

Time file is provided from CY-1 project. The file contains the time
conversion information, each of which corresponds to one packet.

Packet structure is described by Structure(OBT-UTC conversion).doc,
which is also provided from project.

The packet constitute of a structure defined by    typedef struct    {
int OrbitNo;   // 32bit         long long DHOBT_l;   // 64bit -> 40
bit DH-OBT         int DHOBT_i4;   // 32bit -> 32 bit DH-OBT
double BMUOBT_d;  // 64bit -> BMU OBT int UTCTime_7i4[7];  // 32bit x
7  UTC time yr, mon, dy, hr, min, sec, .1 msec         unsigned char
BMUIndication_c;  // 8bit    }TMRecord;

One packet consistitue of 53 byte. For SARA, we use BMUOBT_d and
UTCTime_7i4 only.

C++ includes: TimePacket.h ";

%feature("docstring")  IrfPac::SaraPac::TimePacket::TimePacket "IrfPac::SaraPac::TimePacket::TimePacket(uint8_t *pac) ";

%feature("docstring")  IrfPac::SaraPac::TimePacket::~TimePacket "IrfPac::SaraPac::TimePacket::~TimePacket() ";

%feature("docstring")  IrfPac::SaraPac::TimePacket::getObtTimeDouble "double IrfPac::SaraPac::TimePacket::getObtTimeDouble() ";

%feature("docstring")  IrfPac::SaraPac::TimePacket::getGmt "double
IrfPac::SaraPac::TimePacket::getGmt()

Return the GMT in UNIX epoch time expression.

The returned value is the same unit as time_t, but support millisec
resolution as double. ";


// File: classTimePacket__test.xml
%feature("docstring") TimePacket_test "";

%feature("docstring")  TimePacket_test::CPPUNIT_TEST_SUITE "TimePacket_test::CPPUNIT_TEST_SUITE(TimePacket_test) ";

%feature("docstring")  TimePacket_test::CPPUNIT_TEST "TimePacket_test::CPPUNIT_TEST(testTest) ";

%feature("docstring")  TimePacket_test::CPPUNIT_TEST "TimePacket_test::CPPUNIT_TEST(testConversion) ";

%feature("docstring")  TimePacket_test::CPPUNIT_TEST "TimePacket_test::CPPUNIT_TEST(testString) ";

%feature("docstring")  TimePacket_test::CPPUNIT_TEST_SUITE_END "TimePacket_test::CPPUNIT_TEST_SUITE_END() ";

%feature("docstring")  TimePacket_test::getSample "uint8_t*
TimePacket_test::getSample() ";

%feature("docstring")  TimePacket_test::testTest "void
TimePacket_test::testTest() ";

%feature("docstring")  TimePacket_test::testConversion "void
TimePacket_test::testConversion() ";

%feature("docstring")  TimePacket_test::testString "void
TimePacket_test::testString() ";


// File: namespaceIrfPac.xml
%feature("docstring")  IrfPac::Encode::byteSpectrum "uint16_t *
IrfPac::byteSpectrum(uint8_t *stream, size_t number_of_stream)

Returns the spectrum of the byte array.

Returns pointer to 256-elements array. Each array corresponds to the
number how often the index appeared in the stream.

The returned pointer should be deleted.

For example, the byte array 0x00010002 returns the 256-elements array
which constitute of {2,1,1,0,0,0,.....}. This function is intended to
use the shape of the bytestream is similar or not. It is also useful
for feeling the compression is effective or not. Normally if the
compression is effective, the spectrum approaches flat. ";


// File: namespaceIrfPac_1_1Encode.xml


// File: namespaceIrfPac_1_1SaraPac.xml
%feature("docstring")  IrfPac::SaraPac::AscFmt::getWordAt "uint16_t
IrfPac::SaraPac::getWordAt(GeneralPacket &pac, size_t pos)

Returns the contents of specified word.

Word for SARA DPU is 2 byte starting from 1. Note that this function
is discouraged to be used inside the for-loop because it is too slow
in this version. (While no other methods are implemented:-(.) ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::getByteAt "uint8_t
IrfPac::SaraPac::getByteAt(GeneralPacket &pac, size_t pos)

Returns the contents of specified byte.

Byte for SARA DPU is 1 byte starting from 0. This definition is
natural for C/C++. Note that this function is discouraged to be used
inside the for-loop because it is too slow in this version.

See:   GeneralPacket::getStream()

PacketIntArr::getValue(size_t) ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::obt2msec "double
IrfPac::SaraPac::obt2msec(uint64_t obt)

A function to convert OBT (so-called 1750 format) to float value (unit
in msec). ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::convert_utc2epoch "double IrfPac::SaraPac::convert_utc2epoch(int yr, int mo, int dy, int
hr, int mn, int sec, int msec)

A utility of converting specified time from UTC to UNIX epoch time.

The returned value is the same unit as time_t, but support millisec
resolution as double.

Todo Maybe move to another library in future ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::epoch2str "std::string IrfPac::SaraPac::epoch2str(double utctime)

Return the epoch time string.

The returned value has the format \"2009-06-23T23:25:31.947Z\" ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::epoch2iso8601str "std::string IrfPac::SaraPac::epoch2iso8601str(double utctime)

Return the epoch time string in xmgrace compatible format.

The returned value has the format \"2009-06-23T23:25:31.947\" ";

%feature("docstring")  IrfPac::SaraPac::AscFmt::iso8601str2epoch "double IrfPac::SaraPac::iso8601str2epoch(std::string isotime)

Return the unix epoch time of the string isotime.

The parameter isotime has the format \"2009-06-23T23:25:31.947. An
invalid string creates an exception\" ";


// File: namespaceIrfPac_1_1SaraPac_1_1AscFmt.xml


// File: namespacestd.xml


// File: AllTestIrfPac_8cpp.xml
%feature("docstring")  main "int main(int argc, char *argv[])

Main routine of the test. ";


// File: ByteSpectrum_8cpp.xml


// File: ByteSpectrum_8h.xml


// File: ByteSpectrum__test_8cpp.xml
%feature("docstring")  std::CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(ByteSpectrum_test) ";


// File: BitBuffer_8h.xml


// File: BitBuffer__sample_8cpp.xml
%feature("docstring")  main "int main(void) ";


// File: encode_8h.xml


// File: generalpacket_8cpp.xml


// File: generalpacket_8h.xml


// File: irfpac_8h.xml


// File: packetbytearr_8cpp.xml


// File: packetbytearr_8h.xml


// File: packetbytearr__sample_8cpp.xml
%feature("docstring")  main "int main(void) ";


// File: PacketByteArr__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(PacketByteArrTest) ";


// File: packetint32arr_8cpp.xml


// File: packetint32arr_8h.xml


// File: PacketInt32Arr__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(PacketInt32Arr_test) ";


// File: PacketIntArr_8cpp.xml


// File: PacketIntArr_8h.xml


// File: PacketIntArr__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(PacketIntArr_test) ";


// File: AllTestSaraPac_8cpp.xml
%feature("docstring")  main "int main(int argc, char *argv[])

Main routine of the test. ";


// File: AllTestAscFmt_8cpp.xml
%feature("docstring")  main "int main(int argc, char *argv[])

Main routine of the test. ";


// File: ascfmt_8h.xml


// File: AscFmtReader__sample_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";


// File: AscFmtReader__sample_8h.xml


// File: CenaBmuReader_8h.xml


// File: CenaBmuReader__sample_8cpp.xml
%feature("docstring")  main "int main(int argc, char *argv[]) ";


// File: CenaBmuReader__sample2_8cpp.xml
%feature("docstring")  main "int main(int argc, char *argv[]) ";


// File: CenaPacketDump__sample_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";


// File: CenaTimeDumpApp_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";


// File: SaraAscFile_8cpp.xml


// File: SaraAscFile_8h.xml


// File: SaraBufferedDemultiplexor__sample_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";


// File: SaraBufferedDemultiplexor__sample2_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";


// File: SaraDemultiplex_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";

%feature("docstring")  swim_science_table "void
swim_science_table(char *dirname, SwimPacket *pac) ";


// File: SaraDemultiplexor__sample_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";


// File: SaraSimpleDemulApp_8cpp.xml
%feature("docstring")  utc2str "std::string utc2str(double utc) ";

%feature("docstring")  main "int main(int argc, char **argv) ";


// File: SaraSpacePac2Bmu_8cpp.xml


// File: SaraSpacePac2Bmu_8h.xml


// File: SaraSpacePac2Bmu__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SaraSpacePac2Bmu_test) ";


// File: SaraSpacePac2BmuApp_8cpp.xml
%feature("docstring")  main "int main(void) ";


// File: SaraSyncCheckApp_8cpp.xml
%feature("docstring")  showCena "void showCena(CenaPacket *cena) ";

%feature("docstring")  showSwim "void showSwim(SwimPacket *swim) ";

%feature("docstring")  main "int main(int argc, char **argv) ";


// File: SwimBmuReader_8h.xml


// File: SwimBmuReader__sample_8cpp.xml
%feature("docstring")  main "int main(int argc, char *argv[]) ";


// File: TimeFile_8h.xml


// File: TimeFile__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(TimeFile_test) ";


// File: TimeFileDumpApp_8cpp.xml
%feature("docstring")  main "int main(int argc, char **argv) ";


// File: TimeSync__sample_8cpp.xml
%feature("docstring")  tostr "std::string tostr(double msec) ";

%feature("docstring")  main "int main(int argc, char **argv) ";


// File: CenaAccumSclMatx_8cpp.xml


// File: CenaAccumSclMatx_8h.xml


// File: CenaAccumSclMatx__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaAccumSclMatx_test) ";


// File: CenaCompressedPacketSample_8h.xml


// File: CenaFastHkPacket_8cpp.xml


// File: CenaFastHkPacket_8h.xml


// File: CenaFastHkPacket__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaFastHkPacket_test) ";


// File: CenaMatrix_8cpp.xml


// File: CenaMatrix_8h.xml


// File: CenaMatrix__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaMatrix_test) ";


// File: CenaPacket_8cpp.xml


// File: CenaPacket_8h.xml


// File: CenaPacket__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaPacket_test) ";


// File: CenaSciCntrAcc_8cpp.xml


// File: CenaSciCntrAcc_8h.xml


// File: CenaSciCntrAcc__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaSciCntrAcc_test) ";


// File: CenaScienceDataPacket_8cpp.xml


// File: CenaScienceDataPacket_8h.xml


// File: CenaSciencePackage_8h.xml


// File: CenaSciMassAcc_8cpp.xml


// File: CenaSciMassAcc_8h.xml


// File: CenaSciMassAcc__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaSciMassAcc_test) ";


// File: CenaSciTofAcc_8cpp.xml


// File: CenaSciTofAcc_8h.xml


// File: CenaSciTofAcc__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaSciTofAcc_test) ";


// File: CenaSubcHkPac_8cpp.xml


// File: CenaSubcHkPac_8h.xml


// File: CenaSubcHkPac__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(CenaSubcHkPac_test) ";


// File: linlog__sample_8cpp.xml
%feature("docstring")  main "int main(void) ";


// File: linlog__sample_8h.xml


// File: SaraBufferedDemultiplexor_8cpp.xml


// File: SaraBufferedDemultiplexor_8h.xml


// File: SaraDemultiplexor_8cpp.xml


// File: SaraDemultiplexor_8h.xml


// File: SaraDemultiplexor__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SaraDemultiplexor_test) ";


// File: SaraHkConversion_8cpp.xml


// File: SaraHkConversion_8h.xml


// File: SaraHkConversion__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SaraHkConversion_test) ";


// File: SaraHkConversionGrndCal_8cpp.xml


// File: SaraHkConversionGrndCal_8h.xml


// File: SaraHkConversionGrndCal__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SaraHkConversionGrndCal_test) ";


// File: sarapac_8h.xml


// File: SaraPacket_8cpp.xml


// File: SaraPacket_8h.xml


// File: SaraPacket__sample_8cpp.xml
%feature("docstring")  main "int main(void) ";


// File: SaraPacket__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SaraPacket_test) ";


// File: SwimAccumTotMatx_8cpp.xml


// File: SwimAccumTotMatx_8h.xml


// File: SwimAccumTotMatx__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SwimAccumTotMatx_test) ";


// File: SwimFastHkPacket_8cpp.xml


// File: SwimFastHkPacket_8h.xml


// File: SwimMatrix_8cpp.xml


// File: SwimMatrix_8h.xml


// File: SwimPacket_8cpp.xml


// File: SwimPacket_8h.xml


// File: SwimPacket__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SwimPacket_test) ";


// File: SwimRawModeData_8cpp.xml


// File: SwimRawModeData_8h.xml


// File: SwimSciAcc_8cpp.xml


// File: SwimSciAcc_8h.xml


// File: SwimSciAcc__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(SwimSciAcc_test) ";


// File: SwimScienceDataPacket_8cpp.xml


// File: SwimScienceDataPacket_8h.xml


// File: SwimSciencePackage_8h.xml


// File: SwimSubcHkPacket_8cpp.xml


// File: SwimSubcHkPacket_8h.xml


// File: TimeConversion_8h.xml


// File: TimeConversion__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(TimeConversion_test) ";


// File: TimePacket_8cpp.xml
%feature("docstring")  mkgmtime "time_t mkgmtime(register struct tm
*t) ";


// File: TimePacket_8h.xml


// File: TimePacket__test_8cpp.xml
%feature("docstring")  CPPUNIT_TEST_SUITE_REGISTRATION "CPPUNIT_TEST_SUITE_REGISTRATION(TimePacket_test) ";


// File: project__description_8h.xml


// File: DemultiplexorSample.xml


// File: CenaMode.xml


// File: UniversalTimeSample.xml


// File: AnalysisSara.xml


// File: ConversionPacketFormat.xml


// File: todo.xml


// File: deprecated.xml


// File: bug.xml


// File: dir_becfd9a0d2219f64df37cae0b6e9f396.xml


// File: dir_baa117ef5f756849c114b8ec1f49d994.xml


// File: dir_66d897bd079c7a2c15d63f34fefc92ed.xml


// File: dir_eb36f48131c2505bd57384ea784481f6.xml


// File: indexpage.xml

